<?php

/**
 * info actions.
 *
 * @package    sam3
 * @subpackage info_stat
 * @author     Alfred Broda
 * @version    SVN: $Id: actions.class.php 9301 2008-05-27 01:08:46Z dwhittle $
 */
class igaleria_statActions extends myActions {

    public function preExecute() {
        if ( ! in_array('gali', ModulPeer::getEnabled()))
        {
            $this->forwardSecure();
        }
    }

    /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    public function executeIndex(sfWebRequest $request) {
        $user = $this->getUser();
        $c = GaleriaIPubPeer::buildCurrentCriteria();
        if (!($user->hasCredential('config') || ($user->checkPermission('gali_global','edit')==1))) {
            $c->add(GaleriaIPubPeer::UZYTKOWNIK_ID,$user->getId());
        }
        $c->setDistinct();
        //$c->add(IobiektTblPeer::STATUS,1);
        $c->addJoin(GaleriaIPubPeer::ID,GiRankPeer::GALERIA_ID);
        //$c->addDescendingOrderByColumn(GiRankPeer::VIEWS);
        //$c->addDescendingOrderByColumn(GiRankPeer::UPDATED_AT);

        $this->addSortCriteria($c);

        $cstat = new Criteria();
        $cstat->clearSelectColumns();
        $cstat->addSelectColumn('SUM('.GiRankPeer::VIEWS.')');
        $result_set = GRankPeer::doSelectStmt($cstat);
        $views = $result_set->fetchColumn(0);

        $cstat = new Criteria();
        $cstat->clearSelectColumns();
        $cstat->addSelectColumn('SUM('.GiStatPeer::WEJSC.')');
        $result_set = GStatPeer::doSelectStmt($cstat);
        $wejsc = $result_set->fetchColumn(0);

        $this->all = $views + $wejsc;
        $this->max = $this->all;

        $pager = new sfPropelPager('GaleriaIPub',15);
        $pager->setCriteria($c);
        //$pager->setPeerMethod('');

        if ($request->hasParameter('page') && is_numeric($request->getParameter('page'))) {
            $page = $request->getParameter('page');
            $this->getUser()->setAttribute('gali/index/page',$page);
        }
        else {
            $page = $this->getUser()->getAttribute('gali/index/page',1);
        }
        $pager->setPage($page);
        $pager->init();
        $this->pager = $pager;
    }

    protected function addSortCriteria($c) {
        $this->processSort();
        $sort_column = $this->getUser()->getAttribute('sort', null, 'sf_admin/igaleria_stat/sort');
        if ($sort_column) {
            // camelize lower case to be able to compare with BasePeer::TYPE_PHPNAME translate field name
            $sort_column = GiRankPeer::translateFieldName(sfInflector::camelize(strtolower($sort_column)), BasePeer::TYPE_PHPNAME, BasePeer::TYPE_COLNAME);
            if ($this->getUser()->getAttribute('type', null, 'sf_admin/igaleria_stat/sort') == 'asc') {
                $c->addAscendingOrderByColumn($sort_column);
            }
            else {
                $c->addDescendingOrderByColumn($sort_column);
            }
        }
    }

    protected function addFiltersCriteria($c) {
        foreach ($this->filters as $field =>$filter) {
            //$c->add(GaleriaPeer::DATABASE_NAME."$field","%$filter%",Criteria::LIKE);
        }
    }

    protected function processSort() {
        if ($this->getRequestParameter('sort')) {
            $this->getUser()->setAttribute('sort', $this->getRequestParameter('sort'), 'sf_admin/igaleria_stat/sort');
            $this->getUser()->setAttribute('type', $this->getRequestParameter('type', 'asc'), 'sf_admin/igaleria_stat/sort');
        }

        if (!$this->getUser()->getAttribute('sort', null, 'sf_admin/igaleria_stat/sort')) {
        }
    }

    public function executeDetails(sfWebRequest $request) {
        if ($request->hasParameter('id') && is_numeric($request->getParameter('id'))) {
            $id = $request->getParameter('id');
            $object = GaleriaIPubPeer::retrieveByPK($id);
            $this->title = $object->getTytul();
            $object->increaseViews(0);

            $c = new Criteria();
            $c->addDescendingOrderByColumn(GiStatPeer::ROK);
            $c->addDescendingOrderByColumn(GiStatPeer::MIESIAC);
            $this->stats = $object->getGiStats($c);

            $this->rank = $object->getGiRank();

            $c = new Criteria();
            $c->add(GiStatPeer::GALERIA_ID,$id);
            $c->addSelectColumn('SUM('.GiStatPeer::WEJSC.')');
            $allviews = GiStatPeer::doSelectStmt($c);
            $this->max = $allviews->fetchColumn(0)+$object->getViews();
        }
    }
}
