<?php

/**
 * igobraz actions.
 *
 * @package    sam3
 * @subpackage galerie
 * @author     Alfred Broda
 * @version    SVN: $Id: actions.class.php  alfred $
 */
class igobrazActions extends sfActions {

    /**
     * Enter description here...
     *
     * @param sfWebRequest $request
     */
    public function executeEdit(sfWebRequest $request) {
        $user = $this->getUser();
        $this->referer = $user->getAttribute('referer', $request->getUri());
        $this->message = '';
        if ($request->getParameter('postsave', null) == 'true') {
            $this->message = "Zapis przebiegł pomyślnie.";
        }

        $object = null;
        if ($request->getParameter('obraz')) {
            $obraz = $request->getParameter('obraz');
            $id = $obraz['id'];
            $object = GiObrazPeer::retrieveByPK($id);
        } else {
            $id = $request->getParameter('id');
            $object = GiObrazPeer::retrieveByPK($id);
            if (!$request->isMethod('post')) {
                $before = $object;
            }
        }

        if (!$object) {
            $object = new GiObraz();
            $gid = $request->getParameter('gid');
            if (!$gid)
                $gid = $this->getUser()->getAttribute('gali_id');
            $object->setGaleriaId($gid);
        } else {
            $gid = $object->getGaleriaId();
        }

        $this->gid = $gid;
        $this->getUser()->setAttribute('gali_id', $gid);

        if (!$object->isNew()) {
            $this->getUser()->setAttribute('old_file', "/uploads/temp/gali/gal_$gid/thumb_" . $object->getNazwaPliku());
            $this->getUser()->setAttribute('old_file_max', "/uploads/temp/gali/gal_$gid/" . $object->getNazwaPliku());
        } else {
            $this->getUser()->setAttribute('old_file', null);
            $this->getUser()->setAttribute('old_file_max', null);
        }

        // Uprawnienia
        $user = $this->getUser();
        if (!($object->getGaleriaI()->checkPermission($user, 'edit') == 1 || $this->getUser()->checkPermission('gali_global', 'edit') == 1)) {
            $this->forward(sfConfig::get('sf_secure_module'), sfConfig::get('sf_secure_action'));
        }
        $this->form = new GiObrazForm($object);

        $this->errors = array();

        if ($request->hasParameter('publish')) {
            if ($this->form->getObject()->getGaleriaI()->checkPermission($user, 'publish') == 1) {
                $object->publish();
                $this->errors = $this->form->getErrorsNice();
                if (!count($this->errors)) {
                    $this->message = "Publikacja przebiegła pomyślnie.";
                } else {
                    $this->message = "Publikacja przerwana z powodu błędów.";
                }
                return 'Success';

            } else {
                $this->message = "Publikacja przerwana z powodu błędów.";
                $this->errors['Publikacja'] = "Brak uprawnień!";
                return 'Success';
            }
        }

        if ($request->isMethod('post')) {
            $obraz = $request->getParameter('obraz');

            $files = $this->getUser()->getAttribute('gali_new');
            $files = $files[$gid];
            if ($files) {
                foreach ($files as $name => $file) {
                    $obraz['nazwa_pliku'] = $name;
                }
            }
            $obraz = array_merge($object->toArray(BasePeer::TYPE_FIELDNAME), $obraz);
            $cultures = JezykTblPeer::getCulturesForModul('gali');
            
            if ($object->isNew() && isset($obraz['title']) && $obraz['title']) {
                foreach ($cultures as $cult) {
                    if (!$obraz[$cult]['nazwa']) {
                        $obraz[$cult]['nazwa'] = $obraz['title'];
                    }
                }
            }

            $this->form->bind($obraz);
            if (!$this->form->isValid()) {
                $this->errors = $this->form->getErrorsNice();
                $this->message = "Błąd w formularzu!";
            } else {
                try {
                    $isNew = $this->form->getObject()->isNew();
                    $this->form->save();
                    $this->message = "Zapis przebiegł pomyślnie.";
                    $save_ok = true;
                } catch (PropelException $e) {
                    $this->errors[] = $e->getMessage();
                    $this->message = "Błąd podczas zapisu.";
                }
                if ($files) {
                    $directory = sfConfig::get('sf_upload_dir') . "/temp/gali/gal_".$gid;
                    if (!is_dir($directory)) {
                        mkdir($directory, 0775, true);
                    }

                    foreach ($files as $name => $file) {
                        rename($file, $directory."/".$name);
                    }
                    $object = $this->form->getObject();
                    $this->getUser()->setAttribute('old_file', "/uploads/temp/gali/gal_".$gid."/thumb_" . $object->getNazwaPliku());
                    $this->getUser()->setAttribute('old_file_max', "/uploads/temp/gali/gal_".$gid."/" . $object->getNazwaPliku());
                    $this->getUser()->setAttribute('gali_new', null);
                }
            }
            if (isset($save_ok)) {
                $this->redirect('igobraz/edit?id=' . $this->form->getObject()->getId() . '&postsave=true');
            }
        }
    }

    public function executeSave(sfWebRequest $request) {
        $this->forward('igobraz', 'edit');
    }

    public function executeDelete(sfWebRequest $request) {
        $id = $request->getParameter('id');
        $this->text = "Brak parametrów";
        if ($id) {
            try {
                $obraz = GiObrazPeer::retrieveByPK($id);
                if ($obraz) {
                    $obraz->delete();
                    $this->text = "Obiekt usunięty pomyślnie.";
                }
            } catch (PropelException $e) {
                $this->text = $e->getMessage();
            }
        }
        $this->setTemplate('message');
    }

    public function executeCreate(sfWebRequest $request) {
        $this->forward('igobraz', 'edit');
    }

    public function executeList(sfWebRequest $request) {
        $this->forward('igobraz', 'edit');
    }

    public function executeUpload(sfWebRequest $request) {
        sfConfig::set('sf_web_debug', false);
        $gid = $this->getUser()->getAttribute('gali_id');
        $base_dir = sfConfig::get('sf_upload_dir')."/temp/gali/gal_$gid/";
        $directory = $base_dir;

        // Plik do wyświetlenia
        $this->oldfile = $this->getUser()->getAttribute('old_file', 'dummy_preview.jpg');
        $this->oldfile_max = $this->getUser()->getAttribute('old_file_max');

        // Kasujemy świeżo wysłane a nie zapisane pliki z temp
        if ($this->getUser()->getAttribute('gali_new')) {
            $thumbnails_dalete = array(
                'mini_',
                'thumb_',
                'normal_',
            );
            foreach ($this->getUser()->getAttribute('gali_new') as $gal) {
                foreach ($gal as $img) {
                    if (is_file($directory.$img)) {
                        foreach ($thumbnails_dalete as $key):
                            @unlink($directory.$key.$img);
                        endforeach;
                        @unlink($directory.$img);
                    }
                }
            }
            $this->getUser()->setAttribute('galp_new', null);
        }

        $this->form = new UploadFileForm();
        if ($request->isMethod('post')) {
            $data = $request->getFiles('Filedata');

            $validators = $this->form->getValidatorSchema();
            $validators['data'] = new ciValidatorFile(array('mime_types' => 'baner_images'));
            $this->form->setValidatorSchema($validators);

            $this->form->bind(array('data' => $data['name']), array('data' => $data));
            if (!$this->form->isValid()) {
                $this->error = $this->form->getErrorsNice();
            } else {
                $file = $this->form->getValue('data');

                $mime = $file->getType();
                $filename = $file->generateFilename();
                $tmpfile = $file->getTempName();
                
                
                if (!is_dir($directory))
                    mkdir($directory, 0775, true);

                $file->save($directory.$filename);
                
                // generowanie miniaturek
                Functions::wygenerujMiniaturkiPrzyUploadzie($directory,  $filename, $directory, array('mini', 'thumb', 'normal', 'max'), 'gali_config_');
                
                $this->filepath = "/uploads/temp/gali/gal_$gid/$filename";
                $this->minifile = "/uploads/temp/gali/gal_$gid/mini_$filename";
                $this->thumbfile = "/uploads/temp/gali/gal_$gid/thumb_$filename";
                $this->normalfile = "/uploads/temp/gali/gal_$gid/normal_$filename";

                $new[$gid][$filename] = $filename;
                $this->getUser()->setAttribute('gali_new', $new);
            }
        }
    }

    public function executeMove(sfWebRequest $request) {
        $this->messages = null;
        $this->errors = array();
        if ($request->hasParameter('id')) {
            $obj = GiObrazPeer::retrieveByPK($request->getParameter('id'));
            if ($obj) {
                switch ($request->getParameter('move')) {
                    case 'up':
                        $obj->moveUp();
                        $this->messages = "Obraz <b>" . $obj->getTytul() . "</b> przeniesiony w górę prawidłowo.";
                        break;
                    case 'down':
                        $obj->moveDown();
                        $this->messages = "Obraz <b>" . $obj->getTytul() . "</b> przeniesiony w dół prawidłowo.";
                        break;
                    default:
                        $this->messages = null;
                        $obj = null;
                }
                if (!$this->messages)
                    $this->errors[] = "Błąd przy zmianie kolejności obiektu <b>" . $obj->getTytul() . "</b>";
            }
            else {
                if (!$this->messages)
                    $this->messages = "Błedne ID obiektu lub zmiana jest nieokreślona";
            }
        }
        else {
            $this->errors[] = "Nieokreślone ID obiektu";
        }
    }

    public function executeMessage(sfWebRequest $request) {
        $this->text = 'OK';
    }

    public function executeThumbnailSave(sfWebRequest $request) {
        if (!$request->isMethod('post')) {
            $this->redirect('igaleria/index');
        }

        $nazwa = $_GET['filename'];
        $size = $request->getParameter('size');
        $repl = sfConfig::get('sf_upload_dir');

        $preg_pattern = "/(.*)uploads/";
        $filename = preg_replace($preg_pattern, $repl, $nazwa);

        $id = null;
        if (preg_match('#gal_([0-9]+)#', $filename, $matches) && isset($matches[1])) {
            $id = array_pop($matches);
        }


        $thumb = str_replace('orginal_', $size . '_', $filename);

        $t_file = fopen($thumb, 'wb');
        fwrite($t_file, $GLOBALS["HTTP_RAW_POST_DATA"]);
        fclose($t_file);

        $watermark_config = UstawieniePeer::getProperties('graf_config_watermark');
        if (isset($watermark_config['show']) && $watermark_config['show'] == 1) {
            //znak wodny
            $margin = $watermark_config['margin'];
            $pos = $watermark_config['pos'];
            $watermark_src = sfConfig::get('sf_upload_dir') . "/" . $watermark_config['file'];
            UploadFileForm::addWatermark($thumb, $watermark_src, null, $pos, $margin);
        }

        if ($id) {
            $this->redirect('igaleria/edit?id=' . $id);
        } else {
            $this->redirect('igaleria/index');
        }
    }
}
