<?php

/**
 * igobraz actions.
 *
 * @package    sam3
 * @subpackage igalerie
 * @author     Alfred Broda
 * @version    SVN: $Id: actions.class.php  alfred $
 */
class igsubkategoriaActions extends autoigsubkategoriaActions {

    /**
     * Enter description here...
     *
     * @param sfWebRequest $request
     */
    public function executeEdit($request) {
        $this->message = '';
        if ($request->getParameter('postsave', null) == 'true') {
            $this->message = "Zapis przebiegł pomyślnie.";
        }
        $object = null;
        if ($request->getParameter('g_subkategoria')) {
            $id = $request->getParameter('g_subkategoria');
            $id = $id['id'];
            $object = GiSubkategoriaPeer::retrieveByPK($id);
        } else {
            $id = $request->getParameter('id');
            $object = GiSubkategoriaPeer::retrieveByPK($id);
        }

        if (!$object) {
            $object = new GiSubkategoria();
        }

        if ($request->getParameter('gkid')) {
            $gkid = $request->getParameter('gkid');
        }

        $isnew = $object->isNew();
        $this->form = new GiSubkategoriaForm($object);

        $this->errors = array();
        if ($request->isMethod('post')) {
            $obraz = $request->getParameter('g_subkategoria');
            $this->form->bind($obraz);
            if (!$this->form->isValid()) {
                $this->message = "Formularz zawiera błędy.";
                $shema = $this->form->getErrorsNice();
                $this->errors = $shema;
            } else {
                try {
                    $this->form->save();
                    $this->id = $this->form->getObject()->getId();
                    $this->redirect('igsubkategoria/edit?id=' . $this->id . '&postsave=true');
                } catch (PropelException $e) {
                    $this->errors[] = $e->getMessage();
                    $this->message = "Wystąpiły błędy podczs zapisu.";
                }
            }
        } else if ($isnew) {
            $this->form->setDefault('kategoria_id', $gkid);
        }
    }

    public function executeSave($request) {
        $this->forward('igsubkategoria', 'edit');
    }

    public function executeDelete($request) {
        $id = $request->getParameter('id');
        if ($id) {
            try {
                GiSubkategoriaPeer::retrieveByPK($id)->delete();
            } catch (PropelException $e) {
                $this->text = $e->getMessage();
            }
            if (!isset($this->text))
                $this->text = "Subkategoria usunięta pomyślnie.";
        }
    }

    public function executeCreate($request) {
        $this->forward('igsubkategoria', 'edit');
    }

    public function executeMove(sfWebRequest $request) {
        $this->messages = null;
        $this->errors = array();
        if ($request->hasParameter('id')) {
            $obj = GiSubkategoriaPeer::retrieveByPK($request->getParameter('id'));
            if ($obj) {
                switch ($request->getParameter('move')) {
                    case 'up':
                        $obj->moveUp();
                        $this->messages = "Subkategoria <b>" . $obj->getNazwa() . "</b> przeniesiona w górę prawidłowo.";
                        break;
                    case 'down':
                        $obj->moveDown();
                        $this->messages = "Subkategoria <b>" . $obj->getNazwa() . "</b> przeniesiona w dół prawidłowo.";
                        break;
                    default:
                        $this->messages = null;
                        $obj = null;
                }
                if (!$this->messages) {
                    $this->errors[] = "Błąd przy zmianie kolejności obiektu <b>" . $obj->getNazwa() . "</b>";
                }
            } else {
                if (!$this->messages) {
                    $this->messages = "Błedne ID obiektu lub zmiana jest nieokreślona";
                }
            }
        } else {
            $this->errors[] = "Nieokreślone ID obiektu";
        }
    }

}
