<?php

/**
 * ikategoria actions.
 *
 * @package    sam3
 * @subpackage ikategoria
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 2288 2006-10-02 15:22:13Z fabien $
 */
class igaleriaActions extends sfActions
{

    public function preExecute()
    {
        if(!in_array('gali', ModulPeer::getEnabled()))
        {
            $this->redirect('@homepage');
        }
        $culture = $this->getUser()->getCulture();
        $response = $this->getResponse();
        Functions::setAllMetasFromDb('gali', $response, $culture);
    }

    protected function setTitle($title)
    {
        $response = $this->getResponse();
        $response->setTitle($title);
    }

    public function executeIndex(sfWebRequest $request)
    {
        $this->comp_id = 'gali_index';
        $this->view_mode = $request->getCookie('view_mode_'.$this->comp_id, sfConfig::get('app_view_mode'));

        $this->getUser()->setAttribute('selectMenu', 'All', 'menu');

        if($request->hasParameter('sort'))
        {
            $sort = $request->getParameter('sort');
        }
        else
        {
            $sort = '';
        }

        $c_galeries = GaleriaIPubPeer::buildCurrentCriteria();

        switch ($sort)
        {
            case 'rank':
                $c_galeries->addJoin(GaleriaIPubPeer::ID, GiRankPeer::GALERIA_ID);
                $c_galeries->addDescendingOrderByColumn(GiRankPeer::VIEWS);
                break;

            case 'date':
            default:
                $c_galeries->addDescendingOrderByColumn(GaleriaIPubPeer::CREATED_AT);
                break;
        }

        $pager = new sfPropelPager('GaleriaIPub', sfConfig::get('app_pages'));
        $pager->setPeerMethod('doSelectJoinAll');
        $pager->setCriteria($c_galeries);
        $pager->setPage($this->getRequestParameter('page', 1));
        $pager->init();
        $this->pager = $pager;
    }

    public function executeShow(sfWebRequest $request)
    {

        if($request->getParameter('id'))
        {
            $gid = $request->getParameter('id');
            $crit = new Criteria();
            $crit->add(GaleriaIPubPeer::ID, $gid);
            $crit->addJoin(GaleriaIPubPeer::ID, GiObrazPubPeer::GALERIA_ID, Criteria::LEFT_JOIN);
            $crit->addAscendingOrderByColumn(GiObrazPubPeer::KOLEJNOSC);
            $galeria = GaleriaIPubPeer::doSelectWithI18n($crit);
            $galeria = $galeria[0];
        }
        if(!isset($galeria))
        {
            $this->redirect('@gali_list');
        }
        else
        {
            // Aktualizujemy statystykę
            $user = $this->getUser();
            if(!in_array($gid, $user->getAttribute('visited', array(), 'gali')))
            {
                $visited = $user->getAttribute('visited', array(), 'gali');
                $visited[$gid] = true;
                $user->getAttribute('visited', $visited, 'gali');
                $galeria->increaseViews();
            }

            $this->vote = $request->getCookie("vote_$gid", true);
            Functions::setMetaTitle($this->getResponse(), $galeria->getTytul());
            Functions::setMetaDescription($this->getResponse(), $galeria->getTytul());
            $this->galeria = $galeria;
            // tomek-edit:
            $this->temat = GiSubkategoriaPeer::retrieveByPK($galeria->getSubkategoriaId());
            $this->kategoria = GiKategoriaPeer::retrieveByPK($this->temat->getKategoriaId());
            // end-edit
            $crit = new Criteria();
            $crit->addAscendingOrderByColumn(GiObrazPubPeer::KOLEJNOSC);
            $this->obrazy = $galeria->getGiObrazPubs($crit);

            $lang = $this->getUser()->getCulture();
            $slides = array();
            foreach($this->obrazy as $obrazek)
            {
                $slides[$obrazek->getThumbLink()] = array
                    (
                    'image' => $obrazek->getOrigLink(),
                    'title' => $obrazek->getNazwa($lang),
                    'alt' => $obrazek->getOpis($lang),
                    'id' => $obrazek->getId(),
                );
            }
            $this->slides = $slides;
            $galp_def = array(
                'mini' => sfConfig::get('app_size_mini'),
                'thumb' => sfConfig::get('app_size_thumb'),
                'normal' => sfConfig::get('app_size_normal'),
                'max' => sfConfig::get('app_size_max'),
                'background_color' => '#333333',
                'border_color' => '#FFFFFF',
            );
            $this->gconf = array_merge($galp_def, UstawieniePeer::getProperties('gali_config'));
        }

        $this->preview = false;
    }

    public function executePreview(sfWebRequest $request)
    {
        $user = $this->getUser();

        if($request->hasParameter('pid') && is_numeric($request->getParameter('pid')))
        {
            $gid = $request->getParameter('pid');
            $crit = new Criteria();
            $crit->add(GaleriaIPeer::ID, $gid);
            $crit->addAscendingOrderByColumn(GaleriaIPeer::KOLEJNOSC);
            $galeria = GaleriaIPeer::doSelectJoinAll($crit);
            $galeria = $galeria[0];
        }
        if(!isset($galeria))
        { //|| !$user->isAuthenticated()
            $this->redirect404();
        }
        else
        {

            Functions::setMetaTitle($this->getResponse(), $galeria->getTytul());
            Functions::setMetaDescription($this->getResponse(), $galeria->getTytul());

            $this->galeria = $galeria;
            // tomek-edit:
            $this->temat = GiSubkategoriaPeer::retrieveByPK($galeria->getSubkategoriaId());
            $this->kategoria = GiKategoriaPeer::retrieveByPK($this->temat->getKategoriaId());
            // end-edit
            $crit = new Criteria();
            $crit->addAscendingOrderByColumn(GiObrazPeer::KOLEJNOSC);
            $this->obrazy = $galeria->getGiObrazs($crit);
            $lang = $this->getUser()->getCulture();
            $slides = array();
            foreach($this->obrazy as $obrazek)
            {
                $slides[$obrazek->getThumbLink()] = array
                    (
                    'image' => $obrazek->getOrigLink(),
                    'title' => strip_tags($obrazek->getOpis($lang)),
                    'alt' => strip_tags($obrazek->getOpis($lang)),
                    'id' => $obrazek->getId($lang),
                    'opis' => $obrazek->getOpis($lang),
                );
            }
            $this->slides = $slides;
            $gali_def = array
                (
                'mini' => sfConfig::get('app_size_mini'),
                'thumb' => sfConfig::get('app_size_thumb'),
                'normal' => sfConfig::get('app_size_normal'),
                'max' => sfConfig::get('app_size_max'),
                'background_color' => '#333333',
                'border_color' => '#FFFFFF',
            );
            $this->gconf = array_merge($gali_def, UstawieniePeer::getProperties('gali_config'));

            // Powiazane linkuja do Pub?
            $this->links = array();
        }

        $this->preview = true;
        $this->setTemplate('show');
    }

    public function executeGetBigPhoto(sfWebRequest $request)
    {

        if($request->hasParameter('PN'))
            $this->PN = unserialize($request->getParameter('PN'));

        if($request->hasParameter('num'))
            $this->num = $request->getParameter('num');

        if($request->hasParameter('preview'))
            $this->preview = $request->getParameter('preview');

        if($request->hasParameter('id'))
        {
            $this->id = $request->getParameter('id');
            $this->obraz = GiObrazPeer::retrieveByPK($this->id);
            $this->galeria_id = $this->obraz->getGaleriaId();
            $this->upload_dir = sfContext::getInstance()->getRequest()->getRelativeUrlRoot().'/uploads/pub/gali/gal_'.$this->galeria_id.'/';
        }
        else if($request->hasParameter('pid'))
        {
            $this->id = $request->getParameter('pid');
            $this->obraz = GiObrazPeer::retrieveByPK($this->id);
            $this->galeria_id = $this->obraz->getGaleriaId();
            $this->upload_dir = sfContext::getInstance()->getRequest()->getRelativeUrlRoot().'/uploads/temp/gali/gal_'.$this->galeria_id.'/';
        }
        else
        {
            $this->forward404();
        }
        $this->normal_file = $this->obraz->getNormalFile();
        $this->orig_file = $this->obraz->getNazwaPliku();
    }

    public function executeVote(sfWebRequest $request)
    {
        $this->vote = false;
        if($request->hasParameter('id') && is_numeric($request->getParameter('id')))
        {
            $gid = $request->getParameter('id');
            $this->vote = $request->getCookie("vote_gali_$gid", true);

            $galeria = GaleriaIPubPeer::retrieveByPK($gid);
            if($galeria)
            {
                $user = $this->getUser();

                if($this->vote && $request->hasParameter('rank') && is_numeric($request->getParameter('rank')) && $request->getParameter('rank') <= 10)
                {
                    $galeria->addVote($request->getParameter('rank'));
                    $this->getResponse()->setCookie("vote_gali_$gid", true);
                    $this->vote = false;
                }
                $this->galeria = $galeria;
            }
        }
    }

    public function executeKategoria(sfWebRequest $request)
    {
        $this->comp_id = 'gali_kategoria';
        $this->view_mode = $request->getCookie('view_mode_'.$this->comp_id, sfConfig::get('app_view_mode'));

        $id = $request->getParameter('id');

        $this->kategoria = GiKategoriaPeer::retrieveByPK($id);

        $c_galeries = GaleriaIPubPeer::buildCurrentCriteria();

        $c_galeries->add(GiSubkategoriaPeer::KATEGORIA_ID, $id);
        $c_galeries->addJoin(GaleriaIPubPeer::SUBKATEGORIA_ID, GiSubkategoriaPeer::ID);
        $c_galeries->addDescendingOrderByColumn(GaleriaIPubPeer::CREATED_AT);


        if(isset($id) && $id != '')
        {
            $this->id = $id;
        }

        $pager = new sfPropelPager('GaleriaIPub', sfConfig::get('app_pages'));
        $pager->setPeerMethod('doSelectJoinAll');
        $pager->setCriteria($c_galeries);
        $pager->setPage($this->getRequestParameter('page', 1));
        $pager->init();
        $this->pager = $pager;
    }

    public function executeTemat(sfWebRequest $request)
    {
        $this->comp_id = 'gali_temat';
        $this->view_mode = $request->getCookie('view_mode_'.$this->comp_id, sfConfig::get('app_view_mode'));

        $id = $request->getParameter('id');

        $this->temat = GiSubkategoriaPeer::retrieveByPK($id);
        $this->kategoria = GiKategoriaPeer::retrieveByPK($this->temat->getKategoriaId());

        $c_galeries = GaleriaIPubPeer::buildCurrentCriteria();

        $c_galeries->add(GaleriaIPubPeer::SUBKATEGORIA_ID, $id);
        $c_galeries->addAscendingOrderByColumn(GaleriaIPubPeer::UPDATED_AT);

        if(isset($id) && $id != '')
        {
            $this->id = $id;
        }

        $pager = new sfPropelPager('GaleriaIPub', sfConfig::get('app_pages'));
        $pager->setPeerMethod('doSelectJoinAll');
        $pager->setCriteria($c_galeries);
        $pager->setPage($this->getRequestParameter('page', 1));
        $pager->init();
        $this->pager = $pager;
    }

    /* dodana obsługa dodawania galerii przez internautę */

    public function executeDodaj(sfWebRequest $request)
    {
        $this->forward('igaleria', 'regulamin');
    }

    public function executeRegulamin($request)
    {
        $this->def = UstawieniePeer::getProperties('gali_config');
    }

    public function executeDodano($request)
    {
        $this->def = UstawieniePeer::getProperties('gali_config');
    }

    public function executeNew(sfWebRequest $request)
    {
        $this->form = new IgaleriaForm();
    }

    public function executeCreate(sfWebRequest $request)
    {
        $this->form = new IgaleriaForm();
        $this->processForm($request, $this->form);
        $this->setTemplate('new');
    }

    public function executeEdit(sfWebRequest $request)
    {
        $this->forward404Unless($galeria = GaleriaIPeer::retrieveByPK($request->getParameter('id')), sprintf('Galeria nie istnieje (%s).', $request->getParameter('id')));
        $this->form = new IgaleriaForm($galeria);

        $directory = sfConfig::get('sf_upload_dir')."/temp/gali/gal_".$request->getParameter('id');
        if(!is_dir($directory)):
            mkdir($directory, 0775, true);
        endif;

        $criteria = new Criteria();
        $criteria->add(GiObrazPeer::GALERIA_ID, $request->getParameter('id'));
        $criteria->addAscendingOrderByColumn(GiObrazPeer::KOLEJNOSC);
        $obrazki = GiObrazPeer::doSelectWithI18n($criteria);

        $this->lista_obrazow = array();
        foreach($obrazki as $list)
        {
            $this->lista_obrazow[] = new GiObrazForm($list);
        }

        if($galeria->getObrazId())
        {
            $this->zajawka = $galeria->getObrazId();
        }
        else
        {
            $this->zajawka = -1;
        }
    }

    public function executeUpdate(sfWebRequest $request)
    {
        $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
        $this->forward404Unless($galeria = GaleriaIPeer::retrieveByPK($request->getParameter('id')), sprintf('Galeria nie istnieje (%s).', $request->getParameter('id')));

        $this->form = new IgaleriaForm($galeria);

        $this->processForm($request, $this->form);

        $this->redirect('@edycja_galerii?id='.$galeria->getId());
    }

    public function processForm(sfWebRequest $request, sfForm $form)
    {
        
        $params = $request->getParameter($form->getName());
        
        // kopiowanie wartosci z PL na inne wersje jezykowe
        $cloned_data = @$form->cloneRequiredI18nValues('gali', $params);

        $form->bind($params, $request->getFiles($form->getName()));

        if($form->isValid()):
            $galeria = $form->save();
            $galeria->setWidoczna(4);
            $galeria->save();
            $this->redirect('@edycja_galerii?id='.$galeria->getId());
        endif;
    }

    public function executeGetKategoriaRest(sfWebRequest $request)
    {
        $this->galeria = $request->getParameter('galeria');
        $this->sub = $request->getParameter('sub');
    }

    public function executeReloadPhotoList(sfWebRequest $request)
    {
        $this->setLayout(false);

        $this->galery_id = $request->getParameter('galery_id', null);

        if(!empty($this->galery_id))
            return $this->renderPartial('igaleria/jqueryUpload');
        else
            return sfView::NONE;
    }

}