<?php

class igaleriaComponents extends sfComponents {

    public function executeNajnowsze() {
				
        $c_galeries = new Criteria();
        $c_galeries->addDescendingOrderByColumn(GaleriaIPubPeer::CREATED_AT);      
		$c_galeries->setLimit($this->limit);
        $this->galerie = GaleriaIPubPeer::doSelectJoinAll($c_galeries);
              
        
        if (!isset($this->img_size)) {
            $this->img_size = sfConfig::get('app_panel_img_size');
        }
        
        $this->sizes = UstawieniePeer::getProperties('gali_config_'.$this->img_size);
        if (empty($this->galerie))
            return sfView::NONE;
   
    }

    /**
     * Komponent odpowiedzialny za wyswietlenie najnowszych galerii na stronie glownej
     */
    public function executePopularne() {
        $c_galeries = new Criteria();             
        $c_galeries->addJoin(GaleriaIPubPeer::ID, GiRankPeer::GALERIA_ID);
        $c_galeries->addDescendingOrderByColumn(GiRankPeer::VIEWS);
		$c_galeries->setLimit($this->limit);
        $this->galerie = GaleriaIPubPeer::doSelectJoinAll($c_galeries);
        
              
        if (!isset($this->img_size)) {
            $this->img_size = sfConfig::get('app_panel_img_size');
        }
        
        $this->sizes = UstawieniePeer::getProperties('gali_config_'.$this->img_size);
        if (empty($this->galerie))
            return sfView::NONE;
  
    }


    /**
     * komponent pozostalych galerii w tej samej kategorii co aktualnie wyswietlana
     * @param       sfWebRequest $request
     * @author      Tomasz Glowinski, 2012
     */
    public function executeKategoriarest(sfWebRequest $request)
    {
        if (isset($this->galeria))
            $kat_id = $this->galeria->getSubkategoriaId();
        
        if($request->hasParameter('page'))
            $page = $request->getParameter('page');
        else
            $page = 1;
        
        // galeria obecnie wyswietlana
        $gal_id = $request->getParameter('id');
        $this->gal = GaleriaIPubPeer::retrieveByPK($gal_id);
        
        // pager z lista pozostalych galerii w tej kategorii
        $pager = GaleriaIPubPeer::getCategoryRestGalleriesByGalleryId($gal_id);
        $pager->setPage($page);
        $pager->init();
        $this->pager = $pager;        
    }

    public function executeMenu(sfWebRequest $request) {
        $c = new Criteria();
        $c->addAscendingOrderByColumn(GiKategoriaPeer::KOLEJNOSC);
        $this->kategorie = GiKategoriaPeer::doSelect($c);
        
        $request = sfContext::getInstance()->getRequest();  
        $this->sel_kat_id = $request->getParameterHolder()->getAll();
        $this->sel_kat_id = $request->getParameter('id', null);
        
        if (empty($this->kategorie))
            return sfView::NONE;
    }
    
    public function executeDodawanie()
    {
        
    }
}

?>