<?php slot('custom_styles') ?>
<style type="text/css">
    #overlay
    {
        background-color: <?php echo $gconf['background_color'] ?> !important;
    }

    #outerImageContainer
    {
        background-color: <?php echo $gconf['border_color'] ?> !important;
        padding: <?php echo $gconf['padding'] ?>px !important;
    }

    #imageDataContainer
    {
        background-color: <?php echo $gconf['border_color'] ?> !important;
        padding: <?php echo $gconf['padding'] ?>px !important;
    }

    #imageDetails
    {
        color: <?php echo $gconf['font_color'] ?> !important;
    }
</style>
<?php
end_slot();
$img_size = 'thumb';

// wymiary grafik
if ($img_size)
    $sizes = UstawieniePeer::getProperties('galp_config_' . $img_size);
else
    $sizes = array('x' => 0, 'y' => 0);

$relroot = sfContext::getInstance()->getRequest()->getRelativeUrlRoot();
use_stylesheet('print_strona', 'last', array('media' => 'print'));

$path = array(
    __(ModulPeer::getFromShort('gali')->getNazwa()) => url_for('@gali_list'),
    $kategoria->getNazwa() => '@gali_kategoria?id=' . $kategoria->getId() . "&junk=" . Functions::slugify($kategoria->getNazwa()),
    $temat->getNazwa() => '@gali_temat?id=' . $temat->getId() . "&junk=" . Functions::slugify($temat->getNazwa()),
    $galeria->getTytul() => '@gali_opis?id=' . $galeria->getId() . "&junk=" . Functions::slugify($galeria->getTytul()));

$_SESSION['navigator_path'] = serialize($path);
?>


<article>
    <header>
        <h2 class="title"><?php echo $galeria->getTytul(); ?></h2>
    </header>

    <?php if (!empty($slides)): // W przypadku generowania podgladu bez zdjęć sypie błedami w logach:  ?>
        <div id="bigPhoto" style="height: 0; overflow: hidden; background: url('/images/wait.gif') no-repeat 50% <?php echo $sizes['y'] / 2; ?>px;"></div>
        <script>
            function justifyBigPhoto()
            {
                var bigphoto = jQuery("#bigPhoto");
                var wrapperH = jQuery("#wrapper").outerHeight(true);
                //alert(wrapperH);
                bigphoto.animate({
                    height: wrapperH + "px",
                    opacity: 1,
                }, 700);
                jQuery("#bigPhoto div").animate({
                    opacity: 1,
                }, 1500, adjustPanels);
            }
        </script>

        <div class="clr"></div>

        <section>
            <header class="belka">
                <h2 class="title"><span><?php echo __('Pozostałe w galerii'); ?></span></h2>
            </header>

            <div id="foto_box" class="gal_foto_box">
                <table role="presentation">
                    <tr>
                        <?php
                        $i = 0;
                        $PN = array();

                        foreach ($slides as $thumb => $obrazek):
                            $PN[$i++] = $obrazek['id'];
                        endforeach;

                        $i = 0;

                        foreach ($slides as $thumb => $obrazek):
                            if ($i == 0):
                                $id = $obrazek['id'];
                            endif;
                            ?>                            
                            <td class="foto_box">
                                <div class="grafika" onclick="
                                <?php
                                echo remote_function(array(
                                    'url' => url_for('igaleria/getBigPhoto?' . ($preview ? 'pid=' : 'id=') . $obrazek['id'] . '&PN=' . serialize($PN) . '&num=' . $i . ($preview ? '&preview=true' : '')),
                                    'update' => 'bigPhoto',
                                    'script' => true,
                                    'complete' => 'justifyBigPhoto();'
                                )) . ";go_num = $i;return false;"
                                ?>">
                                         <?php echo image_tag($thumb, array('alt' => $obrazek['alt'] ? htmlspecialchars($obrazek['alt']) : '', 'title' => htmlspecialchars($obrazek['title']))) ?>
                                </div>
                                <a style="display:none;" id="galeria_<?php echo $i ?>" href="<?php echo _compute_public_path($obrazek['image'], '/', 'png', true) ?>" class="fancybox" rel="lightbox" title="<?php echo $obrazek['title'] ?>"><?php echo image_tag($thumb, array('alt' => $obrazek['alt'] ? htmlspecialchars($obrazek['alt']) : htmlspecialchars($obrazek['title']), 'title' => htmlspecialchars($obrazek['title']))) ?></a>
                            </td>
                            <?php $i++; ?>
                        <?php endforeach; ?>
                    </tr>
                </table>
                <?php echo javascript_tag('                        
                    function collapseBigPhoto()
                    {
                      jQuery("#bigPhoto div").animate({
                            opacity: 0,
                        }, 1000);
                    }
              '); ?>
            </div>
            <div class="clr"></div>
        </section>

    <?php else: ?>
        <p><?php echo __('Brak obrazków w galerii'); ?></p>
    <?php endif; ?>

    <?php
    // INFO
    $redaktor = trim($galeria->getUzytkownikDane());
    Functions::renderInfo($galeria, 'getCreatedAt', 'getViews', 'countSubs', $redaktor);

    $fb_zaj_file = '';
    if (!isset($preview) || $preview != true):
        $fb_zaj_file = sfConfig::get('sf_upload_dir') . '/pub/gali/gal_' . $galeria->getId() . '/' . $galeria->getGiObrazPub()->getNazwaPliku();
    endif;
    ?>

    <div class="cl"></div>
    <?php
        if (in_array('mkbl', ModulPeer::getEnabled())) include_partial('Common/microblog', array('grafika' => $fb_zaj_file, 'tytul' => $galeria->getTytul()));
        include_partial('igaleria/actions', array('galeria' => $galeria));
    ?>
    <div class="cl"></div>

</div>

<div id="rest_box noprint">
    <?php
    if (!isset($preview) || $preview != true)
        include_component('igaleria', 'kategoriarest', array('galeria' => $galeria, 'img_size' => $img_size, 'sizes' => $sizes));
    ?>
</div>

<?php
if (!isset($preview)):
    if ($galeria->getKomentarz()):
        include_component('comments', 'box', array('module' => 'gali', 'object' => $galeria));
    endif;
endif;


if (!empty($slides)): // W przypadku generowania podgladu bez zdjęć sypie błedami w logach:
    echo javascript_tag(remote_function(array('url' => 'igaleria/getBigPhoto?' . ($preview ? 'pid=' : 'id=') . $id . '&PN=' . serialize($PN) . '&num=0' . ($preview ? '&preview=true' : ''), 'update' => 'bigPhoto', 'script' => true)) . "; var go_num = 0;");
endif;

if (!isset($preview) || $preview != true):
    slot('fb_image');


    if (is_file($fb_zaj_file)):
        list($width_orig, $height_orig, $image_type) = getimagesize($fb_zaj_file);
        if (($width_orig >= 200) || ($height_orig >= 200)):
            ?>
            <meta name="og:image" content="<?php echo 'http://' . $_SERVER['SERVER_NAME'] . str_replace(sfConfig::get('sf_upload_dir'), '/uploads', $fb_zaj_file); ?>"/>
        <?php else: ?>
            <meta name="og:image" content="<?php echo 'http://' . $_SERVER['SERVER_NAME'] . '/images/portal_img.jpg'; ?>"/>
        <?php
        endif;
    else:
        ?>
        <meta name="og:image" content="<?php echo 'http://' . $_SERVER['SERVER_NAME'] . '/images/portal_img.jpg'; ?>"/>
    <?php endif; ?>
    <meta name="og:title" content="<?php echo str_replace('"', '', $galeria->getTytul()); ?>"/>
    <meta name="og:description" content="<?php echo $galeria->getZajawka(); ?>"/>
    <meta name="og:site_name" content="<?php echo UstawieniePeer::getProperties('graf_config_project_name') ?>"/>
    <meta name="og:url" content="<?php echo $sf_request->getUri(); ?>"/>
    <meta name="og:type" content="article" />
    <?php end_slot(); ?>
<?php endif; ?>
<?php include_partial('Common/fancyboxLoader'); ?>
