<?php

/**
 * GaleriaI form.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfPropelFormTemplate.php 10377 2008-07-21 07:10:32Z dwhittle $
 */
class GaleriaIForm extends BaseGaleriaIForm {

    public function configure() {
        $this->getWidgetSchema()->getFormFormatter()->setHelpFormat('%help%');
    }

    public function setup() {
        $crit = new Criteria();
        $crit->add(GiObrazPeer::GALERIA_ID, $this->getObject()->getPrimaryKey());
        $crit->addAscendingOrderByColumn(GiObrazPeer::KOLEJNOSC);

        if (!sfContext::getinstance()->getUser()->hasCredential('config')) {
            $user = new sfWidgetFormInputHidden();
        } else {
            $user = new sfWidgetFormPropelChoice(array('model' => 'sfGuardUser', 'add_empty' => false));
        }

        $critk = GiSubkategoriaPeer::buildBasicCriteria();
        $cat = new sfWidgetFormSelect(array(
                    'choices' => GiSubkategoriaPeer::getSubcatsForSelect($critk)));

        $this->setWidgets(array(
            'id' => new sfWidgetFormInputHidden(),
            'uzytkownik_dane'    => new sfWidgetFormInput(),
            'uzytkownik_kontakt' => new sfWidgetFormInput(),
            'opublikowal' => $user,
            'subkategoria_id' => $cat,
        ));

        $this->setValidators(array(
            'id' => new sfValidatorPropelChoice(array('model' => 'GaleriaI', 'column' => 'id', 'required' => false)),
            'uzytkownik_dane'    => new sfValidatorString(array('max_length' => 255, 'required' => false)),
            'uzytkownik_kontakt' => new ciValidatorEmail(array('max_length' => 255, 'required' => true)),
            'opublikowal' => new sfValidatorPropelChoice(array('model' => 'sfGuardUser', 'column' => 'id')),
            'subkategoria_id' => new sfValidatorPropelChoice(array('model' => 'GiSubkategoria', 'column' => 'id')),
        ));

        if (Comments::showInForms('gali')) {
            $this->widgetSchema['komentarz'] = new sfWidgetFormSelect(array('choices' => array(0 => 'Nie', 1 => 'Tak'), 'default' => 1));
        } else {
            $this->widgetSchema['komentarz'] = new sfWidgetFormInputHidden();
        }
        $this->validatorSchema['komentarz'] = new sfValidatorChoice(array('choices' => array(0, 1), 'required' => false));

        $this->widgetSchema->setHelps(array(
            'uzytkownik_dane'    => 'Podaj imię i nazwisko lub pseudonim.',
            'uzytkownik_kontakt'    => 'Proszę podać adres email osoby zgłaszającej galerię.',
            'opublikowal' => "Dane użytkownika, który opublikował galerię.",
            'subkategoria_id' => "Do jakiej podkategorii należy galeria?",
            'komentarz' => 'Czy można dodawać komentarze do danej galerii?',
        ));
        
        $this->widgetSchema->setLabels(array(
            'subkategoria_id'    => 'Kategoria',
            'uzytkownik_dane'    => 'Autor galerii',
            'uzytkownik_kontakt'    => 'Adres email',
        ));

        unset($this['widoczna'], $this['obraz_id']);

        $cultures = JezykTblPeer::getCulturesForModul('gali');
        $this->embedI18n($cultures);
        foreach ($cultures as $cul) {

        }
        $this->widgetSchema->setNameFormat('galeria[%s]');
        $this->widgetSchema->setFormFormatterName('sam3');
        $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
        
        $this->getWidgetSchema()->getFormFormatter()->setHelpFormat('%help%');
        $this->setRequiredFields();
    }

}
