<?php

/**
 * GaleriaIPub form.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfPropelFormTemplate.php 10377 2008-07-21 07:10:32Z dwhittle $
 */
class GaleriaIPubForm extends BaseGaleriaIPubForm {

    public function setup() {
        
        $crit = new Criteria();
        $crit->add(GiObrazPeer::GALERIA_ID, $this->getObject()->getPrimaryKey());
        $crit->addAscendingOrderByColumn(GiObrazPeer::KOLEJNOSC);
        
        if (!sfContext::getinstance()->getUser()->hasCredential('config')) {
            $user = new sfWidgetFormInputHidden();
        } else {
            $user = new sfWidgetFormPropelChoice(array('model' => 'sfGuardUser', 'add_empty' => false));
        }
        
        $this->setWidgets(array(
            'id' => new sfWidgetFormInputHidden(),
            'uzytkownik_dane'    => new sfWidgetFormInput(),
            'uzytkownik_kontakt' => new sfWidgetFormInput(),
            'subkategoria_id' => new sfWidgetFormPropelChoice(array('model' => 'GiSubkategoria', 'add_empty' => false)),
            'opublikowal' => $user,
        ));

        $this->setValidators(array(
            'id' => new sfValidatorPass(),
            'uzytkownik_dane'    => new sfValidatorString(array('max_length' => 255, 'required' => false)),
            'uzytkownik_kontakt' => new ciValidatorEmail(array('max_length' => 255, 'required' => true)),
            'opublikowal' => new sfValidatorPropelChoice(array('model' => 'sfGuardUser', 'column' => 'id')),
            'subkategoria_id' => new sfValidatorPropelChoice(array('model' => 'GiSubkategoria', 'column' => 'id')),
        ));

        $cultures = JezykTblPeer::getCultures();
        $this->embedI18n($cultures);

        foreach ($cultures as $cul) {
            $this->widgetSchema[$cul]['zajawka'] = new sfWidgetFormTextarea();
            $this->validatorSchema[$cul]['tytul'] = new sfValidatorString(array('required' => false));
            $this->validatorSchema[$cul]['zajawka'] = new sfValidatorString(array('required' => false));
        }
        $this->widgetSchema->setNameFormat('galeria[%s]');
        $this->widgetSchema->setFormFormatterName('sam3');
        $this->validatorSchema->setOption('allow_extra_fields', true);
        $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
    }

    public function configure() {
        
    }

}
