<?php
/**
 * Skeleton subclass for performing query and update operations on the 'igaleria_tbl' table.
 *
 *
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    lib.model
 */
class GaleriaIPeer extends BaseGaleriaIPeer {
    private $allSubs = array();
    static $instance;

    public static function getInstance() {
        if(!self::$instance) {
            return self::$instance = new self();
        }
        return self::$instance;
    }

    public function getAllSubs($crit = null) {
        if (!$crit) $crit = new Criteria();
        if (count($this->allSubs)) {
            foreach ($this->allSubs as $sub) {
                if ($crit->equals($sub['crit'])) {
                    return $sub['list'];
                }
            }
        }
        $list = GiObrazPeer::doSelect($crit);
        $this->allSubs[] = array('crit'=>$crit,'list'=>$list);
        return  $list;
    }

    public static function doCount(Criteria $criteria, $distinct = false, PropelPDO $con = null) {
        $criteria->addGroupByColumn(GaleriaIPeer::ID);
        return parent::doCount($criteria,$distinct,$con);
    }

    public static function buildBasicCriteria($criteria = null) {
        $criteria = GiKategoriaPeer::buildBasicCriteria($criteria);
        $criteria->addJoin(GiKategoriaPeer::ID,GiSubkategoriaPeer::KATEGORIA_ID);
        $criteria->addJoin(GiSubkategoriaPeer::ID,GaleriaIPeer::SUBKATEGORIA_ID);
        return $criteria;
    }

    public static function buildUserCriteria() {
        $criteria = GaleriaIPeer::buildBasicCriteria();
        $user = sfContext::getInstance()->getUser();
        if (!$user->checkPermission('gali_global','edit')) {
            $criteria->add(GaleriaIPeer::UZYTKOWNIK_ID,$user->getId());
        }
        return $criteria;
    }

    public static function getUserGallery() {
        $c = GaleriaIPeer::buildUserCriteria();
        $c->add(GaleriaIPeer::UZYTKOWNIK_ID, sfContext::getInstance()->getUser()->getId());
        //$c->addAscendingOrderByColumn(GaleriaII18nPeer::TYTUL);

        //$c->addJoin(AGaleriaPubPeer::GALERIA_ID, GaleriaIPubPeer::ID);

        return GaleriaIPeer::doSelect($c);
    }

    public static function getAllGallery() {
        $c = GaleriaIPeer::buildBasicCriteria();
        //$c->add(GaleriaIPubPeer::UZYTKOWNIK_ID, sfContext::getInstance()->getUser()->getId());
        //$c->addAscendingOrderByColumn(GaleriaII18nPeer::TYTUL);

        //$c->addJoin(AGaleriaPubPeer::GALERIA_ID, GaleriaIPubPeer::ID);

        return GaleriaIPeer::doSelect($c);
    }

    public static function sortSub($id) {
        $cup = new Criteria();
        $cup->addDescendingOrderByColumn(GaleriaIPeer::KOLEJNOSC);
        $cup->add(GaleriaIPeer::SUBKATEGORIA_ID,$id);
        $galerie = GaleriaIPeer::doSelect($cup);

        $i = 1;
        foreach ($galerie as $gal) {
            $gal->setKolejnosc($i++);
            $gal->save();
        }
    }
}
