<?php
/**
 * Skeleton subclass for representing a row from the 'igaleria_kategoria_tbl' table.
 *
 *
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    lib.model
 */
class GiKategoria extends BaseGiKategoria {
    public function __toString() {
        return $this->getNazwa(sfContext::getInstance()->getUser()->getCulture());
    }

    public function getSubs() {
        $all = GiKategoriaPeer::getInstance()->getAllSubs();
        $subs = array();
        foreach ($all as $sub) {
            if ($sub->getKategoriaId() == $this->getPrimaryKey()) {
                $subs[] = $sub;
            }
        }
        return $subs;
    }

    public function countSubs() {
        $all = GiKategoriaPeer::getInstance()->getAllSubs();
        $subs = 0;
        foreach ($all as $sub) {
            if ($sub->getKategoriaId() == $this->getPrimaryKey()) {
                $subs++;
            }
        }
        return $subs;
    }

    public function getSubspub() {
        $all = GiKategoriaPeer::getInstance()->getAllSubs();
        $subs = array();
        foreach ($all as $sub) {
            if ($sub->getKategoriaId() == $this->getPrimaryKey()) {
                $subs[] = $sub;
            }
        }
        return $subs;
    }

    public function countSubspub() {
        $all = GiKategoriaPeer::getInstance()->getAllSubs();
        $subs = 0;
        foreach ($all as $sub) {
            if ($sub->getKategoriaId() == $this->getPrimaryKey()) {
                $subs++;
            }
        }
        return $subs;
    }

    public function moveDown() {
        $cup = new Criteria();
        $cup->addAscendingOrderByColumn(GiKategoriaPeer::KOLEJNOSC);
        $cup->add(GiKategoriaPeer::KOLEJNOSC,$this->getKolejnosc(),Criteria::GREATER_THAN);
        $up = GKategoriaPeer::doSelectOne($cup);

        if ($up) {
            $temp = $this->getKolejnosc();
            $this->setKolejnosc($up->getKolejnosc());
            $up->setKolejnosc($temp);
            $up->save();
        } else {
            $this->setKolejnosc(($this->getKolejnosc())+1);
        }
        $this->save();
    }

    public function moveUp() {
        $cup = new Criteria();
        $cup->addDescendingOrderByColumn(GiKategoriaPeer::KOLEJNOSC);
        $cup->add(GiKategoriaPeer::KOLEJNOSC,$this->getKolejnosc(),Criteria::LESS_THAN);
        $up = GKategoriaPeer::doSelectOne($cup);

        if ($up) {
            $temp = $this->getKolejnosc();
            $this->setKolejnosc($up->getKolejnosc());
            $up->setKolejnosc($temp);
            $up->save();
        } else {
            $this->setKolejnosc(($this->getKolejnosc())-1);
        }
        $this->save();
    }

    public function save(PropelPDO $con = null) {
        if ($this->isModified() && !$this->isColumnModified(GKategoriaPeer::ID)) {
            $cup = new Criteria();
            $cup->addAscendingOrderByColumn(GiKategoriaPeer::KOLEJNOSC);
            $up = GiKategoriaPeer::doSelectOne($cup);

            if ($up) {
                $this->setKolejnosc($up->getKolejnosc()+1);
            } else {
                $this->setKolejnosc(0);
            }
        }
        parent::save($con);
    }

    public function checkPermission(sfUser $user=null, $val=null) {
        if (!$user) $user = sfContext::getInstance()->getUser();
        if (!sfGuardPermission::validPerm($val)) return false;

        $perm = "gali_gcat_{$this->getPrimaryKey()}";
        $spec = $user->checkPermission($perm,$val);
        if ($spec == -1) {
            return -1;
        } else {
            if ($spec == 1) {
                return 1;
            }

            $global = $user->checkPermission('gali_global',$val);
            if ($global == 1) {
                return 1;
            }
            if ($val == 'create') {
                $usr = $user->checkPermission('gali_user',$val);
                if ($usr == 1) {
                    return 1;
                }
            }
        }
        return 0;
    }

    public function delete(PropelPDO $con = null) {
        $id = $this->getId();
        foreach ($this->getGiSubkategorias() as $sub) {
            $sub->delete();
        }
        parent::delete();
    }
}
