<?php
/**
 * Skeleton subclass for representing a row from the 'igaleria_subkategoria_tbl' table.
 *
 *
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    lib.model
 */
class GiSubkategoria extends BaseGiSubkategoria {
    public function __toString() {
        return $this->getNazwa(sfContext::getInstance()->getUser()->getCulture());
    }

    public function getSubs($crit = null) {
        $all = GiSubkategoriaPeer::getInstance()->getAllSubs($crit);
        $subs = array();
        foreach ($all as $sub) {
            if ($sub->getSubkategoriaId() == $this->getPrimaryKey()) {
                $subs[] = $sub;
            }
        }
        return $subs;
    }

    public function countSubs() {
        $all = GiSubkategoriaPeer::getInstance()->getAllSubs();
        $subs = 0;
        foreach ($all as $sub) {
            if ($sub->getSubkategoriaId() == $this->getPrimaryKey()) {
                $subs++;
            }
        }
        return $subs;
    }

    public function getSubspub() {
        $all = GiSubkategoriaPeer::getInstance()->getAllSubspub();
        $subs = array();
        foreach ($all as $sub) {
            if ($sub->getSubkategoriaId() == $this->getPrimaryKey()) {
                $subs[] = $sub;
            }
        }
        return $subs;
    }

    public function countSubspub() {
        $all = GiSubkategoriaPeer::getInstance()->getAllSubspub();
        $subs = 0;
        foreach ($all as $sub) {
            if ($sub->getSubkategoriaId() == $this->getPrimaryKey()) {
                $subs++;
            }
        }
        return $subs;
    }

    public function moveDown() {
        $cup = new Criteria();
        $cup->addAscendingOrderByColumn(GiSubkategoriaPeer::KOLEJNOSC);
        $cup->add(GiSubkategoriaPeer::KATEGORIA_ID,$this->getKategoriaId());
        $cup->add(GiSubkategoriaPeer::KOLEJNOSC,$this->getKolejnosc(),Criteria::GREATER_THAN);
        $up = GiSubkategoriaPeer::doSelectOne($cup);

        if ($up) {
            $temp = $this->getKolejnosc();
            $this->setKolejnosc($up->getKolejnosc());
            $up->setKolejnosc($temp);
            $up->save();
        }
        else {
            $this->setKolejnosc(($this->getKolejnosc())+1);
        }
        $this->save();
    }

    public function moveUp() {
        $cup = new Criteria();
        $cup->addDescendingOrderByColumn(GiSubkategoriaPeer::KOLEJNOSC);
        $cup->add(GiSubkategoriaPeer::KATEGORIA_ID,$this->getKategoriaId());
        $cup->add(GiSubkategoriaPeer::KOLEJNOSC,$this->getKolejnosc(),Criteria::LESS_THAN);
        $up = GiSubkategoriaPeer::doSelectOne($cup);

        if ($up) {
            $temp = $this->getKolejnosc();
            $this->setKolejnosc($up->getKolejnosc());
            $up->setKolejnosc($temp);
            $up->save();
        }
        else {
            $this->setKolejnosc(($this->getKolejnosc())-1);
        }
        $this->save();
    }

    public function save(PropelPDO $con = null) {
        if ($this->isModified() && !$this->isColumnModified(GiSubkategoriaPeer::KATEGORIA_ID)) {
            $cup = new Criteria();
            $cup->addAscendingOrderByColumn(GiSubkategoriaPeer::KOLEJNOSC);
            $cup->add(GiSubkategoriaPeer::KATEGORIA_ID,$this->getKategoriaId());
            $up = GiSubkategoriaPeer::doSelectOne($cup);

            if ($up) {
                $this->setKolejnosc($up->getKolejnosc()+1);
            }
            else {
                $this->setKolejnosc(0);
            }
        }
        parent::save($con);
    }

    public function checkPermission(sfUser $user=null, $val=null) {
        if (!$user) $user = sfContext::getInstance()->getUser();
        if (!sfGuardPermission::validPerm($val)) return false;
        
        $perm = "gali_gsub_{$this->getPrimaryKey()}";
        $permission = $user->checkPermission($perm,$val);

        switch ($permission) {
            case 1:
                return true;
            case -1:
                return false;
            case 0;
                $parent = $this->getGiKategoria();
                if ($parent && $parent->checkPermission($user,$val) == 1) {
                    return true;
                }
            default:
                return false;
        }
    }

    public function delete(PropelPDO $con = null) {
        $id = $this->getId();
        foreach ($this->getGaleriaIs() as $sub) {
            $sub->delete();
        }
        foreach ($this->getGaleriaIPubs() as $sub) {
            $sub->delete();
        }
        parent::delete();
    }

}
