<?php

/**
 * Skeleton subclass for performing query and update operations on the 'igaleria_subkategoria_tbl' table.
 *
 *
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    lib.model
 */
class GiSubkategoriaPeer extends BaseGiSubkategoriaPeer
{
    private $allSubs = array();
    static $instance;

    public static function getInstance()
    {
        if(!self::$instance)
        {
            return self::$instance = new self();
        }
        return self::$instance;
    }

    public function getAllSubs($crit = null)
    {
        if(!$crit)
            $crit = new Criteria();
        if(count($this->allSubs))
        {
            foreach($this->allSubs as $sub)
            {
                if($crit->equals($sub['crit']))
                {
                    return $sub['list'];
                }
            }
        }
        $list = GaleriaIPeer::doSelect($crit);
        $this->allSubs[] = array('crit' => $crit, 'list' => $list);
        return $list;
    }

    public function getAllSubspub($crit = null)
    {
        if(!$crit)
            $crit = new Criteria();
        if(count($this->allSubs))
        {
            foreach($this->allSubs as $sub)
            {
                if($crit->equals($sub['crit']))
                {
                    return $sub['list'];
                }
            }
        }
        $list = GaleriaIPubPeer::doSelect($crit);
        $this->allSubs[] = array('crit' => $crit, 'list' => $list);
        return $list;
    }

    public static function buildBasicCriteria(Criteria $crit = null)
    {
        if(!$crit)
            $crit = new CriteriaExt();
        
        $crit->addJoin(GiSubkategoriaPeer::KATEGORIA_ID, GiKategoriaPeer::ID, Criteria::LEFT_JOIN);
        if(sfConfig::get('multisite'))
        {
            $crit->add(GiKategoriaPeer::ID, sfConfig::get('portal')->getCat('gali'));
        }
        else
        {
            /* Usunięte w zwiazku ze skargami na zniknięcia
              $other = sfConfig::get('portal')->getOtherCats('gali');
              foreach ($other as $cat) {
              $crit->addAnd(GiKategoriaPeer::ID,$cat,Criteria::NOT_EQUAL);
              }
             */
        }
        
        return $crit;
    }

    /*
     * Dla formularza dodawania/edycji obiektu
     */

    public static function getAllowedCats(Criteria $c = null)
    {
        $user = sfContext::getInstance()->getUser();
        
        if(!$c)
            $c = new CriteriaExt();
        $c->addJoin(GiSubkategoriaPeer::ID, GiSubkategoriaI18nPeer::ID, Criteria::LEFT_JOIN);
        $c->add(GiSubkategoriaI18nPeer::CULTURE, $user->getCulture());
        //$c->addAscendingOrderByColumn(GiSubkategoriaI18nPeer::NAZWA);

        $kategorie = GiSubkategoriaPeer::doSelect($c);
        
        return array_filter($kategorie);
    }

    public static function getSubcatsForSelect(Criteria $c = null)
    {
        $subs = GiSubkategoriaPeer::getAllowedCats($c);
        
        $tmp = array();
        foreach($subs as $sub)
        {
            $kid = $sub->getKategoriaId();
            $tmp[$kid][$sub->getId()] = $sub->__toString();
        }

        $kategorie = array();
        foreach($tmp as $id => $arr)
        {
            $kategorie[GiKategoriaPeer::retrieveByPK($id)->__toString()] = $arr;
        }
        //ksort($kategorie);
        return $kategorie;
    }

}