<?php



class GaleriaIPubMapBuilder implements MapBuilder {

	
	const CLASS_NAME = 'lib.model.map.GaleriaIPubMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(GaleriaIPubPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(GaleriaIPubPeer::TABLE_NAME);
		$tMap->setPhpName('GaleriaIPub');
		$tMap->setClassname('GaleriaIPub');

		$tMap->setUseIdGenerator(false);

		$tMap->addForeignPrimaryKey('ID', 'Id', 'INTEGER' , 'igaleria_tbl', 'ID', true, 11);

		$tMap->addColumn('UPDATED_AT', 'UpdatedAt', 'TIMESTAMP', false, null);

		$tMap->addColumn('CREATED_AT', 'CreatedAt', 'TIMESTAMP', false, null);

		$tMap->addColumn('KOLEJNOSC', 'Kolejnosc', 'INTEGER', false, 11);

		$tMap->addColumn('WIDOCZNA', 'Widoczna', 'TINYINT', true, 1);

		$tMap->addForeignKey('OBRAZ_ID', 'ObrazId', 'INTEGER', 'igaleria_obraz_pub', 'ID', false, 11);

		$tMap->addColumn('X', 'X', 'DECIMAL', false, 19);

		$tMap->addColumn('Y', 'Y', 'DECIMAL', false, 19);

		$tMap->addColumn('Z', 'Z', 'INTEGER', false, 11);

		$tMap->addColumn('UZYTKOWNIK_DANE', 'UzytkownikDane', 'VARCHAR', false, 255);

		$tMap->addColumn('UZYTKOWNIK_KONTAKT', 'UzytkownikKontakt', 'VARCHAR', true, 255);

		$tMap->addForeignKey('OPUBLIKOWAL', 'Opublikowal', 'INTEGER', 'sf_guard_user', 'ID', false, 11);

		$tMap->addForeignKey('SUBKATEGORIA_ID', 'SubkategoriaId', 'INTEGER', 'igaleria_subkategoria_tbl', 'ID', true, 11);

		$tMap->addColumn('KOMENTARZ', 'Komentarz', 'TINYINT', false, 1);

	} 
} 