<?php


abstract class BaseGaleriaI extends BaseObject  implements Persistent {


  const PEER = 'GaleriaIPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $updated_at;

	
	protected $created_at;

	
	protected $kolejnosc;

	
	protected $widoczna;

	
	protected $obraz_id;

	
	protected $x;

	
	protected $y;

	
	protected $z;

	
	protected $uzytkownik_dane;

	
	protected $uzytkownik_kontakt;

	
	protected $opublikowal;

	
	protected $subkategoria_id;

	
	protected $komentarz;

	
	protected $asfGuardUser;

	
	protected $aGiObraz;

	
	protected $aGiSubkategoria;

	
	protected $collGaleriaII18ns;

	
	private $lastGaleriaII18nCriteria = null;

	
	protected $collGiObrazs;

	
	private $lastGiObrazCriteria = null;

	
	protected $singleGaleriaIPub;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

  
  protected $culture;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->kolejnosc = 0;
		$this->widoczna = 0;
		$this->uzytkownik_kontakt = '';
		$this->opublikowal = 0;
		$this->komentarz = 1;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->updated_at === null) {
			return null;
		}


		if ($this->updated_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->updated_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->updated_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getKolejnosc()
	{
		return $this->kolejnosc;
	}

	
	public function getWidoczna()
	{
		return $this->widoczna;
	}

	
	public function getObrazId()
	{
		return $this->obraz_id;
	}

	
	public function getX()
	{
		return $this->x;
	}

	
	public function getY()
	{
		return $this->y;
	}

	
	public function getZ()
	{
		return $this->z;
	}

	
	public function getUzytkownikDane()
	{
		return $this->uzytkownik_dane;
	}

	
	public function getUzytkownikKontakt()
	{
		return $this->uzytkownik_kontakt;
	}

	
	public function getOpublikowal()
	{
		return $this->opublikowal;
	}

	
	public function getSubkategoriaId()
	{
		return $this->subkategoria_id;
	}

	
	public function getKomentarz()
	{
		return $this->komentarz;
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = GaleriaIPeer::ID;
		}

		return $this;
	} 
	
	public function setUpdatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->updated_at !== null || $dt !== null ) {
			
			$currNorm = ($this->updated_at !== null && $tmpDt = new DateTime($this->updated_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->updated_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GaleriaIPeer::UPDATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GaleriaIPeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setKolejnosc($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->kolejnosc !== $v || $v === 0) {
			$this->kolejnosc = $v;
			$this->modifiedColumns[] = GaleriaIPeer::KOLEJNOSC;
		}

		return $this;
	} 
	
	public function setWidoczna($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->widoczna !== $v || $v === 0) {
			$this->widoczna = $v;
			$this->modifiedColumns[] = GaleriaIPeer::WIDOCZNA;
		}

		return $this;
	} 
	
	public function setObrazId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->obraz_id !== $v) {
			$this->obraz_id = $v;
			$this->modifiedColumns[] = GaleriaIPeer::OBRAZ_ID;
		}

		if ($this->aGiObraz !== null && $this->aGiObraz->getId() !== $v) {
			$this->aGiObraz = null;
		}

		return $this;
	} 
	
	public function setX($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->x !== $v) {
			$this->x = $v;
			$this->modifiedColumns[] = GaleriaIPeer::X;
		}

		return $this;
	} 
	
	public function setY($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->y !== $v) {
			$this->y = $v;
			$this->modifiedColumns[] = GaleriaIPeer::Y;
		}

		return $this;
	} 
	
	public function setZ($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->z !== $v) {
			$this->z = $v;
			$this->modifiedColumns[] = GaleriaIPeer::Z;
		}

		return $this;
	} 
	
	public function setUzytkownikDane($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->uzytkownik_dane !== $v) {
			$this->uzytkownik_dane = $v;
			$this->modifiedColumns[] = GaleriaIPeer::UZYTKOWNIK_DANE;
		}

		return $this;
	} 
	
	public function setUzytkownikKontakt($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->uzytkownik_kontakt !== $v || $v === '') {
			$this->uzytkownik_kontakt = $v;
			$this->modifiedColumns[] = GaleriaIPeer::UZYTKOWNIK_KONTAKT;
		}

		return $this;
	} 
	
	public function setOpublikowal($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->opublikowal !== $v || $v === 0) {
			$this->opublikowal = $v;
			$this->modifiedColumns[] = GaleriaIPeer::OPUBLIKOWAL;
		}

		if ($this->asfGuardUser !== null && $this->asfGuardUser->getId() !== $v) {
			$this->asfGuardUser = null;
		}

		return $this;
	} 
	
	public function setSubkategoriaId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->subkategoria_id !== $v) {
			$this->subkategoria_id = $v;
			$this->modifiedColumns[] = GaleriaIPeer::SUBKATEGORIA_ID;
		}

		if ($this->aGiSubkategoria !== null && $this->aGiSubkategoria->getId() !== $v) {
			$this->aGiSubkategoria = null;
		}

		return $this;
	} 
	
	public function setKomentarz($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->komentarz !== $v || $v === 1) {
			$this->komentarz = $v;
			$this->modifiedColumns[] = GaleriaIPeer::KOMENTARZ;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(GaleriaIPeer::KOLEJNOSC,GaleriaIPeer::WIDOCZNA,GaleriaIPeer::UZYTKOWNIK_KONTAKT,GaleriaIPeer::OPUBLIKOWAL,GaleriaIPeer::KOMENTARZ))) {
				return false;
			}

			if ($this->kolejnosc !== 0) {
				return false;
			}

			if ($this->widoczna !== 0) {
				return false;
			}

			if ($this->uzytkownik_kontakt !== '') {
				return false;
			}

			if ($this->opublikowal !== 0) {
				return false;
			}

			if ($this->komentarz !== 1) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->updated_at = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->created_at = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->kolejnosc = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->widoczna = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->obraz_id = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
			$this->x = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->y = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->z = ($row[$startcol + 8] !== null) ? (int) $row[$startcol + 8] : null;
			$this->uzytkownik_dane = ($row[$startcol + 9] !== null) ? (string) $row[$startcol + 9] : null;
			$this->uzytkownik_kontakt = ($row[$startcol + 10] !== null) ? (string) $row[$startcol + 10] : null;
			$this->opublikowal = ($row[$startcol + 11] !== null) ? (int) $row[$startcol + 11] : null;
			$this->subkategoria_id = ($row[$startcol + 12] !== null) ? (int) $row[$startcol + 12] : null;
			$this->komentarz = ($row[$startcol + 13] !== null) ? (int) $row[$startcol + 13] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 14; 
		} catch (Exception $e) {
			throw new PropelException("Error populating GaleriaI object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aGiObraz !== null && $this->obraz_id !== $this->aGiObraz->getId()) {
			$this->aGiObraz = null;
		}
		if ($this->asfGuardUser !== null && $this->opublikowal !== $this->asfGuardUser->getId()) {
			$this->asfGuardUser = null;
		}
		if ($this->aGiSubkategoria !== null && $this->subkategoria_id !== $this->aGiSubkategoria->getId()) {
			$this->aGiSubkategoria = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GaleriaIPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = GaleriaIPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->asfGuardUser = null;
			$this->aGiObraz = null;
			$this->aGiSubkategoria = null;
			$this->collGaleriaII18ns = null;
			$this->lastGaleriaII18nCriteria = null;

			$this->collGiObrazs = null;
			$this->lastGiObrazCriteria = null;

			$this->singleGaleriaIPub = null;

		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GaleriaIPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			GaleriaIPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isModified() && !$this->isColumnModified(GaleriaIPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

    if ($this->isNew() && !$this->isColumnModified(GaleriaIPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GaleriaIPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			GaleriaIPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->asfGuardUser !== null) {
				if ($this->asfGuardUser->isModified() || $this->asfGuardUser->isNew()) {
					$affectedRows += $this->asfGuardUser->save($con);
				}
				$this->setsfGuardUser($this->asfGuardUser);
			}

			if ($this->aGiObraz !== null) {
				if ($this->aGiObraz->isModified() || ($this->aGiObraz->getCulture() && $this->aGiObraz->getCurrentGiObrazI18n()->isModified()) || $this->aGiObraz->isNew()) {
					$affectedRows += $this->aGiObraz->save($con);
				}
				$this->setGiObraz($this->aGiObraz);
			}

			if ($this->aGiSubkategoria !== null) {
				if ($this->aGiSubkategoria->isModified() || ($this->aGiSubkategoria->getCulture() && $this->aGiSubkategoria->getCurrentGiSubkategoriaI18n()->isModified()) || $this->aGiSubkategoria->isNew()) {
					$affectedRows += $this->aGiSubkategoria->save($con);
				}
				$this->setGiSubkategoria($this->aGiSubkategoria);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = GaleriaIPeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = GaleriaIPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += GaleriaIPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			if ($this->collGaleriaII18ns !== null) {
				foreach ($this->collGaleriaII18ns as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collGiObrazs !== null) {
				foreach ($this->collGiObrazs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->singleGaleriaIPub !== null) {
				if (!$this->singleGaleriaIPub->isDeleted()) {
						$affectedRows += $this->singleGaleriaIPub->save($con);
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->asfGuardUser !== null) {
				if (!$this->asfGuardUser->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->asfGuardUser->getValidationFailures());
				}
			}

			if ($this->aGiObraz !== null) {
				if (!$this->aGiObraz->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aGiObraz->getValidationFailures());
				}
			}

			if ($this->aGiSubkategoria !== null) {
				if (!$this->aGiSubkategoria->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aGiSubkategoria->getValidationFailures());
				}
			}


			if (($retval = GaleriaIPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collGaleriaII18ns !== null) {
					foreach ($this->collGaleriaII18ns as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collGiObrazs !== null) {
					foreach ($this->collGiObrazs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->singleGaleriaIPub !== null) {
					if (!$this->singleGaleriaIPub->validate($columns)) {
						$failureMap = array_merge($failureMap, $this->singleGaleriaIPub->getValidationFailures());
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GaleriaIPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getUpdatedAt();
				break;
			case 2:
				return $this->getCreatedAt();
				break;
			case 3:
				return $this->getKolejnosc();
				break;
			case 4:
				return $this->getWidoczna();
				break;
			case 5:
				return $this->getObrazId();
				break;
			case 6:
				return $this->getX();
				break;
			case 7:
				return $this->getY();
				break;
			case 8:
				return $this->getZ();
				break;
			case 9:
				return $this->getUzytkownikDane();
				break;
			case 10:
				return $this->getUzytkownikKontakt();
				break;
			case 11:
				return $this->getOpublikowal();
				break;
			case 12:
				return $this->getSubkategoriaId();
				break;
			case 13:
				return $this->getKomentarz();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = GaleriaIPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getUpdatedAt(),
			$keys[2] => $this->getCreatedAt(),
			$keys[3] => $this->getKolejnosc(),
			$keys[4] => $this->getWidoczna(),
			$keys[5] => $this->getObrazId(),
			$keys[6] => $this->getX(),
			$keys[7] => $this->getY(),
			$keys[8] => $this->getZ(),
			$keys[9] => $this->getUzytkownikDane(),
			$keys[10] => $this->getUzytkownikKontakt(),
			$keys[11] => $this->getOpublikowal(),
			$keys[12] => $this->getSubkategoriaId(),
			$keys[13] => $this->getKomentarz(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GaleriaIPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setUpdatedAt($value);
				break;
			case 2:
				$this->setCreatedAt($value);
				break;
			case 3:
				$this->setKolejnosc($value);
				break;
			case 4:
				$this->setWidoczna($value);
				break;
			case 5:
				$this->setObrazId($value);
				break;
			case 6:
				$this->setX($value);
				break;
			case 7:
				$this->setY($value);
				break;
			case 8:
				$this->setZ($value);
				break;
			case 9:
				$this->setUzytkownikDane($value);
				break;
			case 10:
				$this->setUzytkownikKontakt($value);
				break;
			case 11:
				$this->setOpublikowal($value);
				break;
			case 12:
				$this->setSubkategoriaId($value);
				break;
			case 13:
				$this->setKomentarz($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = GaleriaIPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setUpdatedAt($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setCreatedAt($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setKolejnosc($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setWidoczna($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setObrazId($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setX($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setY($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setZ($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setUzytkownikDane($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setUzytkownikKontakt($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setOpublikowal($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setSubkategoriaId($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setKomentarz($arr[$keys[13]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(GaleriaIPeer::DATABASE_NAME);

		if ($this->isColumnModified(GaleriaIPeer::ID)) $criteria->add(GaleriaIPeer::ID, $this->id);
		if ($this->isColumnModified(GaleriaIPeer::UPDATED_AT)) $criteria->add(GaleriaIPeer::UPDATED_AT, $this->updated_at);
		if ($this->isColumnModified(GaleriaIPeer::CREATED_AT)) $criteria->add(GaleriaIPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(GaleriaIPeer::KOLEJNOSC)) $criteria->add(GaleriaIPeer::KOLEJNOSC, $this->kolejnosc);
		if ($this->isColumnModified(GaleriaIPeer::WIDOCZNA)) $criteria->add(GaleriaIPeer::WIDOCZNA, $this->widoczna);
		if ($this->isColumnModified(GaleriaIPeer::OBRAZ_ID)) $criteria->add(GaleriaIPeer::OBRAZ_ID, $this->obraz_id);
		if ($this->isColumnModified(GaleriaIPeer::X)) $criteria->add(GaleriaIPeer::X, $this->x);
		if ($this->isColumnModified(GaleriaIPeer::Y)) $criteria->add(GaleriaIPeer::Y, $this->y);
		if ($this->isColumnModified(GaleriaIPeer::Z)) $criteria->add(GaleriaIPeer::Z, $this->z);
		if ($this->isColumnModified(GaleriaIPeer::UZYTKOWNIK_DANE)) $criteria->add(GaleriaIPeer::UZYTKOWNIK_DANE, $this->uzytkownik_dane);
		if ($this->isColumnModified(GaleriaIPeer::UZYTKOWNIK_KONTAKT)) $criteria->add(GaleriaIPeer::UZYTKOWNIK_KONTAKT, $this->uzytkownik_kontakt);
		if ($this->isColumnModified(GaleriaIPeer::OPUBLIKOWAL)) $criteria->add(GaleriaIPeer::OPUBLIKOWAL, $this->opublikowal);
		if ($this->isColumnModified(GaleriaIPeer::SUBKATEGORIA_ID)) $criteria->add(GaleriaIPeer::SUBKATEGORIA_ID, $this->subkategoria_id);
		if ($this->isColumnModified(GaleriaIPeer::KOMENTARZ)) $criteria->add(GaleriaIPeer::KOMENTARZ, $this->komentarz);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(GaleriaIPeer::DATABASE_NAME);

		$criteria->add(GaleriaIPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setUpdatedAt($this->updated_at);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setKolejnosc($this->kolejnosc);

		$copyObj->setWidoczna($this->widoczna);

		$copyObj->setObrazId($this->obraz_id);

		$copyObj->setX($this->x);

		$copyObj->setY($this->y);

		$copyObj->setZ($this->z);

		$copyObj->setUzytkownikDane($this->uzytkownik_dane);

		$copyObj->setUzytkownikKontakt($this->uzytkownik_kontakt);

		$copyObj->setOpublikowal($this->opublikowal);

		$copyObj->setSubkategoriaId($this->subkategoria_id);

		$copyObj->setKomentarz($this->komentarz);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach ($this->getGaleriaII18ns() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addGaleriaII18n($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getGiObrazs() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addGiObraz($relObj->copy($deepCopy));
				}
			}

			$relObj = $this->getGaleriaIPub();
			if ($relObj) {
				$copyObj->setGaleriaIPub($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new GaleriaIPeer();
		}
		return self::$peer;
	}

	
	public function setsfGuardUser(sfGuardUser $v = null)
	{
		if ($v === null) {
			$this->setOpublikowal(0);
		} else {
			$this->setOpublikowal($v->getId());
		}

		$this->asfGuardUser = $v;

						if ($v !== null) {
			$v->addGaleriaI($this);
		}

		return $this;
	}


	
	public function getsfGuardUser(PropelPDO $con = null)
	{
		if ($this->asfGuardUser === null && ($this->opublikowal !== null)) {
			$c = new Criteria(sfGuardUserPeer::DATABASE_NAME);
			$c->add(sfGuardUserPeer::ID, $this->opublikowal);
			$this->asfGuardUser = sfGuardUserPeer::doSelectOne($c, $con);
			
		}
		return $this->asfGuardUser;
	}

	
	public function setGiObraz(GiObraz $v = null)
	{
		if ($v === null) {
			$this->setObrazId(NULL);
		} else {
			$this->setObrazId($v->getId());
		}

		$this->aGiObraz = $v;

						if ($v !== null) {
			$v->addGaleriaI($this);
		}

		return $this;
	}


	
	public function getGiObraz(PropelPDO $con = null)
	{
		if ($this->aGiObraz === null && ($this->obraz_id !== null)) {
			$c = new Criteria(GiObrazPeer::DATABASE_NAME);
			$c->add(GiObrazPeer::ID, $this->obraz_id);
			$this->aGiObraz = GiObrazPeer::doSelectOne($c, $con);
			
		}
		return $this->aGiObraz;
	}

	
	public function setGiSubkategoria(GiSubkategoria $v = null)
	{
		if ($v === null) {
			$this->setSubkategoriaId(NULL);
		} else {
			$this->setSubkategoriaId($v->getId());
		}

		$this->aGiSubkategoria = $v;

						if ($v !== null) {
			$v->addGaleriaI($this);
		}

		return $this;
	}


	
	public function getGiSubkategoria(PropelPDO $con = null)
	{
		if ($this->aGiSubkategoria === null && ($this->subkategoria_id !== null)) {
			$c = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);
			$c->add(GiSubkategoriaPeer::ID, $this->subkategoria_id);
			$this->aGiSubkategoria = GiSubkategoriaPeer::doSelectOne($c, $con);
			
		}
		return $this->aGiSubkategoria;
	}

	
	public function clearGaleriaII18ns()
	{
		$this->collGaleriaII18ns = null; 	}

	
	public function initGaleriaII18ns()
	{
		$this->collGaleriaII18ns = array();
	}

	
	public function getGaleriaII18ns($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaII18ns === null) {
			if ($this->isNew()) {
			   $this->collGaleriaII18ns = array();
			} else {

				$criteria->add(GaleriaII18nPeer::ID, $this->id);

				GaleriaII18nPeer::addSelectColumns($criteria);
				$this->collGaleriaII18ns = GaleriaII18nPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GaleriaII18nPeer::ID, $this->id);

				GaleriaII18nPeer::addSelectColumns($criteria);
				if (!isset($this->lastGaleriaII18nCriteria) || !$this->lastGaleriaII18nCriteria->equals($criteria)) {
					$this->collGaleriaII18ns = GaleriaII18nPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGaleriaII18nCriteria = $criteria;
		return $this->collGaleriaII18ns;
	}

	
	public function countGaleriaII18ns(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGaleriaII18ns === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GaleriaII18nPeer::ID, $this->id);

				$count = GaleriaII18nPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GaleriaII18nPeer::ID, $this->id);

				if (!isset($this->lastGaleriaII18nCriteria) || !$this->lastGaleriaII18nCriteria->equals($criteria)) {
					$count = GaleriaII18nPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGaleriaII18ns);
				}
			} else {
				$count = count($this->collGaleriaII18ns);
			}
		}
		return $count;
	}

	
	public function addGaleriaII18n(GaleriaII18n $l)
	{
		if ($this->collGaleriaII18ns === null) {
			$this->initGaleriaII18ns();
		}
		if (!in_array($l, $this->collGaleriaII18ns, true)) { 			array_push($this->collGaleriaII18ns, $l);
			$l->setGaleriaI($this);
		}
	}

	
	public function clearGiObrazs()
	{
		$this->collGiObrazs = null; 	}

	
	public function initGiObrazs()
	{
		$this->collGiObrazs = array();
	}

	
	public function getGiObrazs($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGiObrazs === null) {
			if ($this->isNew()) {
			   $this->collGiObrazs = array();
			} else {

				$criteria->add(GiObrazPeer::GALERIA_ID, $this->id);

				GiObrazPeer::addSelectColumns($criteria);
				$this->collGiObrazs = GiObrazPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiObrazPeer::GALERIA_ID, $this->id);

				GiObrazPeer::addSelectColumns($criteria);
				if (!isset($this->lastGiObrazCriteria) || !$this->lastGiObrazCriteria->equals($criteria)) {
					$this->collGiObrazs = GiObrazPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGiObrazCriteria = $criteria;
		return $this->collGiObrazs;
	}

	
	public function countGiObrazs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGiObrazs === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GiObrazPeer::GALERIA_ID, $this->id);

				$count = GiObrazPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiObrazPeer::GALERIA_ID, $this->id);

				if (!isset($this->lastGiObrazCriteria) || !$this->lastGiObrazCriteria->equals($criteria)) {
					$count = GiObrazPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGiObrazs);
				}
			} else {
				$count = count($this->collGiObrazs);
			}
		}
		return $count;
	}

	
	public function addGiObraz(GiObraz $l)
	{
		if ($this->collGiObrazs === null) {
			$this->initGiObrazs();
		}
		if (!in_array($l, $this->collGiObrazs, true)) { 			array_push($this->collGiObrazs, $l);
			$l->setGaleriaI($this);
		}
	}

	
	public function getGaleriaIPub(PropelPDO $con = null)
	{

		if ($this->singleGaleriaIPub === null && !$this->isNew()) {
			$this->singleGaleriaIPub = GaleriaIPubPeer::retrieveByPK($this->id, $con);
		}

		return $this->singleGaleriaIPub;
	}

	
	public function setGaleriaIPub(GaleriaIPub $v)
	{
		$this->singleGaleriaIPub = $v;

				if ($v->getGaleriaI() === null) {
			$v->setGaleriaI($this);
		}

		return $this;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collGaleriaII18ns) {
				foreach ((array) $this->collGaleriaII18ns as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collGiObrazs) {
				foreach ((array) $this->collGiObrazs as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->singleGaleriaIPub) {
				$this->singleGaleriaIPub->clearAllReferences($deep);
			}
		} 
		$this->collGaleriaII18ns = null;
		$this->collGiObrazs = null;
		$this->singleGaleriaIPub = null;
			$this->asfGuardUser = null;
			$this->aGiObraz = null;
			$this->aGiSubkategoria = null;
	}


  
  public function getCulture()
  {
    return $this->culture;
  }

  
  public function setCulture($culture)
  {
    $this->culture = $culture;
  }

  public function getZajawka($culture = null)
  {
    return $this->getCurrentGaleriaII18n($culture)->getZajawka();
  }

  public function setZajawka($value, $culture = null)
  {
    $this->getCurrentGaleriaII18n($culture)->setZajawka($value);
  }

  public function getTytul($culture = null)
  {
    return $this->getCurrentGaleriaII18n($culture)->getTytul();
  }

  public function setTytul($value, $culture = null)
  {
    $this->getCurrentGaleriaII18n($culture)->setTytul($value);
  }

  protected $current_i18n = array();

  public function getCurrentGaleriaII18n($culture = null)
  {
    if (is_null($culture))
    {
      $culture = is_null($this->culture) ? sfPropel::getDefaultCulture() : $this->culture;
    }

    if (!isset($this->current_i18n[$culture]))
    {
      $obj = $this->isNew() ? null : GaleriaII18nPeer::retrieveByPK($this->getId(), $culture);
      if ($obj)
      {
        $this->setGaleriaII18nForCulture($obj, $culture);
      }
      else
      {
        $this->setGaleriaII18nForCulture(new GaleriaII18n(), $culture);
        $this->current_i18n[$culture]->setCulture($culture);
      }
    }

    return $this->current_i18n[$culture];
  }

  public function setGaleriaII18nForCulture($object, $culture)
  {
    $this->current_i18n[$culture] = $object;
    $this->addGaleriaII18n($object);
  }

} 