<?php


abstract class BaseGaleriaIPub extends BaseObject  implements Persistent {


  const PEER = 'GaleriaIPubPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $updated_at;

	
	protected $created_at;

	
	protected $kolejnosc;

	
	protected $widoczna;

	
	protected $obraz_id;

	
	protected $x;

	
	protected $y;

	
	protected $z;

	
	protected $uzytkownik_dane;

	
	protected $uzytkownik_kontakt;

	
	protected $opublikowal;

	
	protected $subkategoria_id;

	
	protected $komentarz;

	
	protected $aGaleriaI;

	
	protected $aGiObrazPub;

	
	protected $asfGuardUser;

	
	protected $aGiSubkategoria;

	
	protected $collGaleriaIPubI18ns;

	
	private $lastGaleriaIPubI18nCriteria = null;

	
	protected $singleGiRank;

	
	protected $collGiStats;

	
	private $lastGiStatCriteria = null;

	
	protected $collGiObrazPubs;

	
	private $lastGiObrazPubCriteria = null;

	
	protected $collNewsboxs;

	
	private $lastNewsboxCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

  
  protected $culture;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->id = 0;
		$this->kolejnosc = 0;
		$this->widoczna = 0;
		$this->uzytkownik_kontakt = '';
		$this->opublikowal = 0;
		$this->komentarz = 1;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->updated_at === null) {
			return null;
		}


		if ($this->updated_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->updated_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->updated_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getKolejnosc()
	{
		return $this->kolejnosc;
	}

	
	public function getWidoczna()
	{
		return $this->widoczna;
	}

	
	public function getObrazId()
	{
		return $this->obraz_id;
	}

	
	public function getX()
	{
		return $this->x;
	}

	
	public function getY()
	{
		return $this->y;
	}

	
	public function getZ()
	{
		return $this->z;
	}

	
	public function getUzytkownikDane()
	{
		return $this->uzytkownik_dane;
	}

	
	public function getUzytkownikKontakt()
	{
		return $this->uzytkownik_kontakt;
	}

	
	public function getOpublikowal()
	{
		return $this->opublikowal;
	}

	
	public function getSubkategoriaId()
	{
		return $this->subkategoria_id;
	}

	
	public function getKomentarz()
	{
		return $this->komentarz;
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v || $v === 0) {
			$this->id = $v;
			$this->modifiedColumns[] = GaleriaIPubPeer::ID;
		}

		if ($this->aGaleriaI !== null && $this->aGaleriaI->getId() !== $v) {
			$this->aGaleriaI = null;
		}

		return $this;
	} 
	
	public function setUpdatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->updated_at !== null || $dt !== null ) {
			
			$currNorm = ($this->updated_at !== null && $tmpDt = new DateTime($this->updated_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->updated_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GaleriaIPubPeer::UPDATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GaleriaIPubPeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setKolejnosc($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->kolejnosc !== $v || $v === 0) {
			$this->kolejnosc = $v;
			$this->modifiedColumns[] = GaleriaIPubPeer::KOLEJNOSC;
		}

		return $this;
	} 
	
	public function setWidoczna($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->widoczna !== $v || $v === 0) {
			$this->widoczna = $v;
			$this->modifiedColumns[] = GaleriaIPubPeer::WIDOCZNA;
		}

		return $this;
	} 
	
	public function setObrazId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->obraz_id !== $v) {
			$this->obraz_id = $v;
			$this->modifiedColumns[] = GaleriaIPubPeer::OBRAZ_ID;
		}

		if ($this->aGiObrazPub !== null && $this->aGiObrazPub->getId() !== $v) {
			$this->aGiObrazPub = null;
		}

		return $this;
	} 
	
	public function setX($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->x !== $v) {
			$this->x = $v;
			$this->modifiedColumns[] = GaleriaIPubPeer::X;
		}

		return $this;
	} 
	
	public function setY($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->y !== $v) {
			$this->y = $v;
			$this->modifiedColumns[] = GaleriaIPubPeer::Y;
		}

		return $this;
	} 
	
	public function setZ($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->z !== $v) {
			$this->z = $v;
			$this->modifiedColumns[] = GaleriaIPubPeer::Z;
		}

		return $this;
	} 
	
	public function setUzytkownikDane($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->uzytkownik_dane !== $v) {
			$this->uzytkownik_dane = $v;
			$this->modifiedColumns[] = GaleriaIPubPeer::UZYTKOWNIK_DANE;
		}

		return $this;
	} 
	
	public function setUzytkownikKontakt($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->uzytkownik_kontakt !== $v || $v === '') {
			$this->uzytkownik_kontakt = $v;
			$this->modifiedColumns[] = GaleriaIPubPeer::UZYTKOWNIK_KONTAKT;
		}

		return $this;
	} 
	
	public function setOpublikowal($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->opublikowal !== $v || $v === 0) {
			$this->opublikowal = $v;
			$this->modifiedColumns[] = GaleriaIPubPeer::OPUBLIKOWAL;
		}

		if ($this->asfGuardUser !== null && $this->asfGuardUser->getId() !== $v) {
			$this->asfGuardUser = null;
		}

		return $this;
	} 
	
	public function setSubkategoriaId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->subkategoria_id !== $v) {
			$this->subkategoria_id = $v;
			$this->modifiedColumns[] = GaleriaIPubPeer::SUBKATEGORIA_ID;
		}

		if ($this->aGiSubkategoria !== null && $this->aGiSubkategoria->getId() !== $v) {
			$this->aGiSubkategoria = null;
		}

		return $this;
	} 
	
	public function setKomentarz($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->komentarz !== $v || $v === 1) {
			$this->komentarz = $v;
			$this->modifiedColumns[] = GaleriaIPubPeer::KOMENTARZ;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(GaleriaIPubPeer::ID,GaleriaIPubPeer::KOLEJNOSC,GaleriaIPubPeer::WIDOCZNA,GaleriaIPubPeer::UZYTKOWNIK_KONTAKT,GaleriaIPubPeer::OPUBLIKOWAL,GaleriaIPubPeer::KOMENTARZ))) {
				return false;
			}

			if ($this->id !== 0) {
				return false;
			}

			if ($this->kolejnosc !== 0) {
				return false;
			}

			if ($this->widoczna !== 0) {
				return false;
			}

			if ($this->uzytkownik_kontakt !== '') {
				return false;
			}

			if ($this->opublikowal !== 0) {
				return false;
			}

			if ($this->komentarz !== 1) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->updated_at = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->created_at = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->kolejnosc = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->widoczna = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->obraz_id = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
			$this->x = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->y = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->z = ($row[$startcol + 8] !== null) ? (int) $row[$startcol + 8] : null;
			$this->uzytkownik_dane = ($row[$startcol + 9] !== null) ? (string) $row[$startcol + 9] : null;
			$this->uzytkownik_kontakt = ($row[$startcol + 10] !== null) ? (string) $row[$startcol + 10] : null;
			$this->opublikowal = ($row[$startcol + 11] !== null) ? (int) $row[$startcol + 11] : null;
			$this->subkategoria_id = ($row[$startcol + 12] !== null) ? (int) $row[$startcol + 12] : null;
			$this->komentarz = ($row[$startcol + 13] !== null) ? (int) $row[$startcol + 13] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 14; 
		} catch (Exception $e) {
			throw new PropelException("Error populating GaleriaIPub object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aGaleriaI !== null && $this->id !== $this->aGaleriaI->getId()) {
			$this->aGaleriaI = null;
		}
		if ($this->aGiObrazPub !== null && $this->obraz_id !== $this->aGiObrazPub->getId()) {
			$this->aGiObrazPub = null;
		}
		if ($this->asfGuardUser !== null && $this->opublikowal !== $this->asfGuardUser->getId()) {
			$this->asfGuardUser = null;
		}
		if ($this->aGiSubkategoria !== null && $this->subkategoria_id !== $this->aGiSubkategoria->getId()) {
			$this->aGiSubkategoria = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GaleriaIPubPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = GaleriaIPubPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aGaleriaI = null;
			$this->aGiObrazPub = null;
			$this->asfGuardUser = null;
			$this->aGiSubkategoria = null;
			$this->collGaleriaIPubI18ns = null;
			$this->lastGaleriaIPubI18nCriteria = null;

			$this->singleGiRank = null;

			$this->collGiStats = null;
			$this->lastGiStatCriteria = null;

			$this->collGiObrazPubs = null;
			$this->lastGiObrazPubCriteria = null;

			$this->collNewsboxs = null;
			$this->lastNewsboxCriteria = null;

		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GaleriaIPubPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			GaleriaIPubPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isModified() && !$this->isColumnModified(GaleriaIPubPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

    if ($this->isNew() && !$this->isColumnModified(GaleriaIPubPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GaleriaIPubPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			GaleriaIPubPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aGaleriaI !== null) {
				if ($this->aGaleriaI->isModified() || ($this->aGaleriaI->getCulture() && $this->aGaleriaI->getCurrentGaleriaII18n()->isModified()) || $this->aGaleriaI->isNew()) {
					$affectedRows += $this->aGaleriaI->save($con);
				}
				$this->setGaleriaI($this->aGaleriaI);
			}

			if ($this->aGiObrazPub !== null) {
				if ($this->aGiObrazPub->isModified() || ($this->aGiObrazPub->getCulture() && $this->aGiObrazPub->getCurrentGiObrazPubI18n()->isModified()) || $this->aGiObrazPub->isNew()) {
					$affectedRows += $this->aGiObrazPub->save($con);
				}
				$this->setGiObrazPub($this->aGiObrazPub);
			}

			if ($this->asfGuardUser !== null) {
				if ($this->asfGuardUser->isModified() || $this->asfGuardUser->isNew()) {
					$affectedRows += $this->asfGuardUser->save($con);
				}
				$this->setsfGuardUser($this->asfGuardUser);
			}

			if ($this->aGiSubkategoria !== null) {
				if ($this->aGiSubkategoria->isModified() || ($this->aGiSubkategoria->getCulture() && $this->aGiSubkategoria->getCurrentGiSubkategoriaI18n()->isModified()) || $this->aGiSubkategoria->isNew()) {
					$affectedRows += $this->aGiSubkategoria->save($con);
				}
				$this->setGiSubkategoria($this->aGiSubkategoria);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = GaleriaIPubPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += GaleriaIPubPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			if ($this->collGaleriaIPubI18ns !== null) {
				foreach ($this->collGaleriaIPubI18ns as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->singleGiRank !== null) {
				if (!$this->singleGiRank->isDeleted()) {
						$affectedRows += $this->singleGiRank->save($con);
				}
			}

			if ($this->collGiStats !== null) {
				foreach ($this->collGiStats as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collGiObrazPubs !== null) {
				foreach ($this->collGiObrazPubs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collNewsboxs !== null) {
				foreach ($this->collNewsboxs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aGaleriaI !== null) {
				if (!$this->aGaleriaI->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aGaleriaI->getValidationFailures());
				}
			}

			if ($this->aGiObrazPub !== null) {
				if (!$this->aGiObrazPub->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aGiObrazPub->getValidationFailures());
				}
			}

			if ($this->asfGuardUser !== null) {
				if (!$this->asfGuardUser->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->asfGuardUser->getValidationFailures());
				}
			}

			if ($this->aGiSubkategoria !== null) {
				if (!$this->aGiSubkategoria->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aGiSubkategoria->getValidationFailures());
				}
			}


			if (($retval = GaleriaIPubPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collGaleriaIPubI18ns !== null) {
					foreach ($this->collGaleriaIPubI18ns as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->singleGiRank !== null) {
					if (!$this->singleGiRank->validate($columns)) {
						$failureMap = array_merge($failureMap, $this->singleGiRank->getValidationFailures());
					}
				}

				if ($this->collGiStats !== null) {
					foreach ($this->collGiStats as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collGiObrazPubs !== null) {
					foreach ($this->collGiObrazPubs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collNewsboxs !== null) {
					foreach ($this->collNewsboxs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GaleriaIPubPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getUpdatedAt();
				break;
			case 2:
				return $this->getCreatedAt();
				break;
			case 3:
				return $this->getKolejnosc();
				break;
			case 4:
				return $this->getWidoczna();
				break;
			case 5:
				return $this->getObrazId();
				break;
			case 6:
				return $this->getX();
				break;
			case 7:
				return $this->getY();
				break;
			case 8:
				return $this->getZ();
				break;
			case 9:
				return $this->getUzytkownikDane();
				break;
			case 10:
				return $this->getUzytkownikKontakt();
				break;
			case 11:
				return $this->getOpublikowal();
				break;
			case 12:
				return $this->getSubkategoriaId();
				break;
			case 13:
				return $this->getKomentarz();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = GaleriaIPubPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getUpdatedAt(),
			$keys[2] => $this->getCreatedAt(),
			$keys[3] => $this->getKolejnosc(),
			$keys[4] => $this->getWidoczna(),
			$keys[5] => $this->getObrazId(),
			$keys[6] => $this->getX(),
			$keys[7] => $this->getY(),
			$keys[8] => $this->getZ(),
			$keys[9] => $this->getUzytkownikDane(),
			$keys[10] => $this->getUzytkownikKontakt(),
			$keys[11] => $this->getOpublikowal(),
			$keys[12] => $this->getSubkategoriaId(),
			$keys[13] => $this->getKomentarz(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GaleriaIPubPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setUpdatedAt($value);
				break;
			case 2:
				$this->setCreatedAt($value);
				break;
			case 3:
				$this->setKolejnosc($value);
				break;
			case 4:
				$this->setWidoczna($value);
				break;
			case 5:
				$this->setObrazId($value);
				break;
			case 6:
				$this->setX($value);
				break;
			case 7:
				$this->setY($value);
				break;
			case 8:
				$this->setZ($value);
				break;
			case 9:
				$this->setUzytkownikDane($value);
				break;
			case 10:
				$this->setUzytkownikKontakt($value);
				break;
			case 11:
				$this->setOpublikowal($value);
				break;
			case 12:
				$this->setSubkategoriaId($value);
				break;
			case 13:
				$this->setKomentarz($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = GaleriaIPubPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setUpdatedAt($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setCreatedAt($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setKolejnosc($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setWidoczna($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setObrazId($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setX($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setY($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setZ($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setUzytkownikDane($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setUzytkownikKontakt($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setOpublikowal($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setSubkategoriaId($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setKomentarz($arr[$keys[13]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);

		if ($this->isColumnModified(GaleriaIPubPeer::ID)) $criteria->add(GaleriaIPubPeer::ID, $this->id);
		if ($this->isColumnModified(GaleriaIPubPeer::UPDATED_AT)) $criteria->add(GaleriaIPubPeer::UPDATED_AT, $this->updated_at);
		if ($this->isColumnModified(GaleriaIPubPeer::CREATED_AT)) $criteria->add(GaleriaIPubPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(GaleriaIPubPeer::KOLEJNOSC)) $criteria->add(GaleriaIPubPeer::KOLEJNOSC, $this->kolejnosc);
		if ($this->isColumnModified(GaleriaIPubPeer::WIDOCZNA)) $criteria->add(GaleriaIPubPeer::WIDOCZNA, $this->widoczna);
		if ($this->isColumnModified(GaleriaIPubPeer::OBRAZ_ID)) $criteria->add(GaleriaIPubPeer::OBRAZ_ID, $this->obraz_id);
		if ($this->isColumnModified(GaleriaIPubPeer::X)) $criteria->add(GaleriaIPubPeer::X, $this->x);
		if ($this->isColumnModified(GaleriaIPubPeer::Y)) $criteria->add(GaleriaIPubPeer::Y, $this->y);
		if ($this->isColumnModified(GaleriaIPubPeer::Z)) $criteria->add(GaleriaIPubPeer::Z, $this->z);
		if ($this->isColumnModified(GaleriaIPubPeer::UZYTKOWNIK_DANE)) $criteria->add(GaleriaIPubPeer::UZYTKOWNIK_DANE, $this->uzytkownik_dane);
		if ($this->isColumnModified(GaleriaIPubPeer::UZYTKOWNIK_KONTAKT)) $criteria->add(GaleriaIPubPeer::UZYTKOWNIK_KONTAKT, $this->uzytkownik_kontakt);
		if ($this->isColumnModified(GaleriaIPubPeer::OPUBLIKOWAL)) $criteria->add(GaleriaIPubPeer::OPUBLIKOWAL, $this->opublikowal);
		if ($this->isColumnModified(GaleriaIPubPeer::SUBKATEGORIA_ID)) $criteria->add(GaleriaIPubPeer::SUBKATEGORIA_ID, $this->subkategoria_id);
		if ($this->isColumnModified(GaleriaIPubPeer::KOMENTARZ)) $criteria->add(GaleriaIPubPeer::KOMENTARZ, $this->komentarz);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);

		$criteria->add(GaleriaIPubPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setId($this->id);

		$copyObj->setUpdatedAt($this->updated_at);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setKolejnosc($this->kolejnosc);

		$copyObj->setWidoczna($this->widoczna);

		$copyObj->setObrazId($this->obraz_id);

		$copyObj->setX($this->x);

		$copyObj->setY($this->y);

		$copyObj->setZ($this->z);

		$copyObj->setUzytkownikDane($this->uzytkownik_dane);

		$copyObj->setUzytkownikKontakt($this->uzytkownik_kontakt);

		$copyObj->setOpublikowal($this->opublikowal);

		$copyObj->setSubkategoriaId($this->subkategoria_id);

		$copyObj->setKomentarz($this->komentarz);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach ($this->getGaleriaIPubI18ns() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addGaleriaIPubI18n($relObj->copy($deepCopy));
				}
			}

			$relObj = $this->getGiRank();
			if ($relObj) {
				$copyObj->setGiRank($relObj->copy($deepCopy));
			}

			foreach ($this->getGiStats() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addGiStat($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getGiObrazPubs() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addGiObrazPub($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getNewsboxs() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addNewsbox($relObj->copy($deepCopy));
				}
			}

		} 

		$copyObj->setNew(true);

	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new GaleriaIPubPeer();
		}
		return self::$peer;
	}

	
	public function setGaleriaI(GaleriaI $v = null)
	{
		if ($v === null) {
			$this->setId(0);
		} else {
			$this->setId($v->getId());
		}

		$this->aGaleriaI = $v;

				if ($v !== null) {
			$v->setGaleriaIPub($this);
		}

		return $this;
	}


	
	public function getGaleriaI(PropelPDO $con = null)
	{
		if ($this->aGaleriaI === null && ($this->id !== null)) {
			$c = new Criteria(GaleriaIPeer::DATABASE_NAME);
			$c->add(GaleriaIPeer::ID, $this->id);
			$this->aGaleriaI = GaleriaIPeer::doSelectOne($c, $con);
						$this->aGaleriaI->setGaleriaIPub($this);
		}
		return $this->aGaleriaI;
	}

	
	public function setGiObrazPub(GiObrazPub $v = null)
	{
		if ($v === null) {
			$this->setObrazId(NULL);
		} else {
			$this->setObrazId($v->getId());
		}

		$this->aGiObrazPub = $v;

						if ($v !== null) {
			$v->addGaleriaIPub($this);
		}

		return $this;
	}


	
	public function getGiObrazPub(PropelPDO $con = null)
	{
		if ($this->aGiObrazPub === null && ($this->obraz_id !== null)) {
			$c = new Criteria(GiObrazPubPeer::DATABASE_NAME);
			$c->add(GiObrazPubPeer::ID, $this->obraz_id);
			$this->aGiObrazPub = GiObrazPubPeer::doSelectOne($c, $con);
			
		}
		return $this->aGiObrazPub;
	}

	
	public function setsfGuardUser(sfGuardUser $v = null)
	{
		if ($v === null) {
			$this->setOpublikowal(0);
		} else {
			$this->setOpublikowal($v->getId());
		}

		$this->asfGuardUser = $v;

						if ($v !== null) {
			$v->addGaleriaIPub($this);
		}

		return $this;
	}


	
	public function getsfGuardUser(PropelPDO $con = null)
	{
		if ($this->asfGuardUser === null && ($this->opublikowal !== null)) {
			$c = new Criteria(sfGuardUserPeer::DATABASE_NAME);
			$c->add(sfGuardUserPeer::ID, $this->opublikowal);
			$this->asfGuardUser = sfGuardUserPeer::doSelectOne($c, $con);
			
		}
		return $this->asfGuardUser;
	}

	
	public function setGiSubkategoria(GiSubkategoria $v = null)
	{
		if ($v === null) {
			$this->setSubkategoriaId(NULL);
		} else {
			$this->setSubkategoriaId($v->getId());
		}

		$this->aGiSubkategoria = $v;

						if ($v !== null) {
			$v->addGaleriaIPub($this);
		}

		return $this;
	}


	
	public function getGiSubkategoria(PropelPDO $con = null)
	{
		if ($this->aGiSubkategoria === null && ($this->subkategoria_id !== null)) {
			$c = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);
			$c->add(GiSubkategoriaPeer::ID, $this->subkategoria_id);
			$this->aGiSubkategoria = GiSubkategoriaPeer::doSelectOne($c, $con);
			
		}
		return $this->aGiSubkategoria;
	}

	
	public function clearGaleriaIPubI18ns()
	{
		$this->collGaleriaIPubI18ns = null; 	}

	
	public function initGaleriaIPubI18ns()
	{
		$this->collGaleriaIPubI18ns = array();
	}

	
	public function getGaleriaIPubI18ns($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIPubI18ns === null) {
			if ($this->isNew()) {
			   $this->collGaleriaIPubI18ns = array();
			} else {

				$criteria->add(GaleriaIPubI18nPeer::ID, $this->id);

				GaleriaIPubI18nPeer::addSelectColumns($criteria);
				$this->collGaleriaIPubI18ns = GaleriaIPubI18nPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GaleriaIPubI18nPeer::ID, $this->id);

				GaleriaIPubI18nPeer::addSelectColumns($criteria);
				if (!isset($this->lastGaleriaIPubI18nCriteria) || !$this->lastGaleriaIPubI18nCriteria->equals($criteria)) {
					$this->collGaleriaIPubI18ns = GaleriaIPubI18nPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGaleriaIPubI18nCriteria = $criteria;
		return $this->collGaleriaIPubI18ns;
	}

	
	public function countGaleriaIPubI18ns(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGaleriaIPubI18ns === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GaleriaIPubI18nPeer::ID, $this->id);

				$count = GaleriaIPubI18nPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GaleriaIPubI18nPeer::ID, $this->id);

				if (!isset($this->lastGaleriaIPubI18nCriteria) || !$this->lastGaleriaIPubI18nCriteria->equals($criteria)) {
					$count = GaleriaIPubI18nPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGaleriaIPubI18ns);
				}
			} else {
				$count = count($this->collGaleriaIPubI18ns);
			}
		}
		return $count;
	}

	
	public function addGaleriaIPubI18n(GaleriaIPubI18n $l)
	{
		if ($this->collGaleriaIPubI18ns === null) {
			$this->initGaleriaIPubI18ns();
		}
		if (!in_array($l, $this->collGaleriaIPubI18ns, true)) { 			array_push($this->collGaleriaIPubI18ns, $l);
			$l->setGaleriaIPub($this);
		}
	}

	
	public function getGiRank(PropelPDO $con = null)
	{

		if ($this->singleGiRank === null && !$this->isNew()) {
			$this->singleGiRank = GiRankPeer::retrieveByPK($this->id, $con);
		}

		return $this->singleGiRank;
	}

	
	public function setGiRank(GiRank $v)
	{
		$this->singleGiRank = $v;

				if ($v->getGaleriaIPub() === null) {
			$v->setGaleriaIPub($this);
		}

		return $this;
	}

	
	public function clearGiStats()
	{
		$this->collGiStats = null; 	}

	
	public function initGiStats()
	{
		$this->collGiStats = array();
	}

	
	public function getGiStats($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGiStats === null) {
			if ($this->isNew()) {
			   $this->collGiStats = array();
			} else {

				$criteria->add(GiStatPeer::GALERIA_ID, $this->id);

				GiStatPeer::addSelectColumns($criteria);
				$this->collGiStats = GiStatPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiStatPeer::GALERIA_ID, $this->id);

				GiStatPeer::addSelectColumns($criteria);
				if (!isset($this->lastGiStatCriteria) || !$this->lastGiStatCriteria->equals($criteria)) {
					$this->collGiStats = GiStatPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGiStatCriteria = $criteria;
		return $this->collGiStats;
	}

	
	public function countGiStats(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGiStats === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GiStatPeer::GALERIA_ID, $this->id);

				$count = GiStatPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiStatPeer::GALERIA_ID, $this->id);

				if (!isset($this->lastGiStatCriteria) || !$this->lastGiStatCriteria->equals($criteria)) {
					$count = GiStatPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGiStats);
				}
			} else {
				$count = count($this->collGiStats);
			}
		}
		return $count;
	}

	
	public function addGiStat(GiStat $l)
	{
		if ($this->collGiStats === null) {
			$this->initGiStats();
		}
		if (!in_array($l, $this->collGiStats, true)) { 			array_push($this->collGiStats, $l);
			$l->setGaleriaIPub($this);
		}
	}

	
	public function clearGiObrazPubs()
	{
		$this->collGiObrazPubs = null; 	}

	
	public function initGiObrazPubs()
	{
		$this->collGiObrazPubs = array();
	}

	
	public function getGiObrazPubs($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGiObrazPubs === null) {
			if ($this->isNew()) {
			   $this->collGiObrazPubs = array();
			} else {

				$criteria->add(GiObrazPubPeer::GALERIA_ID, $this->id);

				GiObrazPubPeer::addSelectColumns($criteria);
				$this->collGiObrazPubs = GiObrazPubPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiObrazPubPeer::GALERIA_ID, $this->id);

				GiObrazPubPeer::addSelectColumns($criteria);
				if (!isset($this->lastGiObrazPubCriteria) || !$this->lastGiObrazPubCriteria->equals($criteria)) {
					$this->collGiObrazPubs = GiObrazPubPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGiObrazPubCriteria = $criteria;
		return $this->collGiObrazPubs;
	}

	
	public function countGiObrazPubs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGiObrazPubs === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GiObrazPubPeer::GALERIA_ID, $this->id);

				$count = GiObrazPubPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiObrazPubPeer::GALERIA_ID, $this->id);

				if (!isset($this->lastGiObrazPubCriteria) || !$this->lastGiObrazPubCriteria->equals($criteria)) {
					$count = GiObrazPubPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGiObrazPubs);
				}
			} else {
				$count = count($this->collGiObrazPubs);
			}
		}
		return $count;
	}

	
	public function addGiObrazPub(GiObrazPub $l)
	{
		if ($this->collGiObrazPubs === null) {
			$this->initGiObrazPubs();
		}
		if (!in_array($l, $this->collGiObrazPubs, true)) { 			array_push($this->collGiObrazPubs, $l);
			$l->setGaleriaIPub($this);
		}
	}

	
	public function clearNewsboxs()
	{
		$this->collNewsboxs = null; 	}

	
	public function initNewsboxs()
	{
		$this->collNewsboxs = array();
	}

	
	public function getNewsboxs($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNewsboxs === null) {
			if ($this->isNew()) {
			   $this->collNewsboxs = array();
			} else {

				$criteria->add(NewsboxPeer::GALI_ID, $this->id);

				NewsboxPeer::addSelectColumns($criteria);
				$this->collNewsboxs = NewsboxPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(NewsboxPeer::GALI_ID, $this->id);

				NewsboxPeer::addSelectColumns($criteria);
				if (!isset($this->lastNewsboxCriteria) || !$this->lastNewsboxCriteria->equals($criteria)) {
					$this->collNewsboxs = NewsboxPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastNewsboxCriteria = $criteria;
		return $this->collNewsboxs;
	}

	
	public function countNewsboxs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collNewsboxs === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(NewsboxPeer::GALI_ID, $this->id);

				$count = NewsboxPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(NewsboxPeer::GALI_ID, $this->id);

				if (!isset($this->lastNewsboxCriteria) || !$this->lastNewsboxCriteria->equals($criteria)) {
					$count = NewsboxPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collNewsboxs);
				}
			} else {
				$count = count($this->collNewsboxs);
			}
		}
		return $count;
	}

	
	public function addNewsbox(Newsbox $l)
	{
		if ($this->collNewsboxs === null) {
			$this->initNewsboxs();
		}
		if (!in_array($l, $this->collNewsboxs, true)) { 			array_push($this->collNewsboxs, $l);
			$l->setGaleriaIPub($this);
		}
	}


	
	public function getNewsboxsJoinPortal($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNewsboxs === null) {
			if ($this->isNew()) {
				$this->collNewsboxs = array();
			} else {

				$criteria->add(NewsboxPeer::GALI_ID, $this->id);

				$this->collNewsboxs = NewsboxPeer::doSelectJoinPortal($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(NewsboxPeer::GALI_ID, $this->id);

			if (!isset($this->lastNewsboxCriteria) || !$this->lastNewsboxCriteria->equals($criteria)) {
				$this->collNewsboxs = NewsboxPeer::doSelectJoinPortal($criteria, $con, $join_behavior);
			}
		}
		$this->lastNewsboxCriteria = $criteria;

		return $this->collNewsboxs;
	}


	
	public function getNewsboxsJoinAktualnoscPub($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNewsboxs === null) {
			if ($this->isNew()) {
				$this->collNewsboxs = array();
			} else {

				$criteria->add(NewsboxPeer::GALI_ID, $this->id);

				$this->collNewsboxs = NewsboxPeer::doSelectJoinAktualnoscPub($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(NewsboxPeer::GALI_ID, $this->id);

			if (!isset($this->lastNewsboxCriteria) || !$this->lastNewsboxCriteria->equals($criteria)) {
				$this->collNewsboxs = NewsboxPeer::doSelectJoinAktualnoscPub($criteria, $con, $join_behavior);
			}
		}
		$this->lastNewsboxCriteria = $criteria;

		return $this->collNewsboxs;
	}


	
	public function getNewsboxsJoinImprezaPub($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNewsboxs === null) {
			if ($this->isNew()) {
				$this->collNewsboxs = array();
			} else {

				$criteria->add(NewsboxPeer::GALI_ID, $this->id);

				$this->collNewsboxs = NewsboxPeer::doSelectJoinImprezaPub($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(NewsboxPeer::GALI_ID, $this->id);

			if (!isset($this->lastNewsboxCriteria) || !$this->lastNewsboxCriteria->equals($criteria)) {
				$this->collNewsboxs = NewsboxPeer::doSelectJoinImprezaPub($criteria, $con, $join_behavior);
			}
		}
		$this->lastNewsboxCriteria = $criteria;

		return $this->collNewsboxs;
	}


	
	public function getNewsboxsJoinStronyPub($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNewsboxs === null) {
			if ($this->isNew()) {
				$this->collNewsboxs = array();
			} else {

				$criteria->add(NewsboxPeer::GALI_ID, $this->id);

				$this->collNewsboxs = NewsboxPeer::doSelectJoinStronyPub($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(NewsboxPeer::GALI_ID, $this->id);

			if (!isset($this->lastNewsboxCriteria) || !$this->lastNewsboxCriteria->equals($criteria)) {
				$this->collNewsboxs = NewsboxPeer::doSelectJoinStronyPub($criteria, $con, $join_behavior);
			}
		}
		$this->lastNewsboxCriteria = $criteria;

		return $this->collNewsboxs;
	}


	
	public function getNewsboxsJoinGalpGaleriaPub($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNewsboxs === null) {
			if ($this->isNew()) {
				$this->collNewsboxs = array();
			} else {

				$criteria->add(NewsboxPeer::GALI_ID, $this->id);

				$this->collNewsboxs = NewsboxPeer::doSelectJoinGalpGaleriaPub($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(NewsboxPeer::GALI_ID, $this->id);

			if (!isset($this->lastNewsboxCriteria) || !$this->lastNewsboxCriteria->equals($criteria)) {
				$this->collNewsboxs = NewsboxPeer::doSelectJoinGalpGaleriaPub($criteria, $con, $join_behavior);
			}
		}
		$this->lastNewsboxCriteria = $criteria;

		return $this->collNewsboxs;
	}


	
	public function getNewsboxsJoinMultimediaPub($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNewsboxs === null) {
			if ($this->isNew()) {
				$this->collNewsboxs = array();
			} else {

				$criteria->add(NewsboxPeer::GALI_ID, $this->id);

				$this->collNewsboxs = NewsboxPeer::doSelectJoinMultimediaPub($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(NewsboxPeer::GALI_ID, $this->id);

			if (!isset($this->lastNewsboxCriteria) || !$this->lastNewsboxCriteria->equals($criteria)) {
				$this->collNewsboxs = NewsboxPeer::doSelectJoinMultimediaPub($criteria, $con, $join_behavior);
			}
		}
		$this->lastNewsboxCriteria = $criteria;

		return $this->collNewsboxs;
	}


	
	public function getNewsboxsJoinIobiektPub($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNewsboxs === null) {
			if ($this->isNew()) {
				$this->collNewsboxs = array();
			} else {

				$criteria->add(NewsboxPeer::GALI_ID, $this->id);

				$this->collNewsboxs = NewsboxPeer::doSelectJoinIobiektPub($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(NewsboxPeer::GALI_ID, $this->id);

			if (!isset($this->lastNewsboxCriteria) || !$this->lastNewsboxCriteria->equals($criteria)) {
				$this->collNewsboxs = NewsboxPeer::doSelectJoinIobiektPub($criteria, $con, $join_behavior);
			}
		}
		$this->lastNewsboxCriteria = $criteria;

		return $this->collNewsboxs;
	}


	
	public function getNewsboxsJoinOfertyinwestycyjnePub($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNewsboxs === null) {
			if ($this->isNew()) {
				$this->collNewsboxs = array();
			} else {

				$criteria->add(NewsboxPeer::GALI_ID, $this->id);

				$this->collNewsboxs = NewsboxPeer::doSelectJoinOfertyinwestycyjnePub($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(NewsboxPeer::GALI_ID, $this->id);

			if (!isset($this->lastNewsboxCriteria) || !$this->lastNewsboxCriteria->equals($criteria)) {
				$this->collNewsboxs = NewsboxPeer::doSelectJoinOfertyinwestycyjnePub($criteria, $con, $join_behavior);
			}
		}
		$this->lastNewsboxCriteria = $criteria;

		return $this->collNewsboxs;
	}


	
	public function getNewsboxsJoinEpublikacjePub($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNewsboxs === null) {
			if ($this->isNew()) {
				$this->collNewsboxs = array();
			} else {

				$criteria->add(NewsboxPeer::GALI_ID, $this->id);

				$this->collNewsboxs = NewsboxPeer::doSelectJoinEpublikacjePub($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(NewsboxPeer::GALI_ID, $this->id);

			if (!isset($this->lastNewsboxCriteria) || !$this->lastNewsboxCriteria->equals($criteria)) {
				$this->collNewsboxs = NewsboxPeer::doSelectJoinEpublikacjePub($criteria, $con, $join_behavior);
			}
		}
		$this->lastNewsboxCriteria = $criteria;

		return $this->collNewsboxs;
	}


	
	public function getNewsboxsJoinInwestycjeObiektPub($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNewsboxs === null) {
			if ($this->isNew()) {
				$this->collNewsboxs = array();
			} else {

				$criteria->add(NewsboxPeer::GALI_ID, $this->id);

				$this->collNewsboxs = NewsboxPeer::doSelectJoinInwestycjeObiektPub($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(NewsboxPeer::GALI_ID, $this->id);

			if (!isset($this->lastNewsboxCriteria) || !$this->lastNewsboxCriteria->equals($criteria)) {
				$this->collNewsboxs = NewsboxPeer::doSelectJoinInwestycjeObiektPub($criteria, $con, $join_behavior);
			}
		}
		$this->lastNewsboxCriteria = $criteria;

		return $this->collNewsboxs;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collGaleriaIPubI18ns) {
				foreach ((array) $this->collGaleriaIPubI18ns as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->singleGiRank) {
				$this->singleGiRank->clearAllReferences($deep);
			}
			if ($this->collGiStats) {
				foreach ((array) $this->collGiStats as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collGiObrazPubs) {
				foreach ((array) $this->collGiObrazPubs as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collNewsboxs) {
				foreach ((array) $this->collNewsboxs as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} 
		$this->collGaleriaIPubI18ns = null;
		$this->singleGiRank = null;
		$this->collGiStats = null;
		$this->collGiObrazPubs = null;
		$this->collNewsboxs = null;
			$this->aGaleriaI = null;
			$this->aGiObrazPub = null;
			$this->asfGuardUser = null;
			$this->aGiSubkategoria = null;
	}


  
  public function getCulture()
  {
    return $this->culture;
  }

  
  public function setCulture($culture)
  {
    $this->culture = $culture;
  }

  public function getZajawka($culture = null)
  {
    return $this->getCurrentGaleriaIPubI18n($culture)->getZajawka();
  }

  public function setZajawka($value, $culture = null)
  {
    $this->getCurrentGaleriaIPubI18n($culture)->setZajawka($value);
  }

  public function getTytul($culture = null)
  {
    return $this->getCurrentGaleriaIPubI18n($culture)->getTytul();
  }

  public function setTytul($value, $culture = null)
  {
    $this->getCurrentGaleriaIPubI18n($culture)->setTytul($value);
  }

  protected $current_i18n = array();

  public function getCurrentGaleriaIPubI18n($culture = null)
  {
    if (is_null($culture))
    {
      $culture = is_null($this->culture) ? sfPropel::getDefaultCulture() : $this->culture;
    }

    if (!isset($this->current_i18n[$culture]))
    {
      $obj = $this->isNew() ? null : GaleriaIPubI18nPeer::retrieveByPK($this->getId(), $culture);
      if ($obj)
      {
        $this->setGaleriaIPubI18nForCulture($obj, $culture);
      }
      else
      {
        $this->setGaleriaIPubI18nForCulture(new GaleriaIPubI18n(), $culture);
        $this->current_i18n[$culture]->setCulture($culture);
      }
    }

    return $this->current_i18n[$culture];
  }

  public function setGaleriaIPubI18nForCulture($object, $culture)
  {
    $this->current_i18n[$culture] = $object;
    $this->addGaleriaIPubI18n($object);
  }

} 