<?php


abstract class BaseGiObrazPub extends BaseObject  implements Persistent {


  const PEER = 'GiObrazPubPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $created_at;

	
	protected $updated_at;

	
	protected $nazwa_pliku;

	
	protected $tytul;

	
	protected $kolejnosc;

	
	protected $galeria_id;

	
	protected $exif_data;

	
	protected $aGaleriaIPub;

	
	protected $collGaleriaIPubs;

	
	private $lastGaleriaIPubCriteria = null;

	
	protected $collGiObrazPubI18ns;

	
	private $lastGiObrazPubI18nCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

  
  protected $culture;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->id = 0;
		$this->nazwa_pliku = '';
		$this->tytul = '';
		$this->kolejnosc = 0;
		$this->galeria_id = 0;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->updated_at === null) {
			return null;
		}


		if ($this->updated_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->updated_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->updated_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getNazwaPliku()
	{
		return $this->nazwa_pliku;
	}

	
	public function getTytul()
	{
		return $this->tytul;
	}

	
	public function getKolejnosc()
	{
		return $this->kolejnosc;
	}

	
	public function getGaleriaId()
	{
		return $this->galeria_id;
	}

	
	public function getExifData($format = 'Y-m-d H:i:s')
	{
		if ($this->exif_data === null) {
			return null;
		}


		if ($this->exif_data === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->exif_data);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->exif_data, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v || $v === 0) {
			$this->id = $v;
			$this->modifiedColumns[] = GiObrazPubPeer::ID;
		}

		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GiObrazPubPeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setUpdatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->updated_at !== null || $dt !== null ) {
			
			$currNorm = ($this->updated_at !== null && $tmpDt = new DateTime($this->updated_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->updated_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GiObrazPubPeer::UPDATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setNazwaPliku($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->nazwa_pliku !== $v || $v === '') {
			$this->nazwa_pliku = $v;
			$this->modifiedColumns[] = GiObrazPubPeer::NAZWA_PLIKU;
		}

		return $this;
	} 
	
	public function setTytul($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->tytul !== $v || $v === '') {
			$this->tytul = $v;
			$this->modifiedColumns[] = GiObrazPubPeer::TYTUL;
		}

		return $this;
	} 
	
	public function setKolejnosc($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->kolejnosc !== $v || $v === 0) {
			$this->kolejnosc = $v;
			$this->modifiedColumns[] = GiObrazPubPeer::KOLEJNOSC;
		}

		return $this;
	} 
	
	public function setGaleriaId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->galeria_id !== $v || $v === 0) {
			$this->galeria_id = $v;
			$this->modifiedColumns[] = GiObrazPubPeer::GALERIA_ID;
		}

		if ($this->aGaleriaIPub !== null && $this->aGaleriaIPub->getId() !== $v) {
			$this->aGaleriaIPub = null;
		}

		return $this;
	} 
	
	public function setExifData($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->exif_data !== null || $dt !== null ) {
			
			$currNorm = ($this->exif_data !== null && $tmpDt = new DateTime($this->exif_data)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->exif_data = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GiObrazPubPeer::EXIF_DATA;
			}
		} 
		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(GiObrazPubPeer::ID,GiObrazPubPeer::NAZWA_PLIKU,GiObrazPubPeer::TYTUL,GiObrazPubPeer::KOLEJNOSC,GiObrazPubPeer::GALERIA_ID))) {
				return false;
			}

			if ($this->id !== 0) {
				return false;
			}

			if ($this->nazwa_pliku !== '') {
				return false;
			}

			if ($this->tytul !== '') {
				return false;
			}

			if ($this->kolejnosc !== 0) {
				return false;
			}

			if ($this->galeria_id !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->created_at = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->updated_at = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->nazwa_pliku = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->tytul = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->kolejnosc = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
			$this->galeria_id = ($row[$startcol + 6] !== null) ? (int) $row[$startcol + 6] : null;
			$this->exif_data = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 8; 
		} catch (Exception $e) {
			throw new PropelException("Error populating GiObrazPub object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aGaleriaIPub !== null && $this->galeria_id !== $this->aGaleriaIPub->getId()) {
			$this->aGaleriaIPub = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiObrazPubPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = GiObrazPubPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aGaleriaIPub = null;
			$this->collGaleriaIPubs = null;
			$this->lastGaleriaIPubCriteria = null;

			$this->collGiObrazPubI18ns = null;
			$this->lastGiObrazPubI18nCriteria = null;

		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiObrazPubPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			GiObrazPubPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isNew() && !$this->isColumnModified(GiObrazPubPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

    if ($this->isModified() && !$this->isColumnModified(GiObrazPubPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiObrazPubPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			GiObrazPubPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aGaleriaIPub !== null) {
				if ($this->aGaleriaIPub->isModified() || ($this->aGaleriaIPub->getCulture() && $this->aGaleriaIPub->getCurrentGaleriaIPubI18n()->isModified()) || $this->aGaleriaIPub->isNew()) {
					$affectedRows += $this->aGaleriaIPub->save($con);
				}
				$this->setGaleriaIPub($this->aGaleriaIPub);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = GiObrazPubPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += GiObrazPubPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			if ($this->collGaleriaIPubs !== null) {
				foreach ($this->collGaleriaIPubs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collGiObrazPubI18ns !== null) {
				foreach ($this->collGiObrazPubI18ns as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aGaleriaIPub !== null) {
				if (!$this->aGaleriaIPub->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aGaleriaIPub->getValidationFailures());
				}
			}


			if (($retval = GiObrazPubPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collGaleriaIPubs !== null) {
					foreach ($this->collGaleriaIPubs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collGiObrazPubI18ns !== null) {
					foreach ($this->collGiObrazPubI18ns as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GiObrazPubPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getCreatedAt();
				break;
			case 2:
				return $this->getUpdatedAt();
				break;
			case 3:
				return $this->getNazwaPliku();
				break;
			case 4:
				return $this->getTytul();
				break;
			case 5:
				return $this->getKolejnosc();
				break;
			case 6:
				return $this->getGaleriaId();
				break;
			case 7:
				return $this->getExifData();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = GiObrazPubPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getCreatedAt(),
			$keys[2] => $this->getUpdatedAt(),
			$keys[3] => $this->getNazwaPliku(),
			$keys[4] => $this->getTytul(),
			$keys[5] => $this->getKolejnosc(),
			$keys[6] => $this->getGaleriaId(),
			$keys[7] => $this->getExifData(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GiObrazPubPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setCreatedAt($value);
				break;
			case 2:
				$this->setUpdatedAt($value);
				break;
			case 3:
				$this->setNazwaPliku($value);
				break;
			case 4:
				$this->setTytul($value);
				break;
			case 5:
				$this->setKolejnosc($value);
				break;
			case 6:
				$this->setGaleriaId($value);
				break;
			case 7:
				$this->setExifData($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = GiObrazPubPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setCreatedAt($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setUpdatedAt($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setNazwaPliku($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setTytul($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setKolejnosc($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setGaleriaId($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setExifData($arr[$keys[7]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(GiObrazPubPeer::DATABASE_NAME);

		if ($this->isColumnModified(GiObrazPubPeer::ID)) $criteria->add(GiObrazPubPeer::ID, $this->id);
		if ($this->isColumnModified(GiObrazPubPeer::CREATED_AT)) $criteria->add(GiObrazPubPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(GiObrazPubPeer::UPDATED_AT)) $criteria->add(GiObrazPubPeer::UPDATED_AT, $this->updated_at);
		if ($this->isColumnModified(GiObrazPubPeer::NAZWA_PLIKU)) $criteria->add(GiObrazPubPeer::NAZWA_PLIKU, $this->nazwa_pliku);
		if ($this->isColumnModified(GiObrazPubPeer::TYTUL)) $criteria->add(GiObrazPubPeer::TYTUL, $this->tytul);
		if ($this->isColumnModified(GiObrazPubPeer::KOLEJNOSC)) $criteria->add(GiObrazPubPeer::KOLEJNOSC, $this->kolejnosc);
		if ($this->isColumnModified(GiObrazPubPeer::GALERIA_ID)) $criteria->add(GiObrazPubPeer::GALERIA_ID, $this->galeria_id);
		if ($this->isColumnModified(GiObrazPubPeer::EXIF_DATA)) $criteria->add(GiObrazPubPeer::EXIF_DATA, $this->exif_data);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(GiObrazPubPeer::DATABASE_NAME);

		$criteria->add(GiObrazPubPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setId($this->id);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setUpdatedAt($this->updated_at);

		$copyObj->setNazwaPliku($this->nazwa_pliku);

		$copyObj->setTytul($this->tytul);

		$copyObj->setKolejnosc($this->kolejnosc);

		$copyObj->setGaleriaId($this->galeria_id);

		$copyObj->setExifData($this->exif_data);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach ($this->getGaleriaIPubs() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addGaleriaIPub($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getGiObrazPubI18ns() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addGiObrazPubI18n($relObj->copy($deepCopy));
				}
			}

		} 

		$copyObj->setNew(true);

	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new GiObrazPubPeer();
		}
		return self::$peer;
	}

	
	public function setGaleriaIPub(GaleriaIPub $v = null)
	{
		if ($v === null) {
			$this->setGaleriaId(0);
		} else {
			$this->setGaleriaId($v->getId());
		}

		$this->aGaleriaIPub = $v;

						if ($v !== null) {
			$v->addGiObrazPub($this);
		}

		return $this;
	}


	
	public function getGaleriaIPub(PropelPDO $con = null)
	{
		if ($this->aGaleriaIPub === null && ($this->galeria_id !== null)) {
			$c = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
			$c->add(GaleriaIPubPeer::ID, $this->galeria_id);
			$this->aGaleriaIPub = GaleriaIPubPeer::doSelectOne($c, $con);
			
		}
		return $this->aGaleriaIPub;
	}

	
	public function clearGaleriaIPubs()
	{
		$this->collGaleriaIPubs = null; 	}

	
	public function initGaleriaIPubs()
	{
		$this->collGaleriaIPubs = array();
	}

	
	public function getGaleriaIPubs($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiObrazPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIPubs === null) {
			if ($this->isNew()) {
			   $this->collGaleriaIPubs = array();
			} else {

				$criteria->add(GaleriaIPubPeer::OBRAZ_ID, $this->id);

				GaleriaIPubPeer::addSelectColumns($criteria);
				$this->collGaleriaIPubs = GaleriaIPubPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GaleriaIPubPeer::OBRAZ_ID, $this->id);

				GaleriaIPubPeer::addSelectColumns($criteria);
				if (!isset($this->lastGaleriaIPubCriteria) || !$this->lastGaleriaIPubCriteria->equals($criteria)) {
					$this->collGaleriaIPubs = GaleriaIPubPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGaleriaIPubCriteria = $criteria;
		return $this->collGaleriaIPubs;
	}

	
	public function countGaleriaIPubs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiObrazPubPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGaleriaIPubs === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GaleriaIPubPeer::OBRAZ_ID, $this->id);

				$count = GaleriaIPubPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GaleriaIPubPeer::OBRAZ_ID, $this->id);

				if (!isset($this->lastGaleriaIPubCriteria) || !$this->lastGaleriaIPubCriteria->equals($criteria)) {
					$count = GaleriaIPubPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGaleriaIPubs);
				}
			} else {
				$count = count($this->collGaleriaIPubs);
			}
		}
		return $count;
	}

	
	public function addGaleriaIPub(GaleriaIPub $l)
	{
		if ($this->collGaleriaIPubs === null) {
			$this->initGaleriaIPubs();
		}
		if (!in_array($l, $this->collGaleriaIPubs, true)) { 			array_push($this->collGaleriaIPubs, $l);
			$l->setGiObrazPub($this);
		}
	}


	
	public function getGaleriaIPubsJoinGaleriaI($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiObrazPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIPubs === null) {
			if ($this->isNew()) {
				$this->collGaleriaIPubs = array();
			} else {

				$criteria->add(GaleriaIPubPeer::OBRAZ_ID, $this->id);

				$this->collGaleriaIPubs = GaleriaIPubPeer::doSelectJoinGaleriaI($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(GaleriaIPubPeer::OBRAZ_ID, $this->id);

			if (!isset($this->lastGaleriaIPubCriteria) || !$this->lastGaleriaIPubCriteria->equals($criteria)) {
				$this->collGaleriaIPubs = GaleriaIPubPeer::doSelectJoinGaleriaI($criteria, $con, $join_behavior);
			}
		}
		$this->lastGaleriaIPubCriteria = $criteria;

		return $this->collGaleriaIPubs;
	}


	
	public function getGaleriaIPubsJoinsfGuardUser($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiObrazPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIPubs === null) {
			if ($this->isNew()) {
				$this->collGaleriaIPubs = array();
			} else {

				$criteria->add(GaleriaIPubPeer::OBRAZ_ID, $this->id);

				$this->collGaleriaIPubs = GaleriaIPubPeer::doSelectJoinsfGuardUser($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(GaleriaIPubPeer::OBRAZ_ID, $this->id);

			if (!isset($this->lastGaleriaIPubCriteria) || !$this->lastGaleriaIPubCriteria->equals($criteria)) {
				$this->collGaleriaIPubs = GaleriaIPubPeer::doSelectJoinsfGuardUser($criteria, $con, $join_behavior);
			}
		}
		$this->lastGaleriaIPubCriteria = $criteria;

		return $this->collGaleriaIPubs;
	}


	
	public function getGaleriaIPubsJoinGiSubkategoria($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiObrazPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIPubs === null) {
			if ($this->isNew()) {
				$this->collGaleriaIPubs = array();
			} else {

				$criteria->add(GaleriaIPubPeer::OBRAZ_ID, $this->id);

				$this->collGaleriaIPubs = GaleriaIPubPeer::doSelectJoinGiSubkategoria($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(GaleriaIPubPeer::OBRAZ_ID, $this->id);

			if (!isset($this->lastGaleriaIPubCriteria) || !$this->lastGaleriaIPubCriteria->equals($criteria)) {
				$this->collGaleriaIPubs = GaleriaIPubPeer::doSelectJoinGiSubkategoria($criteria, $con, $join_behavior);
			}
		}
		$this->lastGaleriaIPubCriteria = $criteria;

		return $this->collGaleriaIPubs;
	}

	
	public function clearGiObrazPubI18ns()
	{
		$this->collGiObrazPubI18ns = null; 	}

	
	public function initGiObrazPubI18ns()
	{
		$this->collGiObrazPubI18ns = array();
	}

	
	public function getGiObrazPubI18ns($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiObrazPubPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGiObrazPubI18ns === null) {
			if ($this->isNew()) {
			   $this->collGiObrazPubI18ns = array();
			} else {

				$criteria->add(GiObrazPubI18nPeer::ID, $this->id);

				GiObrazPubI18nPeer::addSelectColumns($criteria);
				$this->collGiObrazPubI18ns = GiObrazPubI18nPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiObrazPubI18nPeer::ID, $this->id);

				GiObrazPubI18nPeer::addSelectColumns($criteria);
				if (!isset($this->lastGiObrazPubI18nCriteria) || !$this->lastGiObrazPubI18nCriteria->equals($criteria)) {
					$this->collGiObrazPubI18ns = GiObrazPubI18nPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGiObrazPubI18nCriteria = $criteria;
		return $this->collGiObrazPubI18ns;
	}

	
	public function countGiObrazPubI18ns(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiObrazPubPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGiObrazPubI18ns === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GiObrazPubI18nPeer::ID, $this->id);

				$count = GiObrazPubI18nPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiObrazPubI18nPeer::ID, $this->id);

				if (!isset($this->lastGiObrazPubI18nCriteria) || !$this->lastGiObrazPubI18nCriteria->equals($criteria)) {
					$count = GiObrazPubI18nPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGiObrazPubI18ns);
				}
			} else {
				$count = count($this->collGiObrazPubI18ns);
			}
		}
		return $count;
	}

	
	public function addGiObrazPubI18n(GiObrazPubI18n $l)
	{
		if ($this->collGiObrazPubI18ns === null) {
			$this->initGiObrazPubI18ns();
		}
		if (!in_array($l, $this->collGiObrazPubI18ns, true)) { 			array_push($this->collGiObrazPubI18ns, $l);
			$l->setGiObrazPub($this);
		}
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collGaleriaIPubs) {
				foreach ((array) $this->collGaleriaIPubs as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collGiObrazPubI18ns) {
				foreach ((array) $this->collGiObrazPubI18ns as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} 
		$this->collGaleriaIPubs = null;
		$this->collGiObrazPubI18ns = null;
			$this->aGaleriaIPub = null;
	}


  
  public function getCulture()
  {
    return $this->culture;
  }

  
  public function setCulture($culture)
  {
    $this->culture = $culture;
  }

  public function getNazwa($culture = null)
  {
    return $this->getCurrentGiObrazPubI18n($culture)->getNazwa();
  }

  public function setNazwa($value, $culture = null)
  {
    $this->getCurrentGiObrazPubI18n($culture)->setNazwa($value);
  }

  public function getOpis($culture = null)
  {
    return $this->getCurrentGiObrazPubI18n($culture)->getOpis();
  }

  public function setOpis($value, $culture = null)
  {
    $this->getCurrentGiObrazPubI18n($culture)->setOpis($value);
  }

  protected $current_i18n = array();

  public function getCurrentGiObrazPubI18n($culture = null)
  {
    if (is_null($culture))
    {
      $culture = is_null($this->culture) ? sfPropel::getDefaultCulture() : $this->culture;
    }

    if (!isset($this->current_i18n[$culture]))
    {
      $obj = $this->isNew() ? null : GiObrazPubI18nPeer::retrieveByPK($this->getId(), $culture);
      if ($obj)
      {
        $this->setGiObrazPubI18nForCulture($obj, $culture);
      }
      else
      {
        $this->setGiObrazPubI18nForCulture(new GiObrazPubI18n(), $culture);
        $this->current_i18n[$culture]->setCulture($culture);
      }
    }

    return $this->current_i18n[$culture];
  }

  public function setGiObrazPubI18nForCulture($object, $culture)
  {
    $this->current_i18n[$culture] = $object;
    $this->addGiObrazPubI18n($object);
  }

} 