<?php


abstract class BaseGiStat extends BaseObject  implements Persistent {


  const PEER = 'GiStatPeer';

	
	protected static $peer;

	
	protected $galeria_id;

	
	protected $rok;

	
	protected $miesiac;

	
	protected $wejsc;

	
	protected $aGaleriaIPub;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
	}

	
	public function getGaleriaId()
	{
		return $this->galeria_id;
	}

	
	public function getRok()
	{
		return $this->rok;
	}

	
	public function getMiesiac()
	{
		return $this->miesiac;
	}

	
	public function getWejsc()
	{
		return $this->wejsc;
	}

	
	public function setGaleriaId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->galeria_id !== $v) {
			$this->galeria_id = $v;
			$this->modifiedColumns[] = GiStatPeer::GALERIA_ID;
		}

		if ($this->aGaleriaIPub !== null && $this->aGaleriaIPub->getId() !== $v) {
			$this->aGaleriaIPub = null;
		}

		return $this;
	} 
	
	public function setRok($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->rok !== $v) {
			$this->rok = $v;
			$this->modifiedColumns[] = GiStatPeer::ROK;
		}

		return $this;
	} 
	
	public function setMiesiac($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->miesiac !== $v) {
			$this->miesiac = $v;
			$this->modifiedColumns[] = GiStatPeer::MIESIAC;
		}

		return $this;
	} 
	
	public function setWejsc($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->wejsc !== $v) {
			$this->wejsc = $v;
			$this->modifiedColumns[] = GiStatPeer::WEJSC;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array())) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->galeria_id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->rok = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->miesiac = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
			$this->wejsc = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating GiStat object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aGaleriaIPub !== null && $this->galeria_id !== $this->aGaleriaIPub->getId()) {
			$this->aGaleriaIPub = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiStatPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = GiStatPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aGaleriaIPub = null;
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiStatPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			GiStatPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiStatPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			GiStatPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aGaleriaIPub !== null) {
				if ($this->aGaleriaIPub->isModified() || ($this->aGaleriaIPub->getCulture() && $this->aGaleriaIPub->getCurrentGaleriaIPubI18n()->isModified()) || $this->aGaleriaIPub->isNew()) {
					$affectedRows += $this->aGaleriaIPub->save($con);
				}
				$this->setGaleriaIPub($this->aGaleriaIPub);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = GiStatPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += GiStatPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aGaleriaIPub !== null) {
				if (!$this->aGaleriaIPub->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aGaleriaIPub->getValidationFailures());
				}
			}


			if (($retval = GiStatPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GiStatPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getGaleriaId();
				break;
			case 1:
				return $this->getRok();
				break;
			case 2:
				return $this->getMiesiac();
				break;
			case 3:
				return $this->getWejsc();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = GiStatPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getGaleriaId(),
			$keys[1] => $this->getRok(),
			$keys[2] => $this->getMiesiac(),
			$keys[3] => $this->getWejsc(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GiStatPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setGaleriaId($value);
				break;
			case 1:
				$this->setRok($value);
				break;
			case 2:
				$this->setMiesiac($value);
				break;
			case 3:
				$this->setWejsc($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = GiStatPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setGaleriaId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setRok($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setMiesiac($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setWejsc($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(GiStatPeer::DATABASE_NAME);

		if ($this->isColumnModified(GiStatPeer::GALERIA_ID)) $criteria->add(GiStatPeer::GALERIA_ID, $this->galeria_id);
		if ($this->isColumnModified(GiStatPeer::ROK)) $criteria->add(GiStatPeer::ROK, $this->rok);
		if ($this->isColumnModified(GiStatPeer::MIESIAC)) $criteria->add(GiStatPeer::MIESIAC, $this->miesiac);
		if ($this->isColumnModified(GiStatPeer::WEJSC)) $criteria->add(GiStatPeer::WEJSC, $this->wejsc);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(GiStatPeer::DATABASE_NAME);

		$criteria->add(GiStatPeer::GALERIA_ID, $this->galeria_id);
		$criteria->add(GiStatPeer::ROK, $this->rok);
		$criteria->add(GiStatPeer::MIESIAC, $this->miesiac);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getGaleriaId();

		$pks[1] = $this->getRok();

		$pks[2] = $this->getMiesiac();

		return $pks;
	}

	
	public function setPrimaryKey($keys)
	{

		$this->setGaleriaId($keys[0]);

		$this->setRok($keys[1]);

		$this->setMiesiac($keys[2]);

	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setGaleriaId($this->galeria_id);

		$copyObj->setRok($this->rok);

		$copyObj->setMiesiac($this->miesiac);

		$copyObj->setWejsc($this->wejsc);


		$copyObj->setNew(true);

	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new GiStatPeer();
		}
		return self::$peer;
	}

	
	public function setGaleriaIPub(GaleriaIPub $v = null)
	{
		if ($v === null) {
			$this->setGaleriaId(NULL);
		} else {
			$this->setGaleriaId($v->getId());
		}

		$this->aGaleriaIPub = $v;

						if ($v !== null) {
			$v->addGiStat($this);
		}

		return $this;
	}


	
	public function getGaleriaIPub(PropelPDO $con = null)
	{
		if ($this->aGaleriaIPub === null && ($this->galeria_id !== null)) {
			$c = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
			$c->add(GaleriaIPubPeer::ID, $this->galeria_id);
			$this->aGaleriaIPub = GaleriaIPubPeer::doSelectOne($c, $con);
			
		}
		return $this->aGaleriaIPub;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
			$this->aGaleriaIPub = null;
	}

} 