<?php


abstract class BaseGiSubkategoria extends BaseObject  implements Persistent {


  const PEER = 'GiSubkategoriaPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $updated_at;

	
	protected $created_at;

	
	protected $kolejnosc;

	
	protected $kategoria_id;

	
	protected $aGiKategoria;

	
	protected $collGiSubkategoriaI18ns;

	
	private $lastGiSubkategoriaI18nCriteria = null;

	
	protected $collGaleriaIs;

	
	private $lastGaleriaICriteria = null;

	
	protected $collGaleriaIPubs;

	
	private $lastGaleriaIPubCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

  
  protected $culture;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->kolejnosc = 0;
		$this->kategoria_id = 0;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->updated_at === null) {
			return null;
		}


		if ($this->updated_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->updated_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->updated_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getKolejnosc()
	{
		return $this->kolejnosc;
	}

	
	public function getKategoriaId()
	{
		return $this->kategoria_id;
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = GiSubkategoriaPeer::ID;
		}

		return $this;
	} 
	
	public function setUpdatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->updated_at !== null || $dt !== null ) {
			
			$currNorm = ($this->updated_at !== null && $tmpDt = new DateTime($this->updated_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->updated_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GiSubkategoriaPeer::UPDATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GiSubkategoriaPeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setKolejnosc($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->kolejnosc !== $v || $v === 0) {
			$this->kolejnosc = $v;
			$this->modifiedColumns[] = GiSubkategoriaPeer::KOLEJNOSC;
		}

		return $this;
	} 
	
	public function setKategoriaId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->kategoria_id !== $v || $v === 0) {
			$this->kategoria_id = $v;
			$this->modifiedColumns[] = GiSubkategoriaPeer::KATEGORIA_ID;
		}

		if ($this->aGiKategoria !== null && $this->aGiKategoria->getId() !== $v) {
			$this->aGiKategoria = null;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(GiSubkategoriaPeer::KOLEJNOSC,GiSubkategoriaPeer::KATEGORIA_ID))) {
				return false;
			}

			if ($this->kolejnosc !== 0) {
				return false;
			}

			if ($this->kategoria_id !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->updated_at = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->created_at = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->kolejnosc = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->kategoria_id = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 5; 
		} catch (Exception $e) {
			throw new PropelException("Error populating GiSubkategoria object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aGiKategoria !== null && $this->kategoria_id !== $this->aGiKategoria->getId()) {
			$this->aGiKategoria = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiSubkategoriaPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = GiSubkategoriaPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aGiKategoria = null;
			$this->collGiSubkategoriaI18ns = null;
			$this->lastGiSubkategoriaI18nCriteria = null;

			$this->collGaleriaIs = null;
			$this->lastGaleriaICriteria = null;

			$this->collGaleriaIPubs = null;
			$this->lastGaleriaIPubCriteria = null;

		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiSubkategoriaPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			GiSubkategoriaPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isModified() && !$this->isColumnModified(GiSubkategoriaPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

    if ($this->isNew() && !$this->isColumnModified(GiSubkategoriaPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiSubkategoriaPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			GiSubkategoriaPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aGiKategoria !== null) {
				if ($this->aGiKategoria->isModified() || ($this->aGiKategoria->getCulture() && $this->aGiKategoria->getCurrentGiKategoriaI18n()->isModified()) || $this->aGiKategoria->isNew()) {
					$affectedRows += $this->aGiKategoria->save($con);
				}
				$this->setGiKategoria($this->aGiKategoria);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = GiSubkategoriaPeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = GiSubkategoriaPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += GiSubkategoriaPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			if ($this->collGiSubkategoriaI18ns !== null) {
				foreach ($this->collGiSubkategoriaI18ns as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collGaleriaIs !== null) {
				foreach ($this->collGaleriaIs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collGaleriaIPubs !== null) {
				foreach ($this->collGaleriaIPubs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aGiKategoria !== null) {
				if (!$this->aGiKategoria->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aGiKategoria->getValidationFailures());
				}
			}


			if (($retval = GiSubkategoriaPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collGiSubkategoriaI18ns !== null) {
					foreach ($this->collGiSubkategoriaI18ns as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collGaleriaIs !== null) {
					foreach ($this->collGaleriaIs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collGaleriaIPubs !== null) {
					foreach ($this->collGaleriaIPubs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GiSubkategoriaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getUpdatedAt();
				break;
			case 2:
				return $this->getCreatedAt();
				break;
			case 3:
				return $this->getKolejnosc();
				break;
			case 4:
				return $this->getKategoriaId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = GiSubkategoriaPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getUpdatedAt(),
			$keys[2] => $this->getCreatedAt(),
			$keys[3] => $this->getKolejnosc(),
			$keys[4] => $this->getKategoriaId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GiSubkategoriaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setUpdatedAt($value);
				break;
			case 2:
				$this->setCreatedAt($value);
				break;
			case 3:
				$this->setKolejnosc($value);
				break;
			case 4:
				$this->setKategoriaId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = GiSubkategoriaPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setUpdatedAt($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setCreatedAt($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setKolejnosc($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setKategoriaId($arr[$keys[4]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);

		if ($this->isColumnModified(GiSubkategoriaPeer::ID)) $criteria->add(GiSubkategoriaPeer::ID, $this->id);
		if ($this->isColumnModified(GiSubkategoriaPeer::UPDATED_AT)) $criteria->add(GiSubkategoriaPeer::UPDATED_AT, $this->updated_at);
		if ($this->isColumnModified(GiSubkategoriaPeer::CREATED_AT)) $criteria->add(GiSubkategoriaPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(GiSubkategoriaPeer::KOLEJNOSC)) $criteria->add(GiSubkategoriaPeer::KOLEJNOSC, $this->kolejnosc);
		if ($this->isColumnModified(GiSubkategoriaPeer::KATEGORIA_ID)) $criteria->add(GiSubkategoriaPeer::KATEGORIA_ID, $this->kategoria_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);

		$criteria->add(GiSubkategoriaPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setUpdatedAt($this->updated_at);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setKolejnosc($this->kolejnosc);

		$copyObj->setKategoriaId($this->kategoria_id);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach ($this->getGiSubkategoriaI18ns() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addGiSubkategoriaI18n($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getGaleriaIs() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addGaleriaI($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getGaleriaIPubs() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addGaleriaIPub($relObj->copy($deepCopy));
				}
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new GiSubkategoriaPeer();
		}
		return self::$peer;
	}

	
	public function setGiKategoria(GiKategoria $v = null)
	{
		if ($v === null) {
			$this->setKategoriaId(0);
		} else {
			$this->setKategoriaId($v->getId());
		}

		$this->aGiKategoria = $v;

						if ($v !== null) {
			$v->addGiSubkategoria($this);
		}

		return $this;
	}


	
	public function getGiKategoria(PropelPDO $con = null)
	{
		if ($this->aGiKategoria === null && ($this->kategoria_id !== null)) {
			$c = new Criteria(GiKategoriaPeer::DATABASE_NAME);
			$c->add(GiKategoriaPeer::ID, $this->kategoria_id);
			$this->aGiKategoria = GiKategoriaPeer::doSelectOne($c, $con);
			
		}
		return $this->aGiKategoria;
	}

	
	public function clearGiSubkategoriaI18ns()
	{
		$this->collGiSubkategoriaI18ns = null; 	}

	
	public function initGiSubkategoriaI18ns()
	{
		$this->collGiSubkategoriaI18ns = array();
	}

	
	public function getGiSubkategoriaI18ns($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGiSubkategoriaI18ns === null) {
			if ($this->isNew()) {
			   $this->collGiSubkategoriaI18ns = array();
			} else {

				$criteria->add(GiSubkategoriaI18nPeer::ID, $this->id);

				GiSubkategoriaI18nPeer::addSelectColumns($criteria);
				$this->collGiSubkategoriaI18ns = GiSubkategoriaI18nPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiSubkategoriaI18nPeer::ID, $this->id);

				GiSubkategoriaI18nPeer::addSelectColumns($criteria);
				if (!isset($this->lastGiSubkategoriaI18nCriteria) || !$this->lastGiSubkategoriaI18nCriteria->equals($criteria)) {
					$this->collGiSubkategoriaI18ns = GiSubkategoriaI18nPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGiSubkategoriaI18nCriteria = $criteria;
		return $this->collGiSubkategoriaI18ns;
	}

	
	public function countGiSubkategoriaI18ns(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGiSubkategoriaI18ns === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GiSubkategoriaI18nPeer::ID, $this->id);

				$count = GiSubkategoriaI18nPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiSubkategoriaI18nPeer::ID, $this->id);

				if (!isset($this->lastGiSubkategoriaI18nCriteria) || !$this->lastGiSubkategoriaI18nCriteria->equals($criteria)) {
					$count = GiSubkategoriaI18nPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGiSubkategoriaI18ns);
				}
			} else {
				$count = count($this->collGiSubkategoriaI18ns);
			}
		}
		return $count;
	}

	
	public function addGiSubkategoriaI18n(GiSubkategoriaI18n $l)
	{
		if ($this->collGiSubkategoriaI18ns === null) {
			$this->initGiSubkategoriaI18ns();
		}
		if (!in_array($l, $this->collGiSubkategoriaI18ns, true)) { 			array_push($this->collGiSubkategoriaI18ns, $l);
			$l->setGiSubkategoria($this);
		}
	}

	
	public function clearGaleriaIs()
	{
		$this->collGaleriaIs = null; 	}

	
	public function initGaleriaIs()
	{
		$this->collGaleriaIs = array();
	}

	
	public function getGaleriaIs($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIs === null) {
			if ($this->isNew()) {
			   $this->collGaleriaIs = array();
			} else {

				$criteria->add(GaleriaIPeer::SUBKATEGORIA_ID, $this->id);

				GaleriaIPeer::addSelectColumns($criteria);
				$this->collGaleriaIs = GaleriaIPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GaleriaIPeer::SUBKATEGORIA_ID, $this->id);

				GaleriaIPeer::addSelectColumns($criteria);
				if (!isset($this->lastGaleriaICriteria) || !$this->lastGaleriaICriteria->equals($criteria)) {
					$this->collGaleriaIs = GaleriaIPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGaleriaICriteria = $criteria;
		return $this->collGaleriaIs;
	}

	
	public function countGaleriaIs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGaleriaIs === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GaleriaIPeer::SUBKATEGORIA_ID, $this->id);

				$count = GaleriaIPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GaleriaIPeer::SUBKATEGORIA_ID, $this->id);

				if (!isset($this->lastGaleriaICriteria) || !$this->lastGaleriaICriteria->equals($criteria)) {
					$count = GaleriaIPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGaleriaIs);
				}
			} else {
				$count = count($this->collGaleriaIs);
			}
		}
		return $count;
	}

	
	public function addGaleriaI(GaleriaI $l)
	{
		if ($this->collGaleriaIs === null) {
			$this->initGaleriaIs();
		}
		if (!in_array($l, $this->collGaleriaIs, true)) { 			array_push($this->collGaleriaIs, $l);
			$l->setGiSubkategoria($this);
		}
	}


	
	public function getGaleriaIsJoinsfGuardUser($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIs === null) {
			if ($this->isNew()) {
				$this->collGaleriaIs = array();
			} else {

				$criteria->add(GaleriaIPeer::SUBKATEGORIA_ID, $this->id);

				$this->collGaleriaIs = GaleriaIPeer::doSelectJoinsfGuardUser($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(GaleriaIPeer::SUBKATEGORIA_ID, $this->id);

			if (!isset($this->lastGaleriaICriteria) || !$this->lastGaleriaICriteria->equals($criteria)) {
				$this->collGaleriaIs = GaleriaIPeer::doSelectJoinsfGuardUser($criteria, $con, $join_behavior);
			}
		}
		$this->lastGaleriaICriteria = $criteria;

		return $this->collGaleriaIs;
	}


	
	public function getGaleriaIsJoinGiObraz($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIs === null) {
			if ($this->isNew()) {
				$this->collGaleriaIs = array();
			} else {

				$criteria->add(GaleriaIPeer::SUBKATEGORIA_ID, $this->id);

				$this->collGaleriaIs = GaleriaIPeer::doSelectJoinGiObraz($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(GaleriaIPeer::SUBKATEGORIA_ID, $this->id);

			if (!isset($this->lastGaleriaICriteria) || !$this->lastGaleriaICriteria->equals($criteria)) {
				$this->collGaleriaIs = GaleriaIPeer::doSelectJoinGiObraz($criteria, $con, $join_behavior);
			}
		}
		$this->lastGaleriaICriteria = $criteria;

		return $this->collGaleriaIs;
	}

	
	public function clearGaleriaIPubs()
	{
		$this->collGaleriaIPubs = null; 	}

	
	public function initGaleriaIPubs()
	{
		$this->collGaleriaIPubs = array();
	}

	
	public function getGaleriaIPubs($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIPubs === null) {
			if ($this->isNew()) {
			   $this->collGaleriaIPubs = array();
			} else {

				$criteria->add(GaleriaIPubPeer::SUBKATEGORIA_ID, $this->id);

				GaleriaIPubPeer::addSelectColumns($criteria);
				$this->collGaleriaIPubs = GaleriaIPubPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GaleriaIPubPeer::SUBKATEGORIA_ID, $this->id);

				GaleriaIPubPeer::addSelectColumns($criteria);
				if (!isset($this->lastGaleriaIPubCriteria) || !$this->lastGaleriaIPubCriteria->equals($criteria)) {
					$this->collGaleriaIPubs = GaleriaIPubPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGaleriaIPubCriteria = $criteria;
		return $this->collGaleriaIPubs;
	}

	
	public function countGaleriaIPubs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGaleriaIPubs === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GaleriaIPubPeer::SUBKATEGORIA_ID, $this->id);

				$count = GaleriaIPubPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GaleriaIPubPeer::SUBKATEGORIA_ID, $this->id);

				if (!isset($this->lastGaleriaIPubCriteria) || !$this->lastGaleriaIPubCriteria->equals($criteria)) {
					$count = GaleriaIPubPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGaleriaIPubs);
				}
			} else {
				$count = count($this->collGaleriaIPubs);
			}
		}
		return $count;
	}

	
	public function addGaleriaIPub(GaleriaIPub $l)
	{
		if ($this->collGaleriaIPubs === null) {
			$this->initGaleriaIPubs();
		}
		if (!in_array($l, $this->collGaleriaIPubs, true)) { 			array_push($this->collGaleriaIPubs, $l);
			$l->setGiSubkategoria($this);
		}
	}


	
	public function getGaleriaIPubsJoinGaleriaI($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIPubs === null) {
			if ($this->isNew()) {
				$this->collGaleriaIPubs = array();
			} else {

				$criteria->add(GaleriaIPubPeer::SUBKATEGORIA_ID, $this->id);

				$this->collGaleriaIPubs = GaleriaIPubPeer::doSelectJoinGaleriaI($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(GaleriaIPubPeer::SUBKATEGORIA_ID, $this->id);

			if (!isset($this->lastGaleriaIPubCriteria) || !$this->lastGaleriaIPubCriteria->equals($criteria)) {
				$this->collGaleriaIPubs = GaleriaIPubPeer::doSelectJoinGaleriaI($criteria, $con, $join_behavior);
			}
		}
		$this->lastGaleriaIPubCriteria = $criteria;

		return $this->collGaleriaIPubs;
	}


	
	public function getGaleriaIPubsJoinGiObrazPub($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIPubs === null) {
			if ($this->isNew()) {
				$this->collGaleriaIPubs = array();
			} else {

				$criteria->add(GaleriaIPubPeer::SUBKATEGORIA_ID, $this->id);

				$this->collGaleriaIPubs = GaleriaIPubPeer::doSelectJoinGiObrazPub($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(GaleriaIPubPeer::SUBKATEGORIA_ID, $this->id);

			if (!isset($this->lastGaleriaIPubCriteria) || !$this->lastGaleriaIPubCriteria->equals($criteria)) {
				$this->collGaleriaIPubs = GaleriaIPubPeer::doSelectJoinGiObrazPub($criteria, $con, $join_behavior);
			}
		}
		$this->lastGaleriaIPubCriteria = $criteria;

		return $this->collGaleriaIPubs;
	}


	
	public function getGaleriaIPubsJoinsfGuardUser($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiSubkategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIPubs === null) {
			if ($this->isNew()) {
				$this->collGaleriaIPubs = array();
			} else {

				$criteria->add(GaleriaIPubPeer::SUBKATEGORIA_ID, $this->id);

				$this->collGaleriaIPubs = GaleriaIPubPeer::doSelectJoinsfGuardUser($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(GaleriaIPubPeer::SUBKATEGORIA_ID, $this->id);

			if (!isset($this->lastGaleriaIPubCriteria) || !$this->lastGaleriaIPubCriteria->equals($criteria)) {
				$this->collGaleriaIPubs = GaleriaIPubPeer::doSelectJoinsfGuardUser($criteria, $con, $join_behavior);
			}
		}
		$this->lastGaleriaIPubCriteria = $criteria;

		return $this->collGaleriaIPubs;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collGiSubkategoriaI18ns) {
				foreach ((array) $this->collGiSubkategoriaI18ns as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collGaleriaIs) {
				foreach ((array) $this->collGaleriaIs as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collGaleriaIPubs) {
				foreach ((array) $this->collGaleriaIPubs as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} 
		$this->collGiSubkategoriaI18ns = null;
		$this->collGaleriaIs = null;
		$this->collGaleriaIPubs = null;
			$this->aGiKategoria = null;
	}


  
  public function getCulture()
  {
    return $this->culture;
  }

  
  public function setCulture($culture)
  {
    $this->culture = $culture;
  }

  public function getNazwa($culture = null)
  {
    return $this->getCurrentGiSubkategoriaI18n($culture)->getNazwa();
  }

  public function setNazwa($value, $culture = null)
  {
    $this->getCurrentGiSubkategoriaI18n($culture)->setNazwa($value);
  }

  protected $current_i18n = array();

  public function getCurrentGiSubkategoriaI18n($culture = null)
  {
    if (is_null($culture))
    {
      $culture = is_null($this->culture) ? sfPropel::getDefaultCulture() : $this->culture;
    }

    if (!isset($this->current_i18n[$culture]))
    {
      $obj = $this->isNew() ? null : GiSubkategoriaI18nPeer::retrieveByPK($this->getId(), $culture);
      if ($obj)
      {
        $this->setGiSubkategoriaI18nForCulture($obj, $culture);
      }
      else
      {
        $this->setGiSubkategoriaI18nForCulture(new GiSubkategoriaI18n(), $culture);
        $this->current_i18n[$culture]->setCulture($culture);
      }
    }

    return $this->current_i18n[$culture];
  }

  public function setGiSubkategoriaI18nForCulture($object, $culture)
  {
    $this->current_i18n[$culture] = $object;
    $this->addGiSubkategoriaI18n($object);
  }

} 