<?php 

class GaleriaISettingsForm extends sfForm {
    public function configure() {
        $this->getWidgetSchema()->getFormFormatter()->setHelpFormat('%help%');
    }

    public function setup() {
        $url     = sfContext::getInstance()->getRequest()->getRelativeUrlRoot();
        $culture = sfContext::getInstance()->getUser()->getCulture();
        $this->setWidgets(array(
            'mini'              => new ciWidgetFormResolution(),
            'thumb'             => new ciWidgetFormResolution(),
            'normal'            => new ciWidgetFormResolution(),
            'flash' => new ciWidgetFormResolution(),
            'max'               => new ciWidgetFormResolution(),
            'background_color'  => new ciWidgetFormColor(),
            'border_color'      => new ciWidgetFormColor(),
            'regulamin'         => new sfWidgetFormTextareaTinyMCE(array(
                'config'=>'
                  language: "'.$culture.'",
                  theme_advanced_buttons1 : "bold,italic,underline,separator,strikethrough,justifyleft,justifycenter,justifyright,justifyfull,bullist,numlist,undo,redo,link,unlink",
                  theme_advanced_buttons2 : "",
                  theme_advanced_buttons3 : "",
                  theme_advanced_toolbar_location : "top",
                  theme_advanced_toolbar_align : "left",
                  theme_advanced_statusbar_location : "bottom",
                  theme : "advanced",
                  debug: false,
                  width: "540px"
            '), array('class'   =>  'tiny_mce1')),

            'dodanie'  => new sfWidgetFormTextareaTinyMCE(array(
                'config'=>'
                  language: "'.$culture.'",
                  theme_advanced_buttons1 : "bold,italic,underline,separator,strikethrough,justifyleft,justifycenter,justifyright,justifyfull,bullist,numlist,undo,redo,link,unlink",
                  theme_advanced_buttons2 : "",
                  theme_advanced_buttons3 : "",
                  theme_advanced_toolbar_location : "top",
                  theme_advanced_toolbar_align : "left",
                  theme_advanced_statusbar_location : "bottom",
                  theme : "advanced",
                  debug: false,
                  width: "540px"
            '), array('class'   =>  'tiny_mce2')),

            'po_dodaniu' => new sfWidgetFormTextareaTinyMCE(array(
                'config'=>'
                  language: "'.$culture.'",
                  theme_advanced_buttons1 : "bold,italic,underline,separator,strikethrough,justifyleft,justifycenter,justifyright,justifyfull,bullist,numlist,undo,redo,link,unlink",
                  theme_advanced_buttons2 : "",
                  theme_advanced_buttons3 : "",
                  theme_advanced_toolbar_location : "top",
                  theme_advanced_toolbar_align : "left",
                  theme_advanced_statusbar_location : "bottom",
                  theme : "advanced",
                  debug: false,
                  width: "540px"
            '), array('class'   =>  'tiny_mce3'))
        ));

        $this->widgetSchema->setLabels(array(
            'mini'              => "Mini",
            'thumb'             => "Miniaturka",
            'normal'            => "Rozmiar Średni",
            'max'               => "Rozmiar Duży",
            'flash' => "Rozmiar NewsBox",
            'background_color'  => 'Kolor tła ',
            'border_color'      => 'Kolor ramki',
            'regulamin'         => "Regulamin",
            'dodanie'           => "Tekst przed dodaniem galerii",
            'po_dodaniu'        => "Tekst po dodaniu galerii",
//          'padding' => 'Ramka',
        ));

        $this->widgetSchema->setHelps(array(
            'mini'              => "Stała wielkość wycinka stosowanego w zajawkach (zależy od skórki)",
            'thumb'             => "Ograniczenie dla najwiekszego wymiaru (przy zachowaniu proporcji)",
            'normal'            => "Ograniczenia dla najwiekszego wymiaru (przy zachowaniu proporcji)",
            'max'               => "Ograniczenia dla najwiekszego wymiaru (przy zachowaniu proporcji)",
            'flash' => "Ograniczenia dla największego wymiaru (przy zachowaniu proporcji)",
            'background_color'  => '(domyślnie #333333)',
            'border_color'      => '(domyślnie #FFFFFF)',
            'regulamin'         => "Regulamin, który musi zaakceptować Internauta przed dodaniem galerii",
            'dodanie'           => "Informacja dla Internauty przed dodaniem galerii",
            'po_dodaniu'        => "Informacja dla Internauty po dodaniu galerii",
//          'padding' => 'szerokosc ramki, odstep obrazka od tla',
        ));

        $this->widgetSchema->setNameFormat('gali_config[%s]');
        $this->widgetSchema->setFormFormatterName('sam3');
    }
}
