<?php

/**
 * igallery actions.
 *
 * @package    sam3
 * @subpackage frontend
 * @author     Alfred Broda
 * @version    SVN: $Id: actions.class.php  alfred $
 */
class igaleriaActions extends autoigaleriaActions {

    public function preExecute() {
        if (!in_array('gali', ModulPeer::getEnabled())) {
            $this->forward(sfConfig::get('sf_secure_module'), sfConfig::get('sf_secure_action'));
        }
    }

    private $filters;

    /**
     * Enter description here...
     *
     * @param sfWebRequest $request
     */
    public function executeEdit($request) {
        $this->module_name = stripos($request->getReferer(), 'igkategoria') == false ? 'igaleria' : 'igkategoria';
        $this->message = '';

        $user = $this->getUser();
        $this->referer = $user->getAttribute('referer', $request->getUri());
        $user->setAttribute('referer', $request->getUri());

        $this->ajax = $request->isXmlHttpRequest();
        if ($request->getParameter('postsave')) {
            $this->ajax = true;
        }
        if ($request->getParameter('from') == 'unpublish') {
            $this->ajax = true;
        }
        if ($this->ajax) {
            $this->setLayout('default');
        }

        $id = $request->getParameter('galeria');
        $id = $id['id'];

        $gsid = null;
        if ($request->hasParameter('gsid')) {
            $gsid = $request->getParameter('gsid');
        }

        $object = null;
        $this->id = null;
        $this->obrazki = array();
        $this->errors = Array();
        if (!$id)
            $id = $request->getParameter('id');
        if (isset($id)) {
            $this->id = $id;
            $object = GaleriaIPeer::retrieveByPK($id);

            if ($request->getParameter('postsave', null) == 'true') {
                $this->message = "Zapis przebiegł pomyślnie.";
            }
            if ($request->getParameter('from') == 'unpublish') {
                if ($object->checkPermission($user, 'publish') == 1) {
                    $this->message = "Opublikowana wersja usunięta pomyślnie.";
                } else {
                    $this->message = "Galeria została przekazana do Usunięcia z Publikacji.";
                }
            }
            $before = $object;
            $przed = $before->toArray(BasePeer::TYPE_FIELDNAME);
            $c_przed = new Criteria();
            $c_przed->add(GaleriaII18nPeer::ID, $id);

            if (!$request->isMethod('post')) {
                $this->getUser()->setAttribute('before_i18n', $before->getGaleriaII18ns());
            }

            $crit = new Criteria();
            $crit->add(GiObrazPeer::GALERIA_ID, $id);
            $crit->addAscendingOrderByColumn(GiObrazPeer::KOLEJNOSC);
            $obrazki = GiObrazPeer::doSelect($crit);
            foreach ($obrazki as $obr) {
                $this->obrazki[] = new GiObrazForm($obr);
            }
            //Publikacja
            if ($request->hasParameter('publish')) {
                $this->form = new GaleriaIForm($object);
                $this->errors = $this->form->getErrorsNice();
                if (!count($this->errors)) {
                    if ($object->checkPermission($user, 'publish') == 1) {
                        if ($object->getOpublikowal() == NULL):
                            $object->setOpublikowal($user->getId());
                        endif;
                        $object->publish();
                        $object->setWidoczna(1);
                        $object->save();

                        $this->message = "Publikacja przebiegła pomyślnie.";
                    } else {
                        $object->setWidoczna(4);
                        $object->save();
                        $this->message = "Galeria przekazana do Publikacji.";
                    }
                    return 'Success';
                } else {
                    $this->message = "Publikacja przerwana z powodu błędów.";
                    return 'Success';
                }
            }
            //Ustawienie zajawki
            if ($request->hasParameter('setdef')) {
                $oid = $request->getParameter('setdef');
                if ($object->getObrazId() == $oid) {
                    $object->setObrazId(null);
                    LogPeer::wstawLoga($user->getId(), 'gali', 'Zajawka usunięta', 'Galeria', $object->getId(), $object->__toString());
                } else {
                    $object->setObrazId($oid);
                    $bef = array('obraz_id' => $object->getObrazId());
                    $aft = array('obraz_id' => $oid);
                    LogPeer::sprawdzZmiany($user->getId(), $bef, $aft, 'gali', 'Galeria', $object->getId());
                }
                try {
                    $object->save();
                } catch (PropelException $e) {
                    $this->getUser()->setFlash('error', $e->getMessage());
                }
                return 'Success';
            }
        } else {
            $object = new GaleriaI();
            $object->setOpublikowal($user->getId());
            $object->setSubkategoriaId($gsid);
        }

        $this->getUser()->setAttribute('gali_id', $id);

        if (!$object->isNew() && $object->checkPermission($user, 'edit') != 1) {
            $this->forward(sfConfig::get('sf_secure_module'), sfConfig::get('sf_secure_action'));
        }

        $this->form = new GaleriaIForm($object);
        if ($this->getUser()->checkPermission('gali_global', 'publish') != 1) {
            
        }

        if ($request->isMethod('post')) {
            $obraz = $request->getParameter('galeria');
            $is_new = $this->form->getObject()->isNew();

            // Przepisywanie różnej maści
            $def_cult = $user->getCulture();
            if ($is_new && isset($obraz[$def_cult])) {
                $cultures = JezykTblPeer::getCulturesForModul('gali');

                foreach ($cultures as $cult) {
                    if ($cult == $def_cult)
                        continue;
                    if (!isset($obraz[$cult]['tytul']) || !$obraz[$cult]['tytul'] && isset($obraz[$def_cult]['tytul'])) {
                        $obraz[$cult]['tytul'] = $obraz[$def_cult]['tytul'];
                    }
                }
            }

            $this->form->bind($obraz);
            if (!$this->form->isValid()) {
                $shema = $this->form->getErrorsNice();
                $this->errors = $shema;
            } else {
                try {
                    // Zmieniamy status na roboczy
                    $this->form->getObject()->setWidoczna(0);
                    $this->form->save();
                    $this->id = $this->form->getObject()->getId();

                    if ($is_new) {
                        LogPeer::wstawLoga($this->getUser()->getId(), 'gali', 'Nowa galeria: ' . $object->getTytul(), 'Galeria', $object->getId());
                    } else {
                        $po = $this->form->getObject()->toArray(BasePeer::TYPE_FIELDNAME);

                        $po['i18n'] = $object->getGaleriaII18ns();
                        $przed['i18n'] = $this->getUser()->getAttribute('before_i18n');
                        LogPeer::sprawdzZmiany($this->getUser()->getId(), $przed, $po, 'gali', 'Galeria', $this->form->getObject()->getId());
                        foreach ($po['i18n'] as $po_i18n) {
                            foreach ($przed['i18n'] as $przed_i18n) {
                                if (($przed_i18n->getCulture() == $po_i18n->getCulture()) && ($przed_i18n->getId() == $po_i18n->getId())) {
                                    $przed_tmp = $przed_i18n->toArray(BasePeer::TYPE_FIELDNAME);
                                    $po_tmp = $po_i18n->toArray(BasePeer::TYPE_FIELDNAME);

                                    LogPeer::sprawdzZmiany($this->getUser()->getId(), $przed_tmp, $po_tmp, 'gali', 'GaleriaI', $this->form->getObject()->getId());
                                } else {
                                    continue;
                                }
                            }
                        }
                    }
                    $this->redirect('igaleria/edit?id=' . $this->id . '&postsave=true');
                } catch (PropelException $e) {
                    $this->errors[] = $e->getMessage();
                }
            }
            if (!count($this->errors))
                $this->message = "Zapis przebiegł pomyślnie.";
        }
        else {
            if ($gsid)
                $this->form->setDefault('subkategoria_id', $gsid);
            $this->form->setDefault('user_id', $user->getId());
        }
    }

    public function executeSave($request) {
        $this->forward('igaleria', 'edit');
    }

    public function executeDelete($request) {
        $user = $this->getUser();
        $id = $request->getParameter('id');
        if ($id) {
            $gal = GaleriaIPeer::retrieveByPK($id);

            $user = $this->getUser();
            try {
                if ($gal->checkPermission($user, 'publish') == 1) {
                    $gal->delete();
                } else {
                    $gal->setWidoczna(3);
                    $gal->save();
                }
            } catch (PropelException $e) {
                $this->text = $e->getMessage();
            }
            if (!isset($this->text))
                $this->text = "Obiekt usunięty pomyślnie.";
        }
        else {
            $this->text = "Nie podano ID lub galeria została wcześniej usunięta.";
        }
        if ($request->isXMLHttpRequest()) {
            $this->setTemplate('message');
        } else {
            $this->redirect('igaleria/list');
        }
    }

    public function executeUnpublish($request) {
        $user = $this->getUser();
        $id = $request->getParameter('id');
        if ($id) {
            try {
                $gal = GaleriaIPeer::retrieveByPK($id);
                if ($gal->checkPermission($user, 'publish') == 1) {
                    $gal->unpublish();
                } else {
                    $gal->setWidoczna(6);
                    $gal->save();
                }
            } catch (PropelException $e) {
                $this->text = $e->getMessage();
            }
            if (!isset($this->text))
                $this->text = "Opublikowana wersja usunięta pomyślnie.";
        }
        else {
            $this->text = "Nie podano ID lub brak wersji opublikowanej.";
        }
        $this->redirect('igaleria/edit?id=' . $id . '&from=unpublish');
    }

    public function executeCreate($request) {
        $this->forward('igaleria', 'edit');
    }

    public function executeList($request) {
        $this->ajax = $request->isXmlHttpRequest();
        if (!$this->ajax)
            $this->setLayout('admin');
        $user = $this->getUser();

        $this->processSort();
        $this->processFilters();

        $this->filters = $user->getAttribute('filters', null, 'sf_admin/igaleria/filters');

        $this->filterform = new GaleriaII18nFormFilter();
        $c = GaleriaIPeer::buildBasicCriteria();
        if ($this->filters) {
            $this->filterform->bind($this->filters);
            $c = $this->filterform->buildCriteria($this->filters);
            $c = GaleriaIPeer::buildBasicCriteria($c);
        }
        $c->addJoin(GaleriaIPeer::ID, GaleriaII18nPeer::ID);
        $c->addGroupByColumn(GaleriaIPeer::ID);

// Sortowanie
        if (!$request->hasParameter('sort')) {
            $c->addDescendingOrderByColumn(GaleriaIPeer::UPDATED_AT);
        } else {
            $this->addSortCriteria($c);
        }

        if ($request->hasParameter('status')) {
            $status = $request->getParameter('status');
            $user->setAttribute('status', $status, 'gali');
        } else {
            $status = $user->getAttribute('status', 7, 'gali');
        }

        if ($status == 1) {
// Opublikowane
            $c->addJoin(GaleriaIPeer::ID, GaleriaIPubPeer::ID);
        } else if ($status != 7) {
            $c->add(GaleriaIPeer::WIDOCZNA, $status);
        }

        // Liczniki
        $cc = GaleriaIPeer::buildBasicCriteria();
        if (!($user->checkPermission('gali_global', 'edit') == 1)) {
            $cc->add(GaleriaIPeer::UZYTKOWNIK_ID, $user->getId());
        }

        $this->all = GaleriaIPeer::doCount($cc);

        $cc->add(GaleriaIPeer::WIDOCZNA, 0);
        $this->work = GaleriaIPeer::doCount($cc);

        $cc->add(GaleriaIPeer::WIDOCZNA, 4);
        $this->to_pub = GaleriaIPeer::doCount($cc);

        $cc->add(GaleriaIPeer::WIDOCZNA, 6);
        $this->rem_pub = GaleriaIPeer::doCount($cc);

        $cc->add(GaleriaIPeer::WIDOCZNA, 3);
        $this->to_del = GaleriaIPeer::doCount($cc);

        $cc->remove(GaleriaIPeer::WIDOCZNA);
        $cc->addJoin(GaleriaIPeer::ID, GaleriaIPubPeer::ID);
        //$cc->setDistinct();
        $this->pub = GaleriaIPeer::doCount($cc);

// pager
        $this->pager = new sfPropelPager('GaleriaI', 15);

        if ($this->getUser()->hasCredential('config') || $this->getUser()->checkPermission('gali_global', 'edit') == 1) {
//Administrator lub edytor/korektor
        } else {
//zwykły użytkownik
            $c->add(GaleriaIPeer::UZYTKOWNIK_ID, $this->getUser()->getId());
        }

        $this->pager->setCriteria($c);
        $this->pager->setPage($this->getRequestParameter('page', $this->getUser()->getAttribute('page', 1, 'sf_admin/galeria')));
        $this->pager->init();
// save page
        if ($this->getRequestParameter('page')) {
            $this->getUser()->setAttribute('page', $this->getRequestParameter('page'), 'sf_admin/galeria');
        }
    }

    protected function addSortCriteria($c) {
        $sort_column = $this->getUser()->getAttribute('sort', null, 'sf_admin/galeria_i/sort');
        if ($sort_column) {
// camelize lower case to be able to compare with BasePeer::TYPE_PHPNAME translate field name
            $sort_column = GaleriaIPeer::translateFieldName(sfInflector::camelize(strtolower($sort_column)), BasePeer::TYPE_PHPNAME, BasePeer::TYPE_COLNAME);
            if ($this->getUser()->getAttribute('type', null, 'sf_admin/galeria_i/sort') == 'asc') {
                $c->addAscendingOrderByColumn($sort_column);
            } else {
                $c->addDescendingOrderByColumn($sort_column);
            }
        }
    }

    protected function addFiltersCriteria($c) {
        foreach ($this->filters as $field => $filter) {
//$c->add(GaleriaIPeer::DATABASE_NAME."$field","%$filter%",Criteria::LIKE);
        }
    }

    public function executePreview(sfWebRequest $request) {
        $this->obrazki = array();
        $id = $request->getParameter('id');
        if (!$id){
            $id = $this->getUser()->getAttribute('gali_id');
        }
        $order_dir = $this->getUser()->getAttribute('order_dir', 'Acs');
        $crit = new Criteria();
        $crit->add(GiObrazPeer::GALERIA_ID, $id);
        $gal = GaleriaIPeer::retrieveByPK($id);
        if ($gal->getObrazId()) {
            $this->zajob = $gal->getObrazId();
        } else {
            $this->zajob = -1;
        }

        $sort = $request->getParameter('sort');
        switch ($sort) {
            case 'name':
                if ($order_dir == "Asc")
                    $crit->addAscendingOrderByColumn(GiObrazPeer::TYTUL);
                else
                    $crit->addDescendingOrderByColumn(GiObrazPeer::TYTUL);
                break;
            case 'date':
                if ($order_dir == "Des")
                    $crit->addAscendingOrderByColumn(GiObrazPeer::CREATED_AT);
                else
                    $crit->addDescendingOrderByColumn(GiObrazPeer::CREATED_AT);
                break;
            case 'exif_date':
                if ($order_dir == "Des")
                    $crit->addAscendingOrderByColumn(GiObrazPeer::EXIF_DATA);
                else
                    $crit->addDescendingOrderByColumn(GiObrazPeer::EXIF_DATA);
                break;
            default:
                $crit->addAscendingOrderByColumn(GiObrazPeer::KOLEJNOSC);
        }


        $obrazki = GiObrazPeer::doSelect($crit);

        if ($sort) {
            $i = 0;
            foreach ($obrazki as $obraz) {
                $obraz->setKolejnosc($i++);
                $obraz->save();
            }
            $this->getUser()->setFlash('notice', "Kolejność zmieniona poprawnie");
        }
        

        foreach ($obrazki as $obr) {
            $this->obrazki[] = new GiObrazForm($obr);
        }
    }

    public function executeMove(sfWebRequest $request) {
        $this->messages = null;
        $this->errors = array();
        if ($request->hasParameter('id')) {
            $obj = GaleriaIPeer::retrieveByPK($request->getParameter('id'));
            if ($obj) {
                switch ($request->getParameter('move')) {
                    case 'up':
                        $obj->moveUp();
                        $this->messages = "Galeria <b>" . $obj->getTytul() . "</b> przeniesiona w górę prawidłowo.";
                        break;
                    case 'down':
                        $obj->moveDown();
                        $this->messages = "Galeria <b>" . $obj->getTytul() . "</b> przeniesiona w dół prawidłowo.";
                        break;
                    default:
                        $this->messages = null;
                        $obj = null;
                }
                if (!$this->messages)
                    $this->errors[] = "Błąd przy zmianie kolejności obiektu <b>" . $obj->getTytul() . "</b>";
            }
            else {
                if (!$this->messages)
                    $this->messages = "Błedne ID obiektu lub zmiana jest nieokreślona";
            }
        }
        else {
            $this->errors[] = "Nieokreślone ID obiektu";
        }
    }

    public function executeUpload(sfWebRequest $request) {
        $this->setLayout(false);

        $log_file = sfConfig::get('sf_upload_dir') . "/../../log/flash_upload.log";
        $flog = fopen($log_file, 'a+');
        fwrite($flog, date('c') . " Output Follows ---------------------- \n");
        sfContext::getInstance()->getConfiguration()->loadHelpers(array('Funkcje'));

        $rarray = $request->getGetParameters();
        $extras = $request->getParameter('extras');
        fwrite($flog, "extras: $extras\n");

        $array = explode('|', $extras);
        $extras = array();
        foreach ($array as $gal) {
            $tmp = explode(':', $gal);
            $extras[$tmp[0]] = $tmp[1];
        }
        $gid = $extras['gali_id'];
        $uid = $extras['user_id'];
        fwrite($flog, "gid: $gid, uid: $uid\n");
        fclose($flog);

        $this->message = '';

        $this->form = new UploadFileForm();

        if ($request->isMethod('post')) {
            $file = UploadFlashForm::recieveUpload($request);
            echo"(Flash Upload) Upload begin:\n";

            if (!$file)
                throw new sfException('Brak pliku! (' . $file . ')');

            $mime = $file->getType();
            $filename = $file->generateFilename();
            $tmpfile = $file->getTempName();

            $directory = sfConfig::get('sf_upload_dir') . "/temp/gali/gal_$gid/work";
            @mkdir($directory, 0775, true);
            $lock_file = "$directory/.upload.lock";
            move_uploaded_file($tmpfile, "$directory/$filename");

            if (is_file($lock_file))
                throw new sfException("Równoległy upload! (istnieje $lock_file)");

            $flock = fopen($lock_file, 'a+');
            $farray = array('mime' => $mime, 'filename' => $filename);
            fwrite($flock, json_encode($farray));

            echo "(Flash Upload) done.\n";
            fclose($flock);
        }
    }

    public function executeExtract(sfWebRequest $request) {
        ini_set('max_execution_time', 14400);
        $Start = microtime(true);

        $gid = $request->GetParameter('gali_id');
        if (!$gid) {
            $gid = $this->getUser()->getAttribute('gali_id');
        }
        $uid = $this->getUser()->getId();

        $lock_file = sfConfig::get('sf_upload_dir') . "/temp/gali/gal_$gid/work/.upload.lock";
        if (!is_file($lock_file))
            throw new sfException("Nie istnieje $lock_file!");

        $farray = file_get_contents($lock_file);
        $farray = json_decode($farray, true);
        $mime = $farray['mime'];
        $filename = $farray['filename'];
        $tmpfile = sfConfig::get('sf_upload_dir') . "/temp/gali/gal_$gid/work/$filename";

        $directory = sfConfig::get('sf_upload_dir') . "/temp/gali/gal_$gid";

        $this->files = array();
        $files = array();
        switch ($mime) {
            case 'application/zip':
            case 'application/octet-stream':
                if (!function_exists('zip_open')) {
                    $this->message = "Brak obsługi ZIP na serwerze! <br/>PHP musi zostać skompilowane z flagą --with-zip";
                    break;
                }
                $this->message = "Otwieram plik ZIP " . $filename . "...";
                $zipfile = zip_open($tmpfile);

                // pZ: ustawiam granice CZASU
                $stop = 0; // sekund
                // pZ: CZAS TO JA MUSZE LICZYC PRZY !-TWORZENIU-! MINIATUR A NIE PODCZAS ROZPAKOWYWNIA !!!
                $start = time();

                // pZ:
                $name_count = $request->GetParameter('name_count', 0);
                // tutaj steruje iloscia rozpakowywanych plikow a nie uzywajac czasu
                $max = $name_count + 10;

                $ile = 0;
                $czy_koniec = true;
                while ($cfile = zip_read($zipfile)) {

                    // pZ: musze liczyc wszystkie pliki (takze nie graficzne) w ZIPie
                    $ile++;

                    // pZ: jakis plik znalazlem wiec to nie koniec
                    $czy_koniec = false;

                    $name = zip_entry_name($cfile);
                    $name_array = explode('/', $name);
                    $sname = array_pop($name_array);
                    $ext_array = explode('.', $sname);
                    $ext = strtolower(array_pop($ext_array));
                    $title = implode('.', $ext_array);

                    if ($name && ($ext == 'jpeg' || $ext == 'jpg' || $ext == 'gif' || $ext == 'png' || $ext == 'bmp')) {
                        $this->message .= "\n Rozpakowywanie $sname... ";
                    }
                    if ($ile <= $name_count) {
                        // pZ: teraz nie obslugujemy tego pliku wiec koniec=true
                        zip_entry_close($cfile);
                        $czy_koniec = true;
                        continue;
                    }

                    // pZ: stworzenie nazwy i zwiekszenie zmiennej $name_count
                    ++$name_count;

                    if ($name && ($ext == 'jpeg' || $ext == 'jpg' || $ext == 'gif' || $ext == 'png' || $ext == 'bmp')) {
                        $this->message .= "\n Rozpakowywanie $sname... ";
                        $size = zip_entry_filesize($cfile);
                        $content = zip_entry_read($cfile, $size);
                        $sname = md5($sname . time());
                        $newfile = file_put_contents("$directory/$sname.$ext", $content);
                        $files[] = array(
                            'sname' => $sname,
                            'title' => $title,
                            'tmpfile' => "$directory/$sname.$ext",
                            'filename' => "$sname.$ext",
                        );
                        $this->message .= "$size bajtów, ok.";
                        zip_entry_close($cfile);
                    }
                    //seba:musi być ty ten warunek, zeby lista plików się generowała
                    //$check_point = $this->getTime();
                    $czas = (microtime(true) - $Start);
                    //	print_rr($czas);
                    //	var_dump($czas > 0.02);
                    $limit = 0.10;
                    if ($czas > $limit) {
                        break;
                    }
                }
                $this->message .= "\nZamykam plik.";
                zip_close($zipfile);
                break;
            case 'application/x-bzip2':
                $this->message = 'Obsługa plików bzip2 wkrótce.';
                break;
            case 'application/gzip':
                $this->message = 'Obsługa plików gzip wkrótce.';
                break;
            default:
                $this->message = 'Nieznany typ pliku (nie mogę rozpakować)!';
                break;
        }
        if (count($files)) {
            /* Ustalenie kolejności */
            $crit = new Criteria();
            $crit->addDescendingOrderByColumn(GiObrazPeer::KOLEJNOSC);
            $crit->add(GiObrazPeer::GALERIA_ID, $gid);
            $max = GiObrazPeer::doSelectOne($crit);

            $licznik = (method_exists($max, 'getKolejnosc')) ? $max->getKolejnosc() : 0;

            foreach ($files as $file_array) {
                ++$licznik; // zwiększanie licznika do nazwy i kolejności

                $base_dir = sfConfig::get('sf_upload_dir') . "/temp/gali/gal_$gid/";
                $directory = sfConfig::get('sf_upload_dir') . "/temp/gali/gal_$gid";

                $sname = $file_array['sname'];
                $title = $file_array['title'];
                $filename = $file_array['filename'];
                $tmpfile = $file_array['tmpfile'];

                $new = array();

                if (UploadFileForm::check_image($tmpfile, 'image')) {
                    $exif = @exif_read_data($tmpfile);
  
                    Functions::wygenerujMiniaturkiPrzyUploadzie($directory, $filename, $base_dir, array('mini', 'thumb', 'normal'), 'gali_config_', $filename);

                    $this->filepath = "/uploads/temp/gali/gal_$gid/$filename";
                    $this->minifile = "/uploads/temp/gali/gal_$gid/mini_$filename";
                    $this->thumbfile = "/uploads/temp/gali/gal_$gid/thumb_$filename";
                    $this->normalfile = "/uploads/temp/gali/gal_$gid/normal_$filename";

                    $new[$gid][$filename] = $filename;

                    try {
                        $object = new GiObraz();
                        $object->setGaleriaId($gid);
                        $object->setKolejnosc($licznik);
                        $object->setNazwaPliku($filename);
                        $object->setTytul('Zdjęcie ' . $licznik);
                        if (!empty($exif['DateTime'])) {
                            $object->setExifData($exif['DateTime']);
                        }
                        $object->save();

                        $culture = $this->getUser()->getCulture();
                        $object_i18n = GiObrazI18nPeer::retrieveByPK($object->getId(), $culture);
                        if (!is_object($object_i18n)) {
                            $object_i18n = new GiObrazI18n();
                            $object_i18n->setId($object->getId());
                            $object_i18n->setCulture($culture);
                        }
                        $object_i18n->setNazwa('Zdjęcie ' . $licznik);
                        $object_i18n->save();
                    } catch (PropelException $e) {
                        echo "(Flash Upload) " . $e->getMessage() . "\n";
                        $oarray = $object->toArray();
                        $rarrray = $request->getGetParameters();
                        foreach ($oarray as $key => $val) {
                            echo "[$key] => $val\n";
                        }
                    }
                }
            }
        }

        //seba: wysłanie requesta z aktualnym numerem zdjęcia
        if ($czy_koniec == false) {
            $this->setLayout(false);
            $this->redirect('igaleria/extract?name_count=' . $name_count . '&gid=' . $gid);
        }

        Functions::rrmdir(sfConfig::get('sf_upload_dir') . '/temp/gali/gal_' . $gid . '/work/');
    }

    public function executeConfig(sfWebRequest $request) {
        $this->setLayout('admin');

        $this->messages = '';
        $gali_def = array(
            'mini' => sfConfig::get('app_size_mini'),
            'thumb' => sfConfig::get('app_size_thumb'),
            'normal' => sfConfig::get('app_size_normal'),
            'flash' => sfConfig::get('app_size_flash'),
            'max' => sfConfig::get('app_size_max'),
            'background_color' => '#333333',
            'border_color' => '#FFFFFF',
//      'padding' => '10px',
        );

        $gali = UstawieniePeer::getProperties('gali_config');
        $gali = array_merge($gali_def, $gali);

        if ($request->isMethod('post') && $request->hasParameter('gali_config')) {
            $gali_post = $request->getParameter('gali_config');
            $gali = array_merge($gali, $gali_post);
            UstawieniePeer::setProperties('gali_config', $gali_post);
            $this->getUser()->setFlash('notice', 'Zapis przebiegł pomyślnie.');
            $this->redirect('igaleria/config');
        }

        $this->form = new GaleriaISettingsForm($gali);
    }

    public function executeSort(sfWebRequest $request) {
        $this->text = "Brak parametrów!";
        $this->obrazki = array();
        if ($request->isMethod('post') && $request->hasParameter('gal_kolejnosc')) {
            $this->setTemplate('message');
            $ids = $request->getParameter('gal_kolejnosc');
            $obrazki = GiObrazPeer::retrieveByPKs($ids);
            $kol = array_flip($ids);

            foreach ($obrazki as $obraz) {
                $obraz->setKolejnosc($kol[$obraz->getId()]);
                $obraz->save();
            }
            $this->text = "Kolejność została zmieniona.";
            $this->obrazki = $obrazki;
        } else {
            $id = $request->getParameter('id');
            if (!$id)
                $id = $this->getUser()->getAttribute('gali_id');
            $crit = new Criteria();
            $crit->add(GiObrazPeer::GALERIA_ID, $id);
            $crit->addAscendingOrderByColumn(GiObrazPeer::KOLEJNOSC);
            $obrazki = GiObrazPeer::doSelect($crit);
            foreach ($obrazki as $obr) {
                $this->obrazki[] = new GiObrazForm($obr);
            }
            $this->text = '';
        }
    }

    protected function processFilters() {
        $filters = $this->getRequestParameter('igaleria_i18n_filters');
        if ($filters) {
            $this->getUser()->setAttribute('filters', $filters, 'sf_admin/igaleria/filters');
        }

        if (!$this->getUser()->getAttribute('filters', null, 'sf_admin/igaleria/filters')) {
            
        }
    }

    public function executeReloadPhotoList(sfWebRequest $request) {
        $this->setLayout(false);

        $this->galery_id = $request->getParameter('galery_id', null);

        if (!empty($this->galery_id))
            return $this->renderPartial('igaleria/jqueryUpload');
        else
            return sfView::NONE;
    }

    /**
     * metoda generujaca na nowo miniaturki (mini, thumb, normal)
     * @param       sfWebRequest $request 
     * @param       bool forced czy nadpisywac istniejace pliki
     * @param       bool update_pub czy aktualizowac artykuly opublikowane
     * @author      Tomasz Glowinski, 2013
     */
    public function executeRegenerateThumbnails(sfWebRequest $request) {
        // USTAWIENIA ----------------------------------------------------------
        // sciezka do katalogu artykulow (uwaga! jesli niepusty musi konczyc sie symbolem /)
        $source_dir = sfConfig::get('sf_upload_dir') . '/temp/gali/';

        // przedrostek kazdego artykulu (uwaga! musi konczyc sie symbolem *)
        $art_prefix = 'gal_*';

        // podkatalog z plikami oryginalnymi (uwaga! jesli niepusty musi konczyc sie symbolem /)
        $source_subdir = '';

        // podkatalog z miniaturami (uwaga! jesli niepusty musi konczyc sie symbolem /)
        $thumbnails_subdir = '';

        // uzyj podanej konfiguracji
        $use_config = 'gali_config_';

        // wygeneruj miniatury o podanych przedrostkach (uwaga! przedrostki musza miec swoja konfiguracje)
        $gen_thumbnails = array('mini', 'thumb', 'normal', 'max');

        // ---------------------------------------------------------------------
        // czas rozpoczecia procesu
        if (!$this->getUser()->hasAttribute('regenerateThumbnails-start_time') || !($this->getUser()->getAttribute('regenerateThumbnails-start_time')))
            $this->getUser()->setAttribute('regenerateThumbnails-start_time', microtime(true));

        // czas ostatniej przerwy wykonywania skryptu
        if (!$this->getUser()->hasAttribute('regenerateThumbnails-last_break_time') || !($this->getUser()->getAttribute('regenerateThumbnails-last_break_time')))
            $this->getUser()->setAttribute('regenerateThumbnails-last_break_time', microtime(true));

        // ilosc przerw
        if (!$this->getUser()->hasAttribute('regenerateThumbnails-breaks') || !($this->getUser()->getAttribute('regenerateThumbnails-breaks')))
            $this->getUser()->setAttribute('regenerateThumbnails-breaks', 1);

        // maksymalny czas na wykonanie partii
        $max_time = ini_get('max_execution_time') - 5;

        // jakosc generowanych grafik
        $quality = sfConfig::get('app_miniatures_quality');

        // tryb wymuszonej regeneracji (true spowoduje nadpisanie istniejacych miniatur
        $forced = $request->getParameter('forced', false);

        // tryb aktualizacji plikow publikowanych
        $update_pub = $request->getParameter('update_pub', false);

        // ilosc zregenerowanych grafik
        $gen_count = $this->getUser()->getAttribute('regenerateThumbnails-gen_count', 0);

        // lista blednych grafik
        $errors = $this->getUser()->getAttribute('regenerateThumbnails-errors', array());

        // wyszukuje katalogow artykulow
        $news_folders = glob($source_dir . $art_prefix, GLOB_MARK | GLOB_ONLYDIR);

        // ile pierwszych katalogow pominac jako zregenerowane
        $regenerated = $this->getUser()->getAttribute('regenerateThumbnails-regenerated', -1);

        // Watermark      
        $watermark_config = UstawieniePeer::getProperties('graf_config_watermark');


        // petla po katalogach
        foreach ($news_folders as $key => $folder) {
            // pomijam zregenerowane wczesniej katalogi
            if ($key <= $regenerated)
                continue;

            // sprawdzam, czy zostal utworzony katalog zrodlowy z zajawkami (nie = nie ma grafik)
            $folder_path = $folder . $source_subdir;
            if (!is_dir($folder_path))
                continue;

            // wyszukuje zaladowane obrazki zajawkowe
            $images = preg_grep('/.+mini_.+$|.+normal_.+$|.+thumb_.+$|.+orginal_.+$/', glob($folder_path . '*.{jpg,png,gif,jpeg,JPG,PNG,GIF,JPEG}', GLOB_BRACE), PREG_GREP_INVERT);

            // petla po obrazkach
            foreach ($images as $img_key => $img) {
                try {
                    // katalog docelowy miniaturek
                    $temp_path = $folder_path . $thumbnails_subdir;
                    $pub_path = str_replace('temp', 'pub', $temp_path);
                    $file_name = str_replace($folder_path, '', $img);

                    // Biorę obrazek typu orginal
                    $source_img = str_replace($temp_path, $temp_path . 'orginal_', $img);

                    // tworzenie katalogu z miniaturkami w razie potrzeby
                    if (!is_dir($temp_path))
                        mkdir($pathname, 0775, true);

                    // generowanie miniaturek
                    foreach ($gen_thumbnails as $thumbnail_type) {
                        $thumbnail = $temp_path . (($thumbnail_type == 'max') ? '' : $thumbnail_type . '_') . $file_name;
                        if (!file_exists($thumbnail) || $forced) {
                            $sizes = UstawieniePeer::getProperties($use_config . $thumbnail_type);
                            if (count($sizes) < 2) {
                                $sizes = sfConfig::get('app_size_' . $thumbnail_type);
                            }

                            $gfx = new sfImage($source_img);
                            $gfx->thumbnail($sizes['x'], $sizes['y'], array_key_exists('behaviour', $sizes) ? $sizes['behaviour'] : 'scale');
                            $gfx->setQuality($quality);
                            $gfx->saveAs($thumbnail);

                            // nakładanie wasermarka
                            if (isset($watermark_config['show']) && $watermark_config['show'] == 1) {
                                $margin = $watermark_config['margin'];
                                $pos = $watermark_config['pos'];
                                $watermark_src = sfConfig::get('sf_upload_dir') . "/" . $watermark_config['file'];
                                UploadFileForm::addWatermark($thumbnail, $watermark_src, null, $pos, $margin);
                            }

                            $gen_count++;

                            if ($update_pub) {
                                if (!is_dir($pub_path))
                                    mkdir($pub_path, 0775, true);

                                $thumbnail_pub = $pub_path . (($thumbnail_type == 'max') ? '' : $thumbnail_type . '_') . $file_name;
                                if (!file_exists($thumbnail) || $forced) {
                                    copy($thumbnail, $thumbnail_pub);
                                    $gen_count++;
                                }
                            }
                        }
                    }
                } catch (sfStopException $e) {
                    // nothnig
                } catch (Exception $e) {
                    $errors[] = $e->getMessage();
                }
            }

            // fragmentaryzacja wykonywania skryptu
            if ($key + 1 % 10000 == 0 || (microtime(true) - $this->getUser()->getAttribute('regenerateThumbnails-last_break_time') > $max_time)) {
                $this->getUser()->setAttribute('regenerateThumbnails-regenerated', $key);
                $this->getUser()->setAttribute('regenerateThumbnails-errors', $errors);
                $this->getUser()->setAttribute('regenerateThumbnails-gen_count', $gen_count);
                $this->getUser()->setAttribute('regenerateThumbnails-last_break_time', microtime(true));
                $this->getUser()->setAttribute('regenerateThumbnails-breaks', $this->getUser()->getAttribute('regenerateThumbnails-breaks') + 1);
                $this->redirect($_SERVER['REQUEST_URI']);
            }
        }

        $execution_time = (microtime(true) - $this->getUser()->getAttribute('regenerateThumbnails-start_time')) . ' sek';
        $execution_parts = $this->getUser()->getAttribute('regenerateThumbnails-breaks');
        $this->getUser()->setAttribute('regenerateThumbnails-regenerated', null);
        $this->getUser()->setAttribute('regenerateThumbnails-errors', null);
        $this->getUser()->setAttribute('regenerateThumbnails-gen_count', null);
        $this->getUser()->setAttribute('regenerateThumbnails-start_time', null);
        $this->getUser()->setAttribute('regenerateThumbnails-breaks', null);

        if ($gen_count > 0 && empty($errors))
            $this->getUser()->setFlash('notice', 'Pomyślnie wygenerowano miniatury (ilość: ' . $gen_count . ', czas wykonania: ' . $execution_time . ' w ' . $execution_parts . ' etapach)');
        elseif (count($errors) > 0)
            $this->getUser()->setFlash('error', 'Wystąpiły błędy podczas generowania miniatur (ilość wygenerowanych: ' . $gen_count . ', błędy: ' . implode(', ', $errors) . ')');
        else
            $this->getUser()->setFlash('error', 'Nie ma plików do wygenerowania przy wybranych ustawieniach');

        $this->redirect('frontend/index');
    }

    /**
     * metoda czyszczaca i budujaca indexy Lucene
     * @author      Tomasz Glowinski, 2014
     */
    public function executeRegenerateLuceneIndex() {
        $mod_short = 'gali';

        // czyszczenie calego idexu
        Functions::clearLuceneIndex($mod_short);

        // ponowne indexowanie kazdego artykulu
        $c = new Criteria();
        $rs = AktualnoscPubPeer::doSelect($c);

        foreach ($rs as $obj)
            $obj->updateLuceneIndex();

        sfContext::getInstance()->getConfiguration()->loadHelpers(array('I18N'));
        $this->getUser()->setFlash('notice', __('Zindeksowano ' . count($rs) . ' artykułów.'));
        $this->redirect('igaleria/list');
    }

}
