<?php

/**
 * igobraz actions.
 *
 * @package    sam3
 * @subpackage galerie
 * @author     Alfred Broda
 * @version    SVN: $Id: actions.class.php  alfred $
 */
class igkategoriaActions extends autoigkategoriaActions {
    /**
     * Enter description here...
     *
     * @param sfWebRequest $request
     */
    public function executeEdit($request) {
        $this->message = '';
        if($request->getParameter('postsave', null) == 'true') {
            $this->message = "Zapis przebiegł pomyślnie.";
            $this->setLayout('default');
        }
        $object = null;
        if ($request->getParameter('g_kategoria')) {
            $id = $request->getParameter('g_kategoria');
            $id = $id['id'];
            $object = GiKategoriaPeer::retrieveByPK($id);
        }
        else {
            $id = $request->getParameter('id');
            $object = GiKategoriaPeer::retrieveByPK($id);
        }
        $this->form = new GiKategoriaForm($object);
        $this->errors = array();
        if ($request->isMethod('post')) {
            $cat = $request->getParameter('g_kategoria');
            $this->form->bind($cat);
            if (!$this->form->isValid()) {
                $this->message = "Formularz zwiera błędy.";
                $shema = $this->form->getErrorsNice();
                $this->errors = $shema;
            }
            else {
                try {
                    $this->form->save();
                    $this->id = $this->form->getObject()->getId();
                    $this->redirect('igkategoria/edit?id='.$this->id.'&postsave=true');
                }
                catch (PropelException $e) {
                                        $this->errors[] = $e->getMessage();
                    $this->message = "Błąd podczas zapisu.";
                }
            }
        }
    }

    public function executeSave($request) {
        $this->forward('igkategoria','edit');
    }

    public function executeDelete($request) {
        $id = $request->getParameter('id');

        try {
            GiKategoriaPeer::retrieveByPK($id)->delete();
        }
        catch (PropelException $e) {
            $this->getUser()->setFlash('error', $e->getMessage());
        }
        $this->text = "Kategoria została usunięta.";
    }

    public function executeCreate($request) {
        $this->forward('igkategoria','edit');
    }

    public function executeIndex($request) {
    }

    public function executeStruktura($request) {
    }

    public function executeMove(sfWebRequest $request) {
        $this->messages = null;
        $this->errors = array();
        if ($request->hasParameter('id')) {
            $obj = GiKategoriaPeer::retrieveByPK($request->getParameter('id'));
            if ($obj) {
                switch ($request->getParameter('move')) {
                    case 'up':
                        $obj->moveUp();
                        $this->messages = "Kategoria <b>".$obj->getNazwa()."</b> przeniesiona w górę prawidłowo.";
                        break;
                    case 'down':
                        $obj->moveDown();
                        $this->messages = "Kategoria <b>".$obj->getNazwa()."</b> przeniesiona w dół prawidłowo.";
                        break;
                    default:
                        $this->messages = null;
                        $obj = null;
                }
                if (!$this->messages)
                    $this->errors[] = "Błąd przy zmianie kolejności obiektu <b>".$obj->getNazwa()."</b>";
            }
            else {
                if (!$this->messages) $this->messages = "Błedne ID obiektu lub zmiana jest nieokreślona";
            }
        }
        else {
            $this->errors[] = "Nieokreślone ID obiektu";
        }
    }
}
