<?php
class igkategoriaComponents extends sfComponents {

    public function executeStruktura(sfWebRequest $request) {
        $tree = new Tree(new GiKategoriaPeer(),'galp-struct');
        $tree->setMethods(array('Select','Subs'));

        $user = $this->getUser();

        $ggcrit = new Criteria();

        $ggcrit->addAscendingOrderByColumn(GaleriaIPeer::KOLEJNOSC);
        $gscrit = new Criteria();
        $gscrit->addAscendingOrderByColumn(GiSubkategoriaPeer::KOLEJNOSC);
        $gkcrit = new Criteria();
        $gkcrit->addAscendingOrderByColumn(GiKategoriaPeer::KOLEJNOSC);
        $gocrit = new Criteria();
//        if ($user->checkPermission('gali_global','edit')!=1) $ggcrit->add(GiObrazPeer::UZYTKOWNIK_ID,$user->getId());
        $gocrit->addAscendingOrderByColumn(GiObrazPeer::KOLEJNOSC);

        $tree->setArguments(array(
            array($gkcrit),
            array($gscrit),
            array($ggcrit),
            array($gocrit)
        ));

        $tree->setOptions(array(
            'mode'			=> 'ajax',
            'max_levels'	=> 4,
            'unfold'		=> false,
        ));

        $update_struct = remote_function(array(
            'update'	=> 'cms_center_panel_content',
            'url' 	=> 'igkategoria/struktura',
            'loading'	=> "setLoader('cms_center_panel_content',1)",
            'complete'	=> "clearLoader(1)",
        ));
        $tactions = array(
            // ### Kategorie ###
            array(
            'mup'=>array(
            'label'=>link_to_remote(image_tag('admin/up.png', array(
                'alt' => '+',
                'style' => 'float: right',
                'title' => __('up'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igkategoria/move?move=up&id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "$update_struct; clearLoader(2);",
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'publish')),
            ),
            'mdown'=>array(
            'label'=>link_to_remote(image_tag('admin/down.png', array(
                'alt' => '-',
                'style' => 'float: right',
                'title' => __('down'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igkategoria/move?move=down&id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "$update_struct; clearLoader(2);",
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'publish')),
            ),
            'delete'=>array(
            'label'=>link_to_remote(image_tag('admin/delete_icon.png', array(
                'alt' => __('delete'),
                'style' => 'float: right',
                'title' => __('delete'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igkategoria/delete?id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "$('actions').innerHTML='';$update_struct; clearLoader(2);",
                'confirm' => __('Czy na pewno chcesz usunąć?'),
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'publish')),
            ),
            'edit'=>array(
            'label'=>link_to_remote(image_tag('admin/edit.png', array(
                'alt' => __('edit'),
                'style' => 'float: right',
                'title' => __('edit'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igkategoria/edit?id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "moveActions(); clearLoader(2)",
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'publish')),
            ),
            'add'=>array(
            'label'=>link_to_remote(image_tag('admin/add_icon.png', array(
                'alt' => __('create'),
                'style' => 'float: left',
                'title' => __('create'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igsubkategoria/create?gkid=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "moveActions(); clearLoader(2)",
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'publish')),
            ),
            ),
            // ### Subkategorie ###
            array(
            'mup'=>array(
            'label'=>link_to_remote(image_tag('admin/up.png', array(
                'alt' => '+',
                'style' => 'float: right',
                'title' => __('up'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igsubkategoria/move?move=up&id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "$update_struct; clearLoader(2);",
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'publish')),
            ),
            'mdown'=>array(
            'label'=>link_to_remote(image_tag('admin/down.png', array(
                'alt' => '-',
                'style' => 'float: right',
                'title' => __('down'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igsubkategoria/move?move=down&id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "$update_struct; clearLoader(2);",
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'publish')),
            ),
            'delete'=>array(
            'label'=>link_to_remote(image_tag('admin/delete_icon.png', array(
                'alt' => __('delete'),
                'style' => 'float: right',
                'title' => __('delete'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igsubkategoria/delete?id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "$('actions').innerHTML='';$update_struct; clearLoader(2);",
                'confirm' => __('Czy na pewno chcesz usunąć?'),
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'publish')),
            ),
            'edit'=>array(
            'label'=>link_to_remote(image_tag('admin/edit.png', array(
                'alt' => __('edit'),
                'style' => 'float: right',
                'title' => __('edit'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igsubkategoria/edit?id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "moveActions(); clearLoader(2)",
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'publish')),
            ),
            'add'=>array(
            'label'=>link_to_remote(image_tag('admin/add_icon.png', array(
                'alt' => __('create'),
                'style' => 'float: left',
                'title' => __('create'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igaleria/create?gsid=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "moveActions(); clearLoader(2)",
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'create')),
            ),
            ),
            // ### Galerie ###
            array(
            'mup'=>array(
            'label'=>link_to_remote(image_tag('admin/up.png', array(
                'alt' => '+',
                'style' => 'float: right',
                'title' => __('up'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igaleria/move?move=up&id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "$update_struct; clearLoader(2);",
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'publish')),
            ),
            'mdown'=>array(
            'label'=>link_to_remote(image_tag('admin/down.png', array(
                'alt' => '-',
                'style' => 'float: right',
                'title' => __('down'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igaleria/move?move=down&id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "$update_struct; clearLoader(2);",
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'publish')),
            ),
            'delete'=>array(
            'label'=>link_to_remote(image_tag('admin/delete_icon.png', array(
                'alt' => __('delete'),
                'style' => 'float: right',
                'title' => __('delete'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igaleria/delete?id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "$('actions').innerHTML='';$update_struct; clearLoader(2);",
                'confirm' => __('Czy na pewno chcesz usunąć?'),
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'publish')),
            ),
            'edit'=>array(
            'label'=>link_to_remote(image_tag('admin/edit.png', array(
                'alt' 	=> __('edit'),
                'style' => 'float: right',
                'title'	=> __('edit'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igaleria/edit?id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "moveActions(); clearLoader(2)",
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'edit')),
            ),
            'add'=>array(
            'label'=>link_to_remote(image_tag('admin/add_icon.png', array(
                'alt' => __('create'),
                'style' => 'float: left',
                'title' => __('create'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igobraz/create?gid=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "moveActions(); clearLoader(2)",
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'edit')),
            ),
            ),
            // ### Obrazki ###
            array(
            'delete'=>array(
            'label'=>link_to_remote(image_tag('admin/delete_icon.png', array(
                'alt' 	=> __('delete'),
                'style' => 'float: left',
                'title'	=> __('delete'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igobraz/delete?id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "$('actions').innerHTML='';$update_struct; clearLoader(2);",
                'confirm' => __('Czy na pewno chcesz usunąć?'),
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'edit')),
            ),
            'edit'=>array(
            'label'=>link_to_remote(image_tag('admin/edit.png', array(
                'alt' 	=> __('edit'),
                'style' => 'float: left',
                'title'	=> __('edit'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igobraz/edit?id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "moveActions(); clearLoader(2)",
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'edit')),
            ),
            'mup'=>array(
            'label'=>link_to_remote(image_tag('admin/up.png', array(
                'alt' => '+',
                'style' => 'float: right',
                'title' => __('up'))),array(
                'method'	=> 'get',
                'script'	=> true,
                'update'	=> 'cms_right_panel',
                'url'		=> 'igobraz/move?move=up&id=%%PK%%',
                'loading'	=> "setLoader('cms_right_panel',2)",
                'complete'	=> "$update_struct; clearLoader(2);",
                'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'edit')),
            ),
            'mdown'=>array(
            'label'=>link_to_remote(image_tag('admin/down.png', array(
            'alt' => '-',
            'style' => 'float: right',
            'title' => __('down'))),array(
            'method'	=> 'get',
            'script'	=> true,
            'update'	=> 'cms_right_panel',
            'url'		=> 'igobraz/move?move=down&id=%%PK%%',
            'loading'	=> "setLoader('cms_right_panel',2)",
            'complete'	=> "$update_struct; clearLoader(2);",
            'before'    => '$("updater").innerHTML=""'
                    )),
                'condition' => array(
                    'method'    => 'checkPermission',
                    'params'    => array(null,'edit')),
            ),
        ));

        if (sfConfig::get('multisite')) unset(
                $tactions[0]['delete'],
                $tactions[0]['edit'],
                $tactions[0]['mup'],
                $tactions[0]['mdown']
            );

        $tree->setActions($tactions);
        $this->treemenu = $tree;

        $this->update = $update_struct;
    }
}