<?php

/**
 * GaleriaI form.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfPropelFormTemplate.php 10377 2008-07-21 07:10:32Z dwhittle $
 */
class IgaleriaForm extends BaseGaleriaIForm
{

    public function configure()
    {
        $this->getWidgetSchema()->getFormFormatter()->setHelpFormat('%help%');
    }

    public function setup()
    {
        $critk = GiSubkategoriaPeer::buildBasicCriteria();
        
        $cat = new sfWidgetFormSelect(array(
            'choices' => GiSubkategoriaPeer::getSubcatsForSelect($critk)));


        $this->setWidgets(array(
            'id' => new sfWidgetFormInputHidden(),
            'uzytkownik_dane' => new sfWidgetFormInput(),
            'uzytkownik_kontakt' => new sfWidgetFormInput(),
            'subkategoria_id' => $cat,
        ));

        $this->setValidators(array(
            'id' => new sfValidatorPropelChoice(array('model' => 'GaleriaI', 'column' => 'id', 'required' => false)),
            'uzytkownik_dane' => new sfValidatorString(array('max_length' => 255, 'required' => false)),
            'uzytkownik_kontakt' => new ciValidatorEmail(array('max_length' => 255, 'required' => true)),
            'subkategoria_id' => new sfValidatorPropelChoice(array('model' => 'GiSubkategoria', 'column' => 'id'))
        ));


        $this->widgetSchema->setLabels(array(
            'subkategoria_id' => 'Kategoria',
            'uzytkownik_dane' => 'Autor galerii',
            'uzytkownik_kontakt' => 'Adres email',
        ));

        $this->widgetSchema->setHelps(array(
            'subkategoria_id' => 'Proszę wybrać tematykę galerii.',
            'uzytkownik_dane' => 'Podaj imię i nazwisko lub pseudonim.',
            'uzytkownik_kontakt' => 'Proszę podać adres email osoby zgłaszającej galerię.',
        ));

        unset($this['widoczna'], $this['obrazek_id'], $this['opublikowal']);

        $cultures = JezykTblPeer::getCulturesForModul('gali');
        $this->embedI18n($cultures);

        $this->widgetSchema->setNameFormat('galeria[%s]');
        $this->widgetSchema->setFormFormatterName('sam3');
        $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

        $this->getWidgetSchema()->getFormFormatter()->setHelpFormat('%help%');
        $this->setRequiredFields();
    }

}