<?php

class igobrazActions extends sfActions {
   
    public function executeIndex(sfWebRequest $request) {
        $this->setLayout('false');
        
        $id = $request->getParameter('galery_id');
        $path = $request->getParameter('path');
        $object = $request->getParameter('gal_object');
        $application = $request->getParameter('app');
        
        $options = array(
            'delete_type' => 'POST',
            'upload_path' => 'temp/'.$path.'/gal_'.$id,
            'config' => 'gali_config_',
            'prefixes' => array('mini', 'thumb', 'normal'),
            'galery_id' => $id,
            'crop' => true,
            'gal_object' => $object,
            'app' => $application,
            'path' => $path
        );
       // $options = array();
        $upload_handler = new msUploadHandler($options);
        exit();
    }

    /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    public function executeUpdate(sfWebRequest $request) {
        $this->setLayout(false);
        $object = null;
        if ($request->getParameter('obraz')) {
            $obraz = $request->getParameter('obraz');
            $id = $obraz['id'];
            $object = GiObrazPeer::retrieveByPK($id);
        } else {
            $id = $request->getParameter('id');
            $object = GiObrazPeer::retrieveByPK($id);
            if (!$request->isMethod('post')) {
                $before = $object;
            }
        }

        if (!$object) {
            $object = new GiObraz();
            $gid = $request->getParameter('gid');
            if (!$gid)
                $gid = $this->getUser()->getAttribute('gali_id');
            $object->setGaleriaId($gid);
        } else {
            $gid = $object->getGaleriaId();
        }

        // Uprawnienia
        $this->form = new GiObrazForm($object);

        $this->errors = array();

        if ($request->isMethod('post')) {
            $obraz = $request->getParameter('obraz');

            $obraz = array_merge($object->toArray(BasePeer::TYPE_FIELDNAME), $obraz);
            $cultures = JezykTblPeer::getCulturesForModul('gali');

            if ($object->isNew() && isset($obraz['title']) && $obraz['title']) {
                foreach ($cultures as $cult) {
                    if (!$obraz[$cult]['nazwa']) {
                        $obraz[$cult]['nazwa'] = $obraz['title'];
                    }
                }
            }

            $this->form->bind($obraz);
            if (!$this->form->isValid()) {
                $this->errors = $this->form->getErrorsNice();
                $this->message = "Błąd w formularzu!";
            } else {
                try {
                    $isNew = $this->form->getObject()->isNew();
                    $this->form->save();
                    $this->message = "Zapis przebiegł pomyślnie.";
                    $save_ok = true;
                } catch (PropelException $e) {
                    $this->errors[] = $e->getMessage();
                    $this->message = "Błąd podczas zapisu.";
                }
            }
            return self::executeUpdateView($request);
        }
    }

    public function executeUpdateView(sfWebRequest $request) {
        $this->setLayout(false);
        $criteria = new Criteria();
        $criteria->add(GiObrazPeer::GALERIA_ID, $request->getParameter('gid'));
        $criteria->addAscendingOrderByColumn(GiObrazPeer::KOLEJNOSC);
        $obrazki = GiObrazPeer::doSelectWithI18n($criteria);

        $this->lista_obrazow = array();
        foreach ($obrazki as $list) {
            $this->lista_obrazow[] = new GiObrazForm($list);
        }

        $galeria = GaleriaIPeer::retrieveByPK($request->getParameter('gid'));
        if ($galeria->getObrazId()) {
            $this->zajawka = $galeria->getObrazId();
        } else {
            $this->zajawka = -1;
        }
        return $this->renderPartial('list', array('lista_obrazow' => $this->lista_obrazow, 'gid' => $request->getParameter('gid'), 'zajawka' => $this->zajawka));
    }

    public function executeSave(sfWebRequest $request) {
        $this->forward('igobraz', 'update');
    }

    public function executeDelete(sfWebRequest $request) {

        //$request->checkCSRFProtection();
        if ($request->isXmlHttpRequest()):
            $this->forward404Unless($galeriaObraz = GiObrazPeer::retrieveByPK($request->getParameter('id')), sprintf('Obraz nie istnieje (%s).', $request->getParameter('id')));
            $galeriaObraz->delete();
        endif;
        return self::executeUpdateView($request);
    }

    public function executeZajawka(sfWebRequest $request) {
        $this->setLayout(false);
        if ($request->hasParameter('gid')):
            $zajawka = GaleriaIPeer::retrieveByPK($request->getParameter('gid'));
            if ($zajawka->getObrazId() == $request->getParameter('id')):
                $zajawka->setObrazId(null);
            else:
                $zajawka->setObrazId($request->getParameter('id'));
            endif;
            $zajawka->save();
        endif;
        return self::executeUpdateView($request);
    }

    public function executeThumbnailSave(sfWebRequest $request) {
        if (!$request->isMethod('post')) {
            $this->redirect('igaleria/index');
        }

        $nazwa = $_GET['filename'];
        $size = $request->getParameter('size');
        $repl = sfConfig::get('sf_upload_dir');

        $preg_pattern = "/(.*)uploads/";
        $filename = preg_replace($preg_pattern, $repl, $nazwa);

        $id = null;
        if (preg_match('#gal_([0-9]+)#', $filename, $matches) && isset($matches[1])) {
            $id = array_pop($matches);
        }

        $thumb = str_replace('orginal_', $size . '_', $filename);

        $t_file = fopen($thumb, 'wb');
        fwrite($t_file, $GLOBALS["HTTP_RAW_POST_DATA"]);
        fclose($t_file);

        $watermark_config = UstawieniePeer::getProperties('graf_config_watermark');
        if (isset($watermark_config['show']) && $watermark_config['show'] == 1) {
            //znak wodny
            $margin = $watermark_config['margin'];
            $pos = $watermark_config['pos'];
            $watermark_src = sfConfig::get('sf_upload_dir') . "/" . $watermark_config['file'];
            UploadFileForm::addWatermark($thumb, $watermark_src, null, $pos, $margin);
        }

        if ($id) {
            $this->redirect('igaleria/edit?id=' . $id);
        } else {
            $this->redirect('igaleria/index');
        }
    }

}
