<?php

/**
 * GiObraz form.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfPropelFormTemplate.php 10377 2008-07-21 07:10:32Z dwhittle $
 */
class GiObrazForm extends BaseGiObrazForm {

    public function setup() {
        $this->setWidgets(array(
            'id' => new sfWidgetFormInputHidden(),
            'nazwa_pliku' => new sfWidgetFormInputHidden(),
            'kolejnosc' => new sfWidgetFormInput(),
            'tytul' => new sfWidgetFormInput(array(), array('class' => 'required')),
            'galeria_id' => new sfWidgetFormPropelChoice(array('model' => 'GaleriaI', 'add_empty' => false)),
        ));

        $this->setValidators(array(
            'id' => new sfValidatorPropelChoice(array('model' => 'GiObraz', 'column' => 'id', 'required' => false)),
            'nazwa_pliku' => new sfValidatorString(),
            'kolejnosc' => new sfValidatorInteger(array('required' => false)),
            'galeria_id' => new sfValidatorPropelChoice(array('model' => 'GaleriaI', 'column' => 'id')),
            'tytul' => new sfValidatorString(array('max_length' => 200, 'required' => false)),
        ));

        unset($this['kolejnosc']);

        $this->widgetSchema->setLabels(array(
            'galeria_id' => 'Galeria',
            'tytul' => 'Nazwa',
        ));
        $this->widgetSchema->setHelps(array(
            'galeria_id' => 'Wskaż galerię, do której należy obraz',
            'tytul' => 'Podaj nazwę wewnętrzną obrazu, przydatne przy sortowaniu',
        ));

        $this->validatorSchema->setOption('allow_extra_fields', true);

        $cultures = JezykTblPeer::getCulturesForModul('gali');
        $this->embedI18n($cultures);
        foreach ($cultures as $cul) {

            $this->widgetSchema[$cul]['opis'] = new sfWidgetFormTextarea();
        }
        $this->widgetSchema->setNameFormat('obraz[%s]');
        $this->widgetSchema->setFormFormatterName('sam3');
        $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
    }

    public function configure() {
        $this->getWidgetSchema()->getFormFormatter()->setHelpFormat('%help%');
    }

}
