<?php
/**
 * Skeleton subclass for representing a row from the 'igaleria_obraz_tbl' table.
 *
 *
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    lib.model
 */
class GiObraz extends BaseGiObraz {
/*	public function getOpis($culture = null) {
		sfContext::getInstance()->getConfiguration()->loadHelpers('Funkcje');
		return(replaceEmail(parent::getOpis($culture)));
	} */

    public function __toString() {
        $culture = sfContext::getInstance()->getUser()->getCulture();
        if(!$culture) $culture='pl';
        if($this->getTytul($culture)) {
            return $this->getTytul($culture);
        } else {
            return $this->getTytul(sfConfig::get('app_db_default_language'));
        }

    }

    public function checkPermission(sfUser $user=null, $val=null) {
        if (!$user) {
            $user = sfContext::getInstance()->getUser();
        }
        if (!sfGuardPermission::validPerm($val)) {
            return false;
        }

        $parent = $this->getGaleriaI();
        if ($parent && $parent->checkPermission($user,$val)) return true;
        return false;
    }

    public function getMiniLink() {
        $gid = $this->getGaleriaId();
        return "/uploads/temp/gali/gal_$gid/mini_".$this->getNazwaPliku().'?rand='.rand(1,999);
    }

    public function getMiniFile() {
        $gid = $this->getGaleriaId();
        return sfConfig::get('sf_upload_dir')."/pub/gali/gal_$gid/mini_".$this->getNazwaPliku();
    }

    public function getThumbLink() {
        $gid = $this->getGaleriaId();
        return "/uploads/temp/gali/gal_$gid/thumb_".$this->getNazwaPliku().'?rand='.rand(1,999);
    }

    public function getThumbFile() {
        $gid = $this->getGaleriaId();
        return sfConfig::get('sf_upload_dir')."/temp/gali/gal_$gid/thumb_".$this->getNazwaPliku();
    }

    public function getNormalLink() {
        $gid = $this->getGaleriaId();
        return "/uploads/temp/gali/gal_$gid/normal_".$this->getNazwaPliku().'?rand='.rand(1,999);
    }

    public function getNormalFile() {
        $gid = $this->getGaleriaId();
        return sfConfig::get('sf_upload_dir')."/temp/gali/gal_$gid/normal_".$this->getNazwaPliku();
    }

    public function getOrigLink() {
        $gid = $this->getGaleriaId();
        return "/uploads/temp/gali/gal_$gid/".$this->getNazwaPliku().'?rand='.rand(1,999);
    }

    public function getOrigFile() {
        $gid = $this->getGaleriaId();
        return sfConfig::get('sf_upload_dir')."/temp/gali/gal_$gid/".$this->getNazwaPliku();
    }

    public function getFiles() {
        $filename = $this->getNazwaPliku();
        $directory = sfConfig::get('sf_upload_dir')."/temp/gali/gal_".$this->getGaleriaId();
        $new["mini_$filename"] = "$directory/mini_$filename";
        $new["thumb_$filename"] = "$directory/thumb_$filename";
        $new["normal_$filename"] = "$directory/normal_$filename";
        $new[$filename] = "$directory/$filename";
        return $new;
    }

    public static function getFilesS($id) {
        $obraz = GiObrazPeer::retrieveByPK($id);
        return $obraz->getFiles();
    }

    public function moveDown() {
        $cup = new Criteria();
        $cup->addAscendingOrderByColumn(GiObrazPeer::KOLEJNOSC);
        $cup->add(GiObrazPeer::GALERIA_ID,$this->getGaleriaId());
        $cup->add(GiObrazPeer::KOLEJNOSC,$this->getKolejnosc(),Criteria::GREATER_THAN);
        $up = GiObrazPeer::doSelectOne($cup);

        if ($up) {
            $upd = $up->getKolejnosc();
        } else {
            $upd = 'NONE';
        }
        
        if ($up) {
            $temp = $this->getKolejnosc();
            $this->setKolejnosc($up->getKolejnosc());
            $up->setKolejnosc($temp);
            $up->save();
            $upd = $up->getKolejnosc();
        } else {
            $this->setKolejnosc(($this->getKolejnosc())+1);
        }
        $this->save();
    }

    public function moveUp() {
        $cup = new Criteria();
        $cup->addDescendingOrderByColumn(GiObrazPeer::KOLEJNOSC);
        $cup->add(GiObrazPeer::GALERIA_ID,$this->getGaleriaId());
        $cup->add(GiObrazPeer::KOLEJNOSC,$this->getKolejnosc(),Criteria::LESS_THAN);
        $up = GiObrazPeer::doSelectOne($cup);

        if ($up) {
            $upd = $up->getKolejnosc();
        } else {
            $upd = 'NONE';
        }

        if ($up) {
            $temp = $this->getKolejnosc();
            $this->setKolejnosc($up->getKolejnosc());
            $up->setKolejnosc($temp);
            $up->save();
            $upd = $up->getKolejnosc();
        } else {
            $this->setKolejnosc(($this->getKolejnosc())-1);
        }
        $this->save();
    }

    public function save(PropelPDO $con = null) {
        if (!$this->isNew() && $this->isColumnModified(GiObrazPeer::GALERIA_ID)) {

            $nid = $this->getGaleriaId();

            // Przeniesienie plików
            $array = $this->toArray();

            $this->reload();
            $files = $this->getFiles();

            $this->fromArray($array);

            $directory = sfConfig::get('sf_upload_dir')."/temp/gali/gal_$nid";
            if (!is_dir($directory)) mkdir($directory,0775,true);
            foreach ($files as $name => $file) {
                if (is_file($file)) {
                    rename($file,"$directory/$name");
                }
            }

            // Kolejność
            $cup = new Criteria();
            $cup->addDescendingOrderByColumn(GiObrazPeer::KOLEJNOSC);
            $cup->add(GiObrazPeer::GALERIA_ID,$this->getGaleriaId());
            $up = GiObrazPeer::doSelectOne($cup);

            if ($up) {
                $this->setKolejnosc($up->getKolejnosc()+1);
            } else {
                $this->setKolejnosc(0);
            }
        }
        parent::save($con);
    }

    public function publish() {
        //$this->checkPermission('gali_gal_'.$this->getId(),'publish');
        $data = $this->toArray(BasePeer::TYPE_FIELDNAME);

        $main = GiObrazPubPeer::retrieveByPK($this->getId());
        if (!$main) $main = new GiObrazPub();

        foreach ($this->getGiObrazI18ns() as $i18n) {
            $i18n_data = $i18n->toArray(BasePeer::TYPE_FIELDNAME);
            unset($i18n_data['id'],$i18n_data['culture']);
            $data[$i18n->getCulture()] = $i18n_data;
        }

        $main->fromArray($data,BasePeer::TYPE_FIELDNAME);
        $publish = new GiObrazPubForm($main);
        $publish->bind($data);

        if ($publish->isValid()) {
            // Publikujemy
            try {
                $publish->save();
            }
            catch (PropelException $e) {
                throw $e;
            }
            $gid = $this->getGaleriaId();
            $files = $this->getFiles();

            $directory = sfConfig::get('sf_upload_dir')."/pub/gali/gal_$gid";

            foreach ($files as $name => $file) {
                if (!is_dir($directory)) mkdir($directory,0775,true);
                if (is_file($file)) {
                    @copy($file,"$directory/$name");
                } else {
                    $this->getUser()->setFlash('error', "Błąd publikacji: plik nie istneje: '".$file."'");
                }
            }
        }

        // Zwracamy formularz Publikacji (z ewentualnymi błędami)
        return $publish;
    }

    public function delete(PropelPDO $con = null) {

        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        $files = $this->getFiles();
        if ($con === null) {
            $con = Propel::getConnection(GiObrazPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        try {
            GiObrazPeer::doDelete($this, $con);
            $this->setDeleted(true);
            $con->commit();
        }
        catch (PropelException $e) {
            $con->rollBack();
            throw $e;
        }

        //Usuwamy pliki
        foreach ($files as $file) {
            if (is_file($file)) {
                unlink($file);
            }
        }
    }

}
