<?php

/**
 * Skeleton subclass for performing query and update operations on the 'igaleria_obraz_tbl' table.
 *
 * 
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    lib.model
 */
class GiObrazPeer extends BaseGiObrazPeer {

    /**
     * metoda zwracajaca maksymalna kolejnosc zdjec we wskazanej galerii
     * @param       int $gal_id id galerii
     * @return      int liczba oznaczajaca maksymalna kolejnosc obecnych zdjec w galerii
     * @author      Tomasz Glowinski, 2014
     */
    public static function getCurrentMaxOrderByGalleryId($gal_id) {
        $c = new CriteriaExt();
        $c->add(self::GALERIA_ID, $gal_id);
        $c->addDescendingOrderByColumn(self::KOLEJNOSC);

        $rs = self::doSelectOne($c);

        if ($rs)
            return $rs->getKolejnosc();
        else
            return 0;
    }

    /**
     * metoda zwracajaca liste zdjec z danej galerii
     * @param       int $gal_id id galerii
     * @return      array lista zdjec ze wskazanej galerii
     * @author      Tomasz Glowinski, 2014
     */
    public static function getObrazyByGalleryId($gal_id) {
        $c = new CriteriaExt();
        $c->add(self::GALERIA_ID, $gal_id);
        $c->addAscendingOrderByColumn(self::KOLEJNOSC);

        return self::doSelectWithI18n($c);
    }

}
