<?php

/**
 * Skeleton subclass for representing a row from the 'igaleria_obraz_pub' table.
 *
 *
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    lib.model
 */
class GiObrazPub extends BaseGiObrazPub {

    public function __toString() {
        return $this->getTytul(sfContext::getInstance()->getUser()->getCulture());
    }

    public function getMiniLink() {
        $gid = $this->getGaleriaId();
        return "/uploads/pub/gali/gal_$gid/mini_" . $this->getNazwaPliku();
    }

    public function getMiniFile() {
        $gid = $this->getGaleriaId();
        return sfConfig::get('sf_upload_dir') . "/pub/gali/gal_$gid/mini_" . $this->getNazwaPliku();
    }

    public function getThumbLink() {
        $gid = $this->getGaleriaId();
        return "/uploads/pub/gali/gal_$gid/thumb_" . $this->getNazwaPliku();
    }

    public function getThumbFile() {
        $gid = $this->getGaleriaId();
        return sfConfig::get('sf_upload_dir') . "/pub/gali/gal_$gid/thumb_" . $this->getNazwaPliku();
    }

    public function getNormalLink() {
        $gid = $this->getGaleriaId();
        return "/uploads/pub/gali/gal_$gid/normal_" . $this->getNazwaPliku();
    }

    public function getNormalFile() {
        $gid = $this->getGaleriaId();
        return sfConfig::get('sf_upload_dir') . "/pub/gali/gal_$gid/normal_" . $this->getNazwaPliku();
    }

    public function getOrigLink() {
        $gid = $this->getGaleriaId();
        return "/uploads/pub/gali/gal_$gid/" . $this->getNazwaPliku();
    }

    public function getOrigFile() {
        $gid = $this->getGaleriaId();
        return sfConfig::get('sf_upload_dir') . "/pub/gali/gal_$gid/" . $this->getNazwaPliku();
    }

    public function getFiles() {
        $filename = $this->getNazwaPliku();
        $directory = sfConfig::get('sf_upload_dir') . "/pub/gali/gal_" . $this->getGaleriaId();
        $new["mini_$filename"] = "$directory/mini_$filename";
        $new["thumb_$filename"] = "$directory/thumb_$filename";
        $new["normal_$filename"] = "$directory/normal_$filename";
        $new[$filename] = "$directory/$filename";
        return $new;
    }

    public function delete(PropelPDO $con = null) {
        $id = $this->getId();

        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        $files = $this->getFiles();
        if ($con === null) {
            $con = Propel::getConnection(GObrazPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        try {
            GiObrazPubPeer::doDelete($this, $con);
            $this->setDeleted(true);
            $con->commit();
        } catch (PropelException $e) {
            $con->rollBack();
            throw $e;
        }

        //Usuwamy pliki
        foreach ($files as $file) {
            if (is_file($file)) {
                unlink($file);
            }
        }
    }
    
    public static function getObrazekZajawki($id = null) {
        $zdjecia = new GiObrazPubPeer();
        $c = new Criteria();
        $c->add(GiObrazPubPeer::ID, $id);
        return $zdjecia->doSelectOne($c);
    }
    public static function getObrazekNazwaPliku($id = null) {
        $zdjecia = new GiObrazPubPeer();
        $c = new Criteria();
        $c->add(GiObrazPubPeer::ID, $id);
        $file = $zdjecia->doSelectOne($c);
        
        return $file->getNazwaPliku();
    }

}
