<?php


abstract class BaseGiKategoria extends BaseObject  implements Persistent {


  const PEER = 'GiKategoriaPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $updated_at;

	
	protected $created_at;

	
	protected $kolejnosc;

	
	protected $widoczna;

	
	protected $collGiKategoriaI18ns;

	
	private $lastGiKategoriaI18nCriteria = null;

	
	protected $collGiSubkategorias;

	
	private $lastGiSubkategoriaCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

  
  protected $culture;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->kolejnosc = 0;
		$this->widoczna = 0;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->updated_at === null) {
			return null;
		}


		if ($this->updated_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->updated_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->updated_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getKolejnosc()
	{
		return $this->kolejnosc;
	}

	
	public function getWidoczna()
	{
		return $this->widoczna;
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = GiKategoriaPeer::ID;
		}

		return $this;
	} 
	
	public function setUpdatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->updated_at !== null || $dt !== null ) {
			
			$currNorm = ($this->updated_at !== null && $tmpDt = new DateTime($this->updated_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->updated_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GiKategoriaPeer::UPDATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GiKategoriaPeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setKolejnosc($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->kolejnosc !== $v || $v === 0) {
			$this->kolejnosc = $v;
			$this->modifiedColumns[] = GiKategoriaPeer::KOLEJNOSC;
		}

		return $this;
	} 
	
	public function setWidoczna($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->widoczna !== $v || $v === 0) {
			$this->widoczna = $v;
			$this->modifiedColumns[] = GiKategoriaPeer::WIDOCZNA;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(GiKategoriaPeer::KOLEJNOSC,GiKategoriaPeer::WIDOCZNA))) {
				return false;
			}

			if ($this->kolejnosc !== 0) {
				return false;
			}

			if ($this->widoczna !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->updated_at = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->created_at = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->kolejnosc = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->widoczna = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 5; 
		} catch (Exception $e) {
			throw new PropelException("Error populating GiKategoria object", $e);
		}
	}

	
	public function ensureConsistency()
	{

	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiKategoriaPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = GiKategoriaPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->collGiKategoriaI18ns = null;
			$this->lastGiKategoriaI18nCriteria = null;

			$this->collGiSubkategorias = null;
			$this->lastGiSubkategoriaCriteria = null;

		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiKategoriaPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			GiKategoriaPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isModified() && !$this->isColumnModified(GiKategoriaPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

    if ($this->isNew() && !$this->isColumnModified(GiKategoriaPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiKategoriaPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			GiKategoriaPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			if ($this->isNew() ) {
				$this->modifiedColumns[] = GiKategoriaPeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = GiKategoriaPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += GiKategoriaPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			if ($this->collGiKategoriaI18ns !== null) {
				foreach ($this->collGiKategoriaI18ns as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collGiSubkategorias !== null) {
				foreach ($this->collGiSubkategorias as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = GiKategoriaPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collGiKategoriaI18ns !== null) {
					foreach ($this->collGiKategoriaI18ns as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collGiSubkategorias !== null) {
					foreach ($this->collGiSubkategorias as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GiKategoriaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getUpdatedAt();
				break;
			case 2:
				return $this->getCreatedAt();
				break;
			case 3:
				return $this->getKolejnosc();
				break;
			case 4:
				return $this->getWidoczna();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = GiKategoriaPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getUpdatedAt(),
			$keys[2] => $this->getCreatedAt(),
			$keys[3] => $this->getKolejnosc(),
			$keys[4] => $this->getWidoczna(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GiKategoriaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setUpdatedAt($value);
				break;
			case 2:
				$this->setCreatedAt($value);
				break;
			case 3:
				$this->setKolejnosc($value);
				break;
			case 4:
				$this->setWidoczna($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = GiKategoriaPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setUpdatedAt($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setCreatedAt($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setKolejnosc($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setWidoczna($arr[$keys[4]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(GiKategoriaPeer::DATABASE_NAME);

		if ($this->isColumnModified(GiKategoriaPeer::ID)) $criteria->add(GiKategoriaPeer::ID, $this->id);
		if ($this->isColumnModified(GiKategoriaPeer::UPDATED_AT)) $criteria->add(GiKategoriaPeer::UPDATED_AT, $this->updated_at);
		if ($this->isColumnModified(GiKategoriaPeer::CREATED_AT)) $criteria->add(GiKategoriaPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(GiKategoriaPeer::KOLEJNOSC)) $criteria->add(GiKategoriaPeer::KOLEJNOSC, $this->kolejnosc);
		if ($this->isColumnModified(GiKategoriaPeer::WIDOCZNA)) $criteria->add(GiKategoriaPeer::WIDOCZNA, $this->widoczna);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(GiKategoriaPeer::DATABASE_NAME);

		$criteria->add(GiKategoriaPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setUpdatedAt($this->updated_at);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setKolejnosc($this->kolejnosc);

		$copyObj->setWidoczna($this->widoczna);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach ($this->getGiKategoriaI18ns() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addGiKategoriaI18n($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getGiSubkategorias() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addGiSubkategoria($relObj->copy($deepCopy));
				}
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new GiKategoriaPeer();
		}
		return self::$peer;
	}

	
	public function clearGiKategoriaI18ns()
	{
		$this->collGiKategoriaI18ns = null; 	}

	
	public function initGiKategoriaI18ns()
	{
		$this->collGiKategoriaI18ns = array();
	}

	
	public function getGiKategoriaI18ns($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiKategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGiKategoriaI18ns === null) {
			if ($this->isNew()) {
			   $this->collGiKategoriaI18ns = array();
			} else {

				$criteria->add(GiKategoriaI18nPeer::ID, $this->id);

				GiKategoriaI18nPeer::addSelectColumns($criteria);
				$this->collGiKategoriaI18ns = GiKategoriaI18nPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiKategoriaI18nPeer::ID, $this->id);

				GiKategoriaI18nPeer::addSelectColumns($criteria);
				if (!isset($this->lastGiKategoriaI18nCriteria) || !$this->lastGiKategoriaI18nCriteria->equals($criteria)) {
					$this->collGiKategoriaI18ns = GiKategoriaI18nPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGiKategoriaI18nCriteria = $criteria;
		return $this->collGiKategoriaI18ns;
	}

	
	public function countGiKategoriaI18ns(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiKategoriaPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGiKategoriaI18ns === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GiKategoriaI18nPeer::ID, $this->id);

				$count = GiKategoriaI18nPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiKategoriaI18nPeer::ID, $this->id);

				if (!isset($this->lastGiKategoriaI18nCriteria) || !$this->lastGiKategoriaI18nCriteria->equals($criteria)) {
					$count = GiKategoriaI18nPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGiKategoriaI18ns);
				}
			} else {
				$count = count($this->collGiKategoriaI18ns);
			}
		}
		return $count;
	}

	
	public function addGiKategoriaI18n(GiKategoriaI18n $l)
	{
		if ($this->collGiKategoriaI18ns === null) {
			$this->initGiKategoriaI18ns();
		}
		if (!in_array($l, $this->collGiKategoriaI18ns, true)) { 			array_push($this->collGiKategoriaI18ns, $l);
			$l->setGiKategoria($this);
		}
	}

	
	public function clearGiSubkategorias()
	{
		$this->collGiSubkategorias = null; 	}

	
	public function initGiSubkategorias()
	{
		$this->collGiSubkategorias = array();
	}

	
	public function getGiSubkategorias($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiKategoriaPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGiSubkategorias === null) {
			if ($this->isNew()) {
			   $this->collGiSubkategorias = array();
			} else {

				$criteria->add(GiSubkategoriaPeer::KATEGORIA_ID, $this->id);

				GiSubkategoriaPeer::addSelectColumns($criteria);
				$this->collGiSubkategorias = GiSubkategoriaPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiSubkategoriaPeer::KATEGORIA_ID, $this->id);

				GiSubkategoriaPeer::addSelectColumns($criteria);
				if (!isset($this->lastGiSubkategoriaCriteria) || !$this->lastGiSubkategoriaCriteria->equals($criteria)) {
					$this->collGiSubkategorias = GiSubkategoriaPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGiSubkategoriaCriteria = $criteria;
		return $this->collGiSubkategorias;
	}

	
	public function countGiSubkategorias(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiKategoriaPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGiSubkategorias === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GiSubkategoriaPeer::KATEGORIA_ID, $this->id);

				$count = GiSubkategoriaPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiSubkategoriaPeer::KATEGORIA_ID, $this->id);

				if (!isset($this->lastGiSubkategoriaCriteria) || !$this->lastGiSubkategoriaCriteria->equals($criteria)) {
					$count = GiSubkategoriaPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGiSubkategorias);
				}
			} else {
				$count = count($this->collGiSubkategorias);
			}
		}
		return $count;
	}

	
	public function addGiSubkategoria(GiSubkategoria $l)
	{
		if ($this->collGiSubkategorias === null) {
			$this->initGiSubkategorias();
		}
		if (!in_array($l, $this->collGiSubkategorias, true)) { 			array_push($this->collGiSubkategorias, $l);
			$l->setGiKategoria($this);
		}
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collGiKategoriaI18ns) {
				foreach ((array) $this->collGiKategoriaI18ns as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collGiSubkategorias) {
				foreach ((array) $this->collGiSubkategorias as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} 
		$this->collGiKategoriaI18ns = null;
		$this->collGiSubkategorias = null;
	}


  
  public function getCulture()
  {
    return $this->culture;
  }

  
  public function setCulture($culture)
  {
    $this->culture = $culture;
  }

  public function getNazwa($culture = null)
  {
    return $this->getCurrentGiKategoriaI18n($culture)->getNazwa();
  }

  public function setNazwa($value, $culture = null)
  {
    $this->getCurrentGiKategoriaI18n($culture)->setNazwa($value);
  }

  protected $current_i18n = array();

  public function getCurrentGiKategoriaI18n($culture = null)
  {
    if (is_null($culture))
    {
      $culture = is_null($this->culture) ? sfPropel::getDefaultCulture() : $this->culture;
    }

    if (!isset($this->current_i18n[$culture]))
    {
      $obj = $this->isNew() ? null : GiKategoriaI18nPeer::retrieveByPK($this->getId(), $culture);
      if ($obj)
      {
        $this->setGiKategoriaI18nForCulture($obj, $culture);
      }
      else
      {
        $this->setGiKategoriaI18nForCulture(new GiKategoriaI18n(), $culture);
        $this->current_i18n[$culture]->setCulture($culture);
      }
    }

    return $this->current_i18n[$culture];
  }

  public function setGiKategoriaI18nForCulture($object, $culture)
  {
    $this->current_i18n[$culture] = $object;
    $this->addGiKategoriaI18n($object);
  }

} 