<?php


abstract class BaseGiObraz extends BaseObject  implements Persistent {


  const PEER = 'GiObrazPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $created_at;

	
	protected $updated_at;

	
	protected $nazwa_pliku;

	
	protected $tytul;

	
	protected $kolejnosc;

	
	protected $galeria_id;

	
	protected $exif_data;

	
	protected $aGaleriaI;

	
	protected $collGaleriaIs;

	
	private $lastGaleriaICriteria = null;

	
	protected $collGiObrazI18ns;

	
	private $lastGiObrazI18nCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

  
  protected $culture;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->nazwa_pliku = '';
		$this->tytul = '';
		$this->kolejnosc = 0;
		$this->galeria_id = 0;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->updated_at === null) {
			return null;
		}


		if ($this->updated_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->updated_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->updated_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getNazwaPliku()
	{
		return $this->nazwa_pliku;
	}

	
	public function getTytul()
	{
		return $this->tytul;
	}

	
	public function getKolejnosc()
	{
		return $this->kolejnosc;
	}

	
	public function getGaleriaId()
	{
		return $this->galeria_id;
	}

	
	public function getExifData($format = 'Y-m-d H:i:s')
	{
		if ($this->exif_data === null) {
			return null;
		}


		if ($this->exif_data === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->exif_data);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->exif_data, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = GiObrazPeer::ID;
		}

		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GiObrazPeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setUpdatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->updated_at !== null || $dt !== null ) {
			
			$currNorm = ($this->updated_at !== null && $tmpDt = new DateTime($this->updated_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->updated_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GiObrazPeer::UPDATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setNazwaPliku($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->nazwa_pliku !== $v || $v === '') {
			$this->nazwa_pliku = $v;
			$this->modifiedColumns[] = GiObrazPeer::NAZWA_PLIKU;
		}

		return $this;
	} 
	
	public function setTytul($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->tytul !== $v || $v === '') {
			$this->tytul = $v;
			$this->modifiedColumns[] = GiObrazPeer::TYTUL;
		}

		return $this;
	} 
	
	public function setKolejnosc($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->kolejnosc !== $v || $v === 0) {
			$this->kolejnosc = $v;
			$this->modifiedColumns[] = GiObrazPeer::KOLEJNOSC;
		}

		return $this;
	} 
	
	public function setGaleriaId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->galeria_id !== $v || $v === 0) {
			$this->galeria_id = $v;
			$this->modifiedColumns[] = GiObrazPeer::GALERIA_ID;
		}

		if ($this->aGaleriaI !== null && $this->aGaleriaI->getId() !== $v) {
			$this->aGaleriaI = null;
		}

		return $this;
	} 
	
	public function setExifData($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->exif_data !== null || $dt !== null ) {
			
			$currNorm = ($this->exif_data !== null && $tmpDt = new DateTime($this->exif_data)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->exif_data = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GiObrazPeer::EXIF_DATA;
			}
		} 
		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(GiObrazPeer::NAZWA_PLIKU,GiObrazPeer::TYTUL,GiObrazPeer::KOLEJNOSC,GiObrazPeer::GALERIA_ID))) {
				return false;
			}

			if ($this->nazwa_pliku !== '') {
				return false;
			}

			if ($this->tytul !== '') {
				return false;
			}

			if ($this->kolejnosc !== 0) {
				return false;
			}

			if ($this->galeria_id !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->created_at = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->updated_at = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->nazwa_pliku = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->tytul = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->kolejnosc = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
			$this->galeria_id = ($row[$startcol + 6] !== null) ? (int) $row[$startcol + 6] : null;
			$this->exif_data = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 8; 
		} catch (Exception $e) {
			throw new PropelException("Error populating GiObraz object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aGaleriaI !== null && $this->galeria_id !== $this->aGaleriaI->getId()) {
			$this->aGaleriaI = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiObrazPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = GiObrazPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aGaleriaI = null;
			$this->collGaleriaIs = null;
			$this->lastGaleriaICriteria = null;

			$this->collGiObrazI18ns = null;
			$this->lastGiObrazI18nCriteria = null;

		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiObrazPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			GiObrazPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isNew() && !$this->isColumnModified(GiObrazPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

    if ($this->isModified() && !$this->isColumnModified(GiObrazPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiObrazPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			GiObrazPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aGaleriaI !== null) {
				if ($this->aGaleriaI->isModified() || ($this->aGaleriaI->getCulture() && $this->aGaleriaI->getCurrentGaleriaII18n()->isModified()) || $this->aGaleriaI->isNew()) {
					$affectedRows += $this->aGaleriaI->save($con);
				}
				$this->setGaleriaI($this->aGaleriaI);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = GiObrazPeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = GiObrazPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += GiObrazPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			if ($this->collGaleriaIs !== null) {
				foreach ($this->collGaleriaIs as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collGiObrazI18ns !== null) {
				foreach ($this->collGiObrazI18ns as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aGaleriaI !== null) {
				if (!$this->aGaleriaI->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aGaleriaI->getValidationFailures());
				}
			}


			if (($retval = GiObrazPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collGaleriaIs !== null) {
					foreach ($this->collGaleriaIs as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collGiObrazI18ns !== null) {
					foreach ($this->collGiObrazI18ns as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GiObrazPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getCreatedAt();
				break;
			case 2:
				return $this->getUpdatedAt();
				break;
			case 3:
				return $this->getNazwaPliku();
				break;
			case 4:
				return $this->getTytul();
				break;
			case 5:
				return $this->getKolejnosc();
				break;
			case 6:
				return $this->getGaleriaId();
				break;
			case 7:
				return $this->getExifData();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = GiObrazPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getCreatedAt(),
			$keys[2] => $this->getUpdatedAt(),
			$keys[3] => $this->getNazwaPliku(),
			$keys[4] => $this->getTytul(),
			$keys[5] => $this->getKolejnosc(),
			$keys[6] => $this->getGaleriaId(),
			$keys[7] => $this->getExifData(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GiObrazPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setCreatedAt($value);
				break;
			case 2:
				$this->setUpdatedAt($value);
				break;
			case 3:
				$this->setNazwaPliku($value);
				break;
			case 4:
				$this->setTytul($value);
				break;
			case 5:
				$this->setKolejnosc($value);
				break;
			case 6:
				$this->setGaleriaId($value);
				break;
			case 7:
				$this->setExifData($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = GiObrazPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setCreatedAt($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setUpdatedAt($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setNazwaPliku($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setTytul($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setKolejnosc($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setGaleriaId($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setExifData($arr[$keys[7]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(GiObrazPeer::DATABASE_NAME);

		if ($this->isColumnModified(GiObrazPeer::ID)) $criteria->add(GiObrazPeer::ID, $this->id);
		if ($this->isColumnModified(GiObrazPeer::CREATED_AT)) $criteria->add(GiObrazPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(GiObrazPeer::UPDATED_AT)) $criteria->add(GiObrazPeer::UPDATED_AT, $this->updated_at);
		if ($this->isColumnModified(GiObrazPeer::NAZWA_PLIKU)) $criteria->add(GiObrazPeer::NAZWA_PLIKU, $this->nazwa_pliku);
		if ($this->isColumnModified(GiObrazPeer::TYTUL)) $criteria->add(GiObrazPeer::TYTUL, $this->tytul);
		if ($this->isColumnModified(GiObrazPeer::KOLEJNOSC)) $criteria->add(GiObrazPeer::KOLEJNOSC, $this->kolejnosc);
		if ($this->isColumnModified(GiObrazPeer::GALERIA_ID)) $criteria->add(GiObrazPeer::GALERIA_ID, $this->galeria_id);
		if ($this->isColumnModified(GiObrazPeer::EXIF_DATA)) $criteria->add(GiObrazPeer::EXIF_DATA, $this->exif_data);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(GiObrazPeer::DATABASE_NAME);

		$criteria->add(GiObrazPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setUpdatedAt($this->updated_at);

		$copyObj->setNazwaPliku($this->nazwa_pliku);

		$copyObj->setTytul($this->tytul);

		$copyObj->setKolejnosc($this->kolejnosc);

		$copyObj->setGaleriaId($this->galeria_id);

		$copyObj->setExifData($this->exif_data);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach ($this->getGaleriaIs() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addGaleriaI($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getGiObrazI18ns() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addGiObrazI18n($relObj->copy($deepCopy));
				}
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new GiObrazPeer();
		}
		return self::$peer;
	}

	
	public function setGaleriaI(GaleriaI $v = null)
	{
		if ($v === null) {
			$this->setGaleriaId(0);
		} else {
			$this->setGaleriaId($v->getId());
		}

		$this->aGaleriaI = $v;

						if ($v !== null) {
			$v->addGiObraz($this);
		}

		return $this;
	}


	
	public function getGaleriaI(PropelPDO $con = null)
	{
		if ($this->aGaleriaI === null && ($this->galeria_id !== null)) {
			$c = new Criteria(GaleriaIPeer::DATABASE_NAME);
			$c->add(GaleriaIPeer::ID, $this->galeria_id);
			$this->aGaleriaI = GaleriaIPeer::doSelectOne($c, $con);
			
		}
		return $this->aGaleriaI;
	}

	
	public function clearGaleriaIs()
	{
		$this->collGaleriaIs = null; 	}

	
	public function initGaleriaIs()
	{
		$this->collGaleriaIs = array();
	}

	
	public function getGaleriaIs($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiObrazPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIs === null) {
			if ($this->isNew()) {
			   $this->collGaleriaIs = array();
			} else {

				$criteria->add(GaleriaIPeer::OBRAZ_ID, $this->id);

				GaleriaIPeer::addSelectColumns($criteria);
				$this->collGaleriaIs = GaleriaIPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GaleriaIPeer::OBRAZ_ID, $this->id);

				GaleriaIPeer::addSelectColumns($criteria);
				if (!isset($this->lastGaleriaICriteria) || !$this->lastGaleriaICriteria->equals($criteria)) {
					$this->collGaleriaIs = GaleriaIPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGaleriaICriteria = $criteria;
		return $this->collGaleriaIs;
	}

	
	public function countGaleriaIs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiObrazPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGaleriaIs === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GaleriaIPeer::OBRAZ_ID, $this->id);

				$count = GaleriaIPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GaleriaIPeer::OBRAZ_ID, $this->id);

				if (!isset($this->lastGaleriaICriteria) || !$this->lastGaleriaICriteria->equals($criteria)) {
					$count = GaleriaIPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGaleriaIs);
				}
			} else {
				$count = count($this->collGaleriaIs);
			}
		}
		return $count;
	}

	
	public function addGaleriaI(GaleriaI $l)
	{
		if ($this->collGaleriaIs === null) {
			$this->initGaleriaIs();
		}
		if (!in_array($l, $this->collGaleriaIs, true)) { 			array_push($this->collGaleriaIs, $l);
			$l->setGiObraz($this);
		}
	}


	
	public function getGaleriaIsJoinsfGuardUser($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiObrazPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIs === null) {
			if ($this->isNew()) {
				$this->collGaleriaIs = array();
			} else {

				$criteria->add(GaleriaIPeer::OBRAZ_ID, $this->id);

				$this->collGaleriaIs = GaleriaIPeer::doSelectJoinsfGuardUser($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(GaleriaIPeer::OBRAZ_ID, $this->id);

			if (!isset($this->lastGaleriaICriteria) || !$this->lastGaleriaICriteria->equals($criteria)) {
				$this->collGaleriaIs = GaleriaIPeer::doSelectJoinsfGuardUser($criteria, $con, $join_behavior);
			}
		}
		$this->lastGaleriaICriteria = $criteria;

		return $this->collGaleriaIs;
	}


	
	public function getGaleriaIsJoinGiSubkategoria($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiObrazPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGaleriaIs === null) {
			if ($this->isNew()) {
				$this->collGaleriaIs = array();
			} else {

				$criteria->add(GaleriaIPeer::OBRAZ_ID, $this->id);

				$this->collGaleriaIs = GaleriaIPeer::doSelectJoinGiSubkategoria($criteria, $con, $join_behavior);
			}
		} else {
									
			$criteria->add(GaleriaIPeer::OBRAZ_ID, $this->id);

			if (!isset($this->lastGaleriaICriteria) || !$this->lastGaleriaICriteria->equals($criteria)) {
				$this->collGaleriaIs = GaleriaIPeer::doSelectJoinGiSubkategoria($criteria, $con, $join_behavior);
			}
		}
		$this->lastGaleriaICriteria = $criteria;

		return $this->collGaleriaIs;
	}

	
	public function clearGiObrazI18ns()
	{
		$this->collGiObrazI18ns = null; 	}

	
	public function initGiObrazI18ns()
	{
		$this->collGiObrazI18ns = array();
	}

	
	public function getGiObrazI18ns($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiObrazPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collGiObrazI18ns === null) {
			if ($this->isNew()) {
			   $this->collGiObrazI18ns = array();
			} else {

				$criteria->add(GiObrazI18nPeer::ID, $this->id);

				GiObrazI18nPeer::addSelectColumns($criteria);
				$this->collGiObrazI18ns = GiObrazI18nPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiObrazI18nPeer::ID, $this->id);

				GiObrazI18nPeer::addSelectColumns($criteria);
				if (!isset($this->lastGiObrazI18nCriteria) || !$this->lastGiObrazI18nCriteria->equals($criteria)) {
					$this->collGiObrazI18ns = GiObrazI18nPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastGiObrazI18nCriteria = $criteria;
		return $this->collGiObrazI18ns;
	}

	
	public function countGiObrazI18ns(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(GiObrazPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collGiObrazI18ns === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(GiObrazI18nPeer::ID, $this->id);

				$count = GiObrazI18nPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(GiObrazI18nPeer::ID, $this->id);

				if (!isset($this->lastGiObrazI18nCriteria) || !$this->lastGiObrazI18nCriteria->equals($criteria)) {
					$count = GiObrazI18nPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collGiObrazI18ns);
				}
			} else {
				$count = count($this->collGiObrazI18ns);
			}
		}
		return $count;
	}

	
	public function addGiObrazI18n(GiObrazI18n $l)
	{
		if ($this->collGiObrazI18ns === null) {
			$this->initGiObrazI18ns();
		}
		if (!in_array($l, $this->collGiObrazI18ns, true)) { 			array_push($this->collGiObrazI18ns, $l);
			$l->setGiObraz($this);
		}
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collGaleriaIs) {
				foreach ((array) $this->collGaleriaIs as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collGiObrazI18ns) {
				foreach ((array) $this->collGiObrazI18ns as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} 
		$this->collGaleriaIs = null;
		$this->collGiObrazI18ns = null;
			$this->aGaleriaI = null;
	}


  
  public function getCulture()
  {
    return $this->culture;
  }

  
  public function setCulture($culture)
  {
    $this->culture = $culture;
  }

  public function getNazwa($culture = null)
  {
    return $this->getCurrentGiObrazI18n($culture)->getNazwa();
  }

  public function setNazwa($value, $culture = null)
  {
    $this->getCurrentGiObrazI18n($culture)->setNazwa($value);
  }

  public function getOpis($culture = null)
  {
    return $this->getCurrentGiObrazI18n($culture)->getOpis();
  }

  public function setOpis($value, $culture = null)
  {
    $this->getCurrentGiObrazI18n($culture)->setOpis($value);
  }

  protected $current_i18n = array();

  public function getCurrentGiObrazI18n($culture = null)
  {
    if (is_null($culture))
    {
      $culture = is_null($this->culture) ? sfPropel::getDefaultCulture() : $this->culture;
    }

    if (!isset($this->current_i18n[$culture]))
    {
      $obj = $this->isNew() ? null : GiObrazI18nPeer::retrieveByPK($this->getId(), $culture);
      if ($obj)
      {
        $this->setGiObrazI18nForCulture($obj, $culture);
      }
      else
      {
        $this->setGiObrazI18nForCulture(new GiObrazI18n(), $culture);
        $this->current_i18n[$culture]->setCulture($culture);
      }
    }

    return $this->current_i18n[$culture];
  }

  public function setGiObrazI18nForCulture($object, $culture)
  {
    $this->current_i18n[$culture] = $object;
    $this->addGiObrazI18n($object);
  }

} 