<?php


abstract class BaseGiObrazPubI18n extends BaseObject  implements Persistent {


  const PEER = 'GiObrazPubI18nPeer';

	
	protected static $peer;

	
	protected $nazwa;

	
	protected $opis;

	
	protected $id;

	
	protected $culture;

	
	protected $aGiObrazPub;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
	}

	
	public function getNazwa()
	{
		return $this->nazwa;
	}

	
	public function getOpis()
	{
		return $this->opis;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getCulture()
	{
		return $this->culture;
	}

	
	public function setNazwa($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->nazwa !== $v) {
			$this->nazwa = $v;
			$this->modifiedColumns[] = GiObrazPubI18nPeer::NAZWA;
		}

		return $this;
	} 
	
	public function setOpis($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->opis !== $v) {
			$this->opis = $v;
			$this->modifiedColumns[] = GiObrazPubI18nPeer::OPIS;
		}

		return $this;
	} 
	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = GiObrazPubI18nPeer::ID;
		}

		if ($this->aGiObrazPub !== null && $this->aGiObrazPub->getId() !== $v) {
			$this->aGiObrazPub = null;
		}

		return $this;
	} 
	
	public function setCulture($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->culture !== $v) {
			$this->culture = $v;
			$this->modifiedColumns[] = GiObrazPubI18nPeer::CULTURE;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array())) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->nazwa = ($row[$startcol + 0] !== null) ? (string) $row[$startcol + 0] : null;
			$this->opis = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->id = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
			$this->culture = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating GiObrazPubI18n object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aGiObrazPub !== null && $this->id !== $this->aGiObrazPub->getId()) {
			$this->aGiObrazPub = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiObrazPubI18nPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = GiObrazPubI18nPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aGiObrazPub = null;
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiObrazPubI18nPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			GiObrazPubI18nPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiObrazPubI18nPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			GiObrazPubI18nPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aGiObrazPub !== null) {
				if ($this->aGiObrazPub->isModified() || ($this->aGiObrazPub->getCulture() && $this->aGiObrazPub->getCurrentGiObrazPubI18n()->isModified()) || $this->aGiObrazPub->isNew()) {
					$affectedRows += $this->aGiObrazPub->save($con);
				}
				$this->setGiObrazPub($this->aGiObrazPub);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = GiObrazPubI18nPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += GiObrazPubI18nPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aGiObrazPub !== null) {
				if (!$this->aGiObrazPub->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aGiObrazPub->getValidationFailures());
				}
			}


			if (($retval = GiObrazPubI18nPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GiObrazPubI18nPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getNazwa();
				break;
			case 1:
				return $this->getOpis();
				break;
			case 2:
				return $this->getId();
				break;
			case 3:
				return $this->getCulture();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = GiObrazPubI18nPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getNazwa(),
			$keys[1] => $this->getOpis(),
			$keys[2] => $this->getId(),
			$keys[3] => $this->getCulture(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GiObrazPubI18nPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setNazwa($value);
				break;
			case 1:
				$this->setOpis($value);
				break;
			case 2:
				$this->setId($value);
				break;
			case 3:
				$this->setCulture($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = GiObrazPubI18nPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setNazwa($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setOpis($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setCulture($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(GiObrazPubI18nPeer::DATABASE_NAME);

		if ($this->isColumnModified(GiObrazPubI18nPeer::NAZWA)) $criteria->add(GiObrazPubI18nPeer::NAZWA, $this->nazwa);
		if ($this->isColumnModified(GiObrazPubI18nPeer::OPIS)) $criteria->add(GiObrazPubI18nPeer::OPIS, $this->opis);
		if ($this->isColumnModified(GiObrazPubI18nPeer::ID)) $criteria->add(GiObrazPubI18nPeer::ID, $this->id);
		if ($this->isColumnModified(GiObrazPubI18nPeer::CULTURE)) $criteria->add(GiObrazPubI18nPeer::CULTURE, $this->culture);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(GiObrazPubI18nPeer::DATABASE_NAME);

		$criteria->add(GiObrazPubI18nPeer::ID, $this->id);
		$criteria->add(GiObrazPubI18nPeer::CULTURE, $this->culture);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getId();

		$pks[1] = $this->getCulture();

		return $pks;
	}

	
	public function setPrimaryKey($keys)
	{

		$this->setId($keys[0]);

		$this->setCulture($keys[1]);

	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNazwa($this->nazwa);

		$copyObj->setOpis($this->opis);

		$copyObj->setId($this->id);

		$copyObj->setCulture($this->culture);


		$copyObj->setNew(true);

	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new GiObrazPubI18nPeer();
		}
		return self::$peer;
	}

	
	public function setGiObrazPub(GiObrazPub $v = null)
	{
		if ($v === null) {
			$this->setId(NULL);
		} else {
			$this->setId($v->getId());
		}

		$this->aGiObrazPub = $v;

						if ($v !== null) {
			$v->addGiObrazPubI18n($this);
		}

		return $this;
	}


	
	public function getGiObrazPub(PropelPDO $con = null)
	{
		if ($this->aGiObrazPub === null && ($this->id !== null)) {
			$c = new Criteria(GiObrazPubPeer::DATABASE_NAME);
			$c->add(GiObrazPubPeer::ID, $this->id);
			$this->aGiObrazPub = GiObrazPubPeer::doSelectOne($c, $con);
			
		}
		return $this->aGiObrazPub;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
			$this->aGiObrazPub = null;
	}

} 