<?php


abstract class BaseGiRank extends BaseObject  implements Persistent {


  const PEER = 'GiRankPeer';

	
	protected static $peer;

	
	protected $galeria_id;

	
	protected $updated_at;

	
	protected $created_at;

	
	protected $rank;

	
	protected $voters;

	
	protected $views;

	
	protected $aGaleriaIPub;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->rank = 0;
		$this->voters = 0;
		$this->views = 0;
	}

	
	public function getGaleriaId()
	{
		return $this->galeria_id;
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->updated_at === null) {
			return null;
		}


		if ($this->updated_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->updated_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->updated_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getRank()
	{
		return $this->rank;
	}

	
	public function getVoters()
	{
		return $this->voters;
	}

	
	public function getViews()
	{
		return $this->views;
	}

	
	public function setGaleriaId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->galeria_id !== $v) {
			$this->galeria_id = $v;
			$this->modifiedColumns[] = GiRankPeer::GALERIA_ID;
		}

		if ($this->aGaleriaIPub !== null && $this->aGaleriaIPub->getId() !== $v) {
			$this->aGaleriaIPub = null;
		}

		return $this;
	} 
	
	public function setUpdatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->updated_at !== null || $dt !== null ) {
			
			$currNorm = ($this->updated_at !== null && $tmpDt = new DateTime($this->updated_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->updated_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GiRankPeer::UPDATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = GiRankPeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setRank($v)
	{
		if ($v !== null) {
			$v = (double) $v;
		}

		if ($this->rank !== $v || $v === 0) {
			$this->rank = $v;
			$this->modifiedColumns[] = GiRankPeer::RANK;
		}

		return $this;
	} 
	
	public function setVoters($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->voters !== $v || $v === 0) {
			$this->voters = $v;
			$this->modifiedColumns[] = GiRankPeer::VOTERS;
		}

		return $this;
	} 
	
	public function setViews($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->views !== $v || $v === 0) {
			$this->views = $v;
			$this->modifiedColumns[] = GiRankPeer::VIEWS;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(GiRankPeer::RANK,GiRankPeer::VOTERS,GiRankPeer::VIEWS))) {
				return false;
			}

			if ($this->rank !== 0) {
				return false;
			}

			if ($this->voters !== 0) {
				return false;
			}

			if ($this->views !== 0) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->galeria_id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->updated_at = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->created_at = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->rank = ($row[$startcol + 3] !== null) ? (double) $row[$startcol + 3] : null;
			$this->voters = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->views = ($row[$startcol + 5] !== null) ? (int) $row[$startcol + 5] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 6; 
		} catch (Exception $e) {
			throw new PropelException("Error populating GiRank object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aGaleriaIPub !== null && $this->galeria_id !== $this->aGaleriaIPub->getId()) {
			$this->aGaleriaIPub = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiRankPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = GiRankPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aGaleriaIPub = null;
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiRankPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			GiRankPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isModified() && !$this->isColumnModified(GiRankPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

    if ($this->isNew() && !$this->isColumnModified(GiRankPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(GiRankPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			GiRankPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aGaleriaIPub !== null) {
				if ($this->aGaleriaIPub->isModified() || ($this->aGaleriaIPub->getCulture() && $this->aGaleriaIPub->getCurrentGaleriaIPubI18n()->isModified()) || $this->aGaleriaIPub->isNew()) {
					$affectedRows += $this->aGaleriaIPub->save($con);
				}
				$this->setGaleriaIPub($this->aGaleriaIPub);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = GiRankPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += GiRankPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aGaleriaIPub !== null) {
				if (!$this->aGaleriaIPub->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aGaleriaIPub->getValidationFailures());
				}
			}


			if (($retval = GiRankPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GiRankPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getGaleriaId();
				break;
			case 1:
				return $this->getUpdatedAt();
				break;
			case 2:
				return $this->getCreatedAt();
				break;
			case 3:
				return $this->getRank();
				break;
			case 4:
				return $this->getVoters();
				break;
			case 5:
				return $this->getViews();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = GiRankPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getGaleriaId(),
			$keys[1] => $this->getUpdatedAt(),
			$keys[2] => $this->getCreatedAt(),
			$keys[3] => $this->getRank(),
			$keys[4] => $this->getVoters(),
			$keys[5] => $this->getViews(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = GiRankPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setGaleriaId($value);
				break;
			case 1:
				$this->setUpdatedAt($value);
				break;
			case 2:
				$this->setCreatedAt($value);
				break;
			case 3:
				$this->setRank($value);
				break;
			case 4:
				$this->setVoters($value);
				break;
			case 5:
				$this->setViews($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = GiRankPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setGaleriaId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setUpdatedAt($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setCreatedAt($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setRank($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setVoters($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setViews($arr[$keys[5]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(GiRankPeer::DATABASE_NAME);

		if ($this->isColumnModified(GiRankPeer::GALERIA_ID)) $criteria->add(GiRankPeer::GALERIA_ID, $this->galeria_id);
		if ($this->isColumnModified(GiRankPeer::UPDATED_AT)) $criteria->add(GiRankPeer::UPDATED_AT, $this->updated_at);
		if ($this->isColumnModified(GiRankPeer::CREATED_AT)) $criteria->add(GiRankPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(GiRankPeer::RANK)) $criteria->add(GiRankPeer::RANK, $this->rank);
		if ($this->isColumnModified(GiRankPeer::VOTERS)) $criteria->add(GiRankPeer::VOTERS, $this->voters);
		if ($this->isColumnModified(GiRankPeer::VIEWS)) $criteria->add(GiRankPeer::VIEWS, $this->views);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(GiRankPeer::DATABASE_NAME);

		$criteria->add(GiRankPeer::GALERIA_ID, $this->galeria_id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getGaleriaId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setGaleriaId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setGaleriaId($this->galeria_id);

		$copyObj->setUpdatedAt($this->updated_at);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setRank($this->rank);

		$copyObj->setVoters($this->voters);

		$copyObj->setViews($this->views);


		$copyObj->setNew(true);

	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new GiRankPeer();
		}
		return self::$peer;
	}

	
	public function setGaleriaIPub(GaleriaIPub $v = null)
	{
		if ($v === null) {
			$this->setGaleriaId(NULL);
		} else {
			$this->setGaleriaId($v->getId());
		}

		$this->aGaleriaIPub = $v;

				if ($v !== null) {
			$v->setGiRank($this);
		}

		return $this;
	}


	
	public function getGaleriaIPub(PropelPDO $con = null)
	{
		if ($this->aGaleriaIPub === null && ($this->galeria_id !== null)) {
			$c = new Criteria(GaleriaIPubPeer::DATABASE_NAME);
			$c->add(GaleriaIPubPeer::ID, $this->galeria_id);
			$this->aGaleriaIPub = GaleriaIPubPeer::doSelectOne($c, $con);
						$this->aGaleriaIPub->setGiRank($this);
		}
		return $this->aGaleriaIPub;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
			$this->aGaleriaIPub = null;
	}

} 